//---------------------------------------------------------------------------
//
//	OEaEt^I
//
//---------------------------------------------------------------------------
#include <nitro.h>
#include "bds_lib.h"
#include "pack_data.h"
#include "game.h"
#include "prime4.h"
#include "entry.h"
#include "sound_data.h"

// -------------------------------------
// 萔`
// -------------------------------------
#define ENTRY_MODE_INIT					0		// 
#define ENTRY_MODE_NAME_WAIT			1		// 
#define ENTRY_MODE_NAME_MAIN			2		// O
#define ENTRY_MODE_NAME_TO_DAUGHTER		3		// 
#define ENTRY_MODE_DAUGHTER_MAIN		4		// aEt^̓
#define ENTRY_MODE_DAUGHTER_TO_NAME		5		// 
#define ENTRY_MODE_DAUGHTER_TO_FATHER	6		// 
#define ENTRY_MODE_FATHER_MAIN			7		// NEa̓
#define ENTRY_MODE_FATHER_TO_DAUGHTER	8		// 
#define ENTRY_MODE_TO_DIALOG			9		// _CAOɈڍs
#define ENTRY_MODE_DIALOG_MAIN			10		// _CAO
#define ENTRY_MODE_DIALOG_DECIDE		11		// _CAO
#define ENTRY_MODE_FROM_DIALOG			12		// _CAO߂
#define ENTRY_MODE_DIALOG_WAIT			13		// _CAO_CAO
#define ENTRY_MODE_END					14		// I

#define ENTRY_DIALOG_TITLE			0		// ^Cgɖ߂܂H
#define ENTRY_DIALOG_SKIP			1		// [r[XLbv
#define ENTRY_DIALOG_CONFIRM		2		// łł

// -------------------------------------
// NXE\̒`
// -------------------------------------
// -------------------------------------
// [Jϐ`
// -------------------------------------
static u8
	g_step,
	g_count,
	g_dialog_count,
	g_movie_count,
	g_movie_mode,
	g_kana_mode,
	g_cursor_count,
	g_cursor_num,
	g_cursor_pal,
	g_cursor_wait,
	g_father_name[12],
	g_daughter_name[12],
	g_father_birth[12],
	g_daughter_birth[12],
	g_daughter_blood[4],
	g_father_age[4],
	g_father_name_len,
	g_daughter_name_len,
	g_blood,
	g_birth_y,
	g_birth_m,
	g_birth_d,
	g_fbirth_y,
	g_fbirth_m,
	g_fbirth_d,
	g_now_y,
	g_tp_repeat,
	g_tp_count,
	g_key_input,
	g_key_mode,
	g_key_select,
	g_name_mode,
	g_name_move[6],
	g_name_input,
	g_name_wait,
	g_name_count,
	*g_hiragana,
	*g_katakana,
	g_dialog_decide,
	g_dialog_num,
	g_next_mode;
static s16
	g_wait,
	g_dialog_wait,
	g_u_wait,
	g_name_x[6],
	g_dialog_select,
	g_blood_select,
	g_days_select,
	g_next_select;

static u8
	g_underbar[2] = { "Q" },
	g_birth[6] = { "@" },
	g_suuji[20] = { "OPQRSTUVWX" },
	g_blood_str[16] = { "`@a@n@`a" };

static OamData
	g_white_wall_oam[] =
	{
		{    0,0,1,0,0,0,   0,0,0,0,3,   0,0, 0,0 },
		{    0,0,1,0,0,0,  64,0,0,0,3,   0,0, 0,0 },
		{    0,0,1,0,0,0, 128,0,0,0,3,   0,0, 0,0 },
		{    0,0,1,0,0,0, 192,0,0,0,3,   0,0, 0,0 },
		{   64,0,1,0,0,0,   0,0,0,0,3,   0,0, 0,0 },
		{   64,0,1,0,0,0,  64,0,0,0,3,   0,0, 0,0 },
		{   64,0,1,0,0,0, 128,0,0,0,3,   0,0, 0,0 },
		{   64,0,1,0,0,0, 192,0,0,0,3,   0,0, 0,0 },
		{  128,0,1,0,0,0,   0,0,0,0,3,   0,0, 0,0 },
		{  128,0,1,0,0,0,  64,0,0,0,3,   0,0, 0,0 },
		{  128,0,1,0,0,0, 128,0,0,0,3,   0,0, 0,0 },
		{  128,0,1,0,0,0, 192,0,0,0,3,   0,0, 0,0 },
	},
	g_black_wall_oam[] =
	{
		{    0,0,1,0,0,0,   0,0,0,0,3,   0,0, 1,0 },
		{    0,0,1,0,0,0,  64,0,0,0,3,   0,0, 1,0 },
		{    0,0,1,0,0,0, 128,0,0,0,3,   0,0, 1,0 },
		{    0,0,1,0,0,0, 192,0,0,0,3,   0,0, 1,0 },
		{   64,0,1,0,0,0,   0,0,0,0,3,   0,0, 1,0 },
		{   64,0,1,0,0,0,  64,0,0,0,3,   0,0, 1,0 },
		{   64,0,1,0,0,0, 128,0,0,0,3,   0,0, 1,0 },
		{   64,0,1,0,0,0, 192,0,0,0,3,   0,0, 1,0 },
		{  128,0,1,0,0,0,   0,0,0,0,3,   0,0, 1,0 },
		{  128,0,1,0,0,0,  64,0,0,0,3,   0,0, 1,0 },
		{  128,0,1,0,0,0, 128,0,0,0,3,   0,0, 1,0 },
		{  128,0,1,0,0,0, 192,0,0,0,3,   0,0, 1,0 },
	},
	g_entry_1_oam[] =
	{
		// [Ȃ̖ĉ]
		{    7,0,0,0,0,1,  40,0,0,0,2, 116,2, 1,0 },
		{    7,0,0,0,0,1,  72,0,0,0,2, 124,2, 1,0 },
		{    7,0,0,0,0,1, 104,0,0,0,2, 132,2, 1,0 },
		{    7,0,0,0,0,1, 136,0,0,0,2, 140,2, 1,0 },
		{    7,0,0,0,0,1, 168,0,0,0,2, 148,2, 1,0 },
		{    7,0,0,0,0,0, 200,0,0,0,1, 156,2, 1,0 },
	},
	g_entry_2_oam[] =
	{
		// [̖Oĉ]
		{    7,0,0,0,0,1,  48,0,0,0,2, 160,2, 1,0 },
		{    7,0,0,0,0,1,  80,0,0,0,2, 168,2, 1,0 },
		{    7,0,0,0,0,1, 112,0,0,0,2, 176,2, 1,0 },
		{    7,0,0,0,0,1, 144,0,0,0,2, 184,2, 1,0 },
		{    7,0,0,0,0,1, 176,0,0,0,2, 192,2, 1,0 },
	},
	g_cursor_1_oam[] =
	{
		// [J[\]
		{    0,0,0,0,0,1,   0,0,0,0,2, 100,2, 0,0 },
		{    0,0,0,0,0,0,  32,0,0,0,1, 108,2, 0,0 },
	},
	g_cursor_2_oam[] =
	{
		// [ႢJ[\]
		{    0,0,0,0,0,0,   0,0,0,0,1, 112,2, 0,0 },
	},
	g_dialog_yes_oam[] =
	{
		// [͂]
		{   86,0,0,0,0,1,  49,0,0,0,3, 704,0, 10,0 },
	},
	g_dialog_no_oam[] =
	{
		// []
		{   86,0,0,0,0,1, 131,0,0,0,3, 736,0, 10,0 },
	},
	g_selecter_1a_oam[] =
	{
		// [ݒ㉺] 
		// 
		{   34,0,0,0,0,1, 128,0,0,0,0,  80,1, 5,0 },
		{   62,0,0,0,0,1, 128,0,0,0,0,  82,1, 5,0 },
		// 
		{   34,0,0,0,0,1, 176,0,0,0,0,  80,1, 5,0 },
		{   62,0,0,0,0,1, 176,0,0,0,0,  82,1, 5,0 },
	},
	g_selecter_1b_oam[] =
	{
		// [ݒ㉺] 
		// 
		{   34,0,0,0,0,1, 128,0,0,0,0,  84,1, 5,0 },
		{   62,0,0,0,0,1, 128,0,0,0,0,  86,1, 5,0 },
		// 
		{   34,0,0,0,0,1, 176,0,0,0,0,  84,1, 5,0 },
		{   62,0,0,0,0,1, 176,0,0,0,0,  86,1, 5,0 },
	},
	g_selecter_1c_oam[] =
	{
		// [ݒ茌t^J[\] 52,96 92,96 132,96 172,96
		{    0,0,0,0,0,1,   0,0,0,0,1,  88,1, 5,0 },
		{   24,0,0,0,0,1,   0,0,0,0,1,  92,1, 5,0 },
		{    8,0,0,0,0,2,   0,0,0,0,0,  96,1, 5,0 },
		{    8,0,0,0,0,2,  24,0,0,0,0,  98,1, 5,0 },
	},
	g_selecter_2a_oam[] =
	{
		// [ݒ㉺] 
		// 10
		{   34,0,0,0,0,1, 112,0,0,0,0,  80,1, 5,0 },
		{   62,0,0,0,0,1, 112,0,0,0,0,  82,1, 5,0 },
		// 1
		{   34,0,0,0,0,1, 128,0,0,0,0,  80,1, 5,0 },
		{   62,0,0,0,0,1, 128,0,0,0,0,  82,1, 5,0 },
		// 
		{   90,0,0,0,0,1, 128,0,0,0,0,  80,1, 5,0 },
		{  118,0,0,0,0,1, 128,0,0,0,0,  82,1, 5,0 },
		// 
		{   90,0,0,0,0,1, 176,0,0,0,0,  80,1, 5,0 },
		{  118,0,0,0,0,1, 176,0,0,0,0,  82,1, 5,0 },
	},
	g_selecter_2b_oam[] =
	{
		// [ݒ㉺] 
		// 10
		{   34,0,0,0,0,1, 112,0,0,0,0,  84,1, 5,0 },
		{   62,0,0,0,0,1, 112,0,0,0,0,  86,1, 5,0 },
		// 1
		{   34,0,0,0,0,1, 128,0,0,0,0,  84,1, 5,0 },
		{   62,0,0,0,0,1, 128,0,0,0,0,  86,1, 5,0 },
		// 
		{   90,0,0,0,0,1, 128,0,0,0,0,  84,1, 5,0 },
		{  118,0,0,0,0,1, 128,0,0,0,0,  86,1, 5,0 },
		// 
		{   90,0,0,0,0,1, 176,0,0,0,0,  84,1, 5,0 },
		{  118,0,0,0,0,1, 176,0,0,0,0,  86,1, 5,0 },
	},
	g_next_1_oam[] =
	{
		// [] 
		{  156,0,0,0,0,1, 192,0,0,0,2, 672,1, 8,0 },
	},
	g_next_2_oam[] =
	{
		// [] 
		{  156,0,0,0,0,1, 192,0,0,0,2, 680,1, 9,0 },
	},
	g_back_1_oam[] =
	{
		// [߂] 
		{  156,0,0,0,0,1, 120,0,0,0,2, 688,1, 8,0 },
	},
	g_back_2_oam[] =
	{
		// [߂] 
		{  156,0,0,0,0,1, 120,0,0,0,2, 696,1, 9,0 },
	},
	g_suuji_1a_oam[] =
	{
		// ̒a
		// N 1430
		{   44,0,0,0,0,0,  42,0,0,0,1,   4,1, 3,0 },
		{   44,0,0,0,0,0,  54,0,0,0,1,  16,1, 3,0 },
		{   44,0,0,0,0,0,  66,0,0,0,1,  12,1, 3,0 },
		{   44,0,0,0,0,0,  78,0,0,0,1,   0,1, 3,0 },
		//  4 1`3͔N1431
		{   44,0,0,0,0,0, 121,0,0,0,1,   4,1, 3,0 },
		{   44,0,0,0,0,0, 135,0,0,0,1,   0,1, 3,0 },
		//  1
		{   44,0,0,0,0,0, 169,0,0,0,1,   0,1, 3,0 },
		{   44,0,0,0,0,0, 183,0,0,0,1,   0,1, 3,0 },
	},
	g_suuji_1b_oam[] =
	{
		// ̒a
		// N 1430
		{   44,0,0,0,0,0,  42,0,0,0,1,  44,1, 4,0 },
		{   44,0,0,0,0,0,  54,0,0,0,1,  56,1, 4,0 },
		{   44,0,0,0,0,0,  66,0,0,0,1,  52,1, 4,0 },
		{   44,0,0,0,0,0,  78,0,0,0,1,  40,1, 4,0 },
		//  4 1`3͔N1431
		{   44,0,0,0,0,0, 121,0,0,0,1,  44,1, 4,0 },
		{   44,0,0,0,0,0, 135,0,0,0,1,  40,1, 4,0 },
		//  1
		{   44,0,0,0,0,0, 169,0,0,0,1,  40,1, 4,0 },
		{   44,0,0,0,0,0, 183,0,0,0,1,  40,1, 4,0 },
	},
	g_suuji_2a_oam[] =
	{
		// pp̔N
		//  20
		{   44,0,0,0,0,0, 113,0,0,0,1,   0,1, 3,0 },
		{   44,0,0,0,0,0, 127,0,0,0,1,   0,1, 3,0 },
	},
	g_suuji_2b_oam[] =
	{
		// pp̔N
		//  20
		{   44,0,0,0,0,0, 113,0,0,0,1,  40,1, 4,0 },
		{   44,0,0,0,0,0, 127,0,0,0,1,  40,1, 4,0 },
	},
	g_suuji_3a_oam[] =
	{
		// pp̒a
		// N 1420
		{  100,0,0,0,0,0,  42,0,0,0,1,   4,1, 3,0 },
		{  100,0,0,0,0,0,  54,0,0,0,1,   0,1, 3,0 },
		{  100,0,0,0,0,0,  66,0,0,0,1,   0,1, 3,0 },
		{  100,0,0,0,0,0,  78,0,0,0,1,   0,1, 3,0 },
		//  1
		{  100,0,0,0,0,0, 121,0,0,0,1,   4,1, 3,0 },
		{  100,0,0,0,0,0, 135,0,0,0,1,   0,1, 3,0 },
		//  1
		{  100,0,0,0,0,0, 169,0,0,0,1,   0,1, 3,0 },
		{  100,0,0,0,0,0, 183,0,0,0,1,   0,1, 3,0 },
	},
	g_suuji_3b_oam[] =
	{
		// pp̒a
		// N 1420
		{  100,0,0,0,0,0,  42,0,0,0,1,  44,1, 4,0 },
		{  100,0,0,0,0,0,  54,0,0,0,1,  40,1, 4,0 },
		{  100,0,0,0,0,0,  66,0,0,0,1,  40,1, 4,0 },
		{  100,0,0,0,0,0,  78,0,0,0,1,  40,1, 4,0 },
		//  1
		{  100,0,0,0,0,0, 121,0,0,0,1,  44,1, 4,0 },
		{  100,0,0,0,0,0, 135,0,0,0,1,  40,1, 4,0 },
		//  1
		{  100,0,0,0,0,0, 169,0,0,0,1,  40,1, 4,0 },
		{  100,0,0,0,0,0, 183,0,0,0,1,  40,1, 4,0 },
	},
	g_birth_1_oam[] =
	{
		// [̒a͂łH] 
		{   16,0,0,0,0,1,  48,0,0,0,2, 200,1, 2,0 },
		{   16,0,0,0,0,1,  80,0,0,0,2, 208,1, 2,0 },
		{   16,0,0,0,0,1, 112,0,0,0,2, 216,1, 2,0 },
		{   16,0,0,0,0,1, 144,0,0,0,2, 224,1, 2,0 },
		{   16,0,0,0,0,1, 176,0,0,0,2, 232,1, 2,0 },
	},
	g_birth_2_oam[] =
	{
		// [̒a͂łH] 
		{   16,0,0,0,0,1,  48,0,0,0,2, 240,1, 1,0 },
		{   16,0,0,0,0,1,  80,0,0,0,2, 248,1, 1,0 },
		{   16,0,0,0,0,1, 112,0,0,0,2, 256,1, 1,0 },
		{   16,0,0,0,0,1, 144,0,0,0,2, 264,1, 1,0 },
		{   16,0,0,0,0,1, 176,0,0,0,2, 272,1, 1,0 },
	},
	g_blood_1_oam[] =
	{
		// [̌t^Ă] 
		{   72,0,0,0,0,1,  40,0,0,0,2, 280,1, 2,0 },
		{   72,0,0,0,0,1,  72,0,0,0,2, 288,1, 2,0 },
		{   72,0,0,0,0,1, 104,0,0,0,2, 296,1, 2,0 },
		{   72,0,0,0,0,1, 136,0,0,0,2, 304,1, 2,0 },
		{   72,0,0,0,0,1, 168,0,0,0,2, 312,1, 2,0 },
		{   72,0,0,0,0,0, 200,0,0,0,1, 320,1, 2,0 },
	},
	g_blood_2_oam[] =
	{
		// [̌t^Ă] 
		{   72,0,0,0,0,1,  40,0,0,0,2, 324,1, 1,0 },
		{   72,0,0,0,0,1,  72,0,0,0,2, 332,1, 1,0 },
		{   72,0,0,0,0,1, 104,0,0,0,2, 340,1, 1,0 },
		{   72,0,0,0,0,1, 136,0,0,0,2, 348,1, 1,0 },
		{   72,0,0,0,0,1, 168,0,0,0,2, 356,1, 1,0 },
		{   72,0,0,0,0,0, 200,0,0,0,1, 364,1, 1,0 },
	},
	g_blood_3_oam[] =
	{
		// [t^ABOAB] 
		{   96,0,0,0,0,0,  52,0,0,0,2, 544,1, 6,0 },
		{   96,0,0,0,0,0,  92,0,0,0,2, 560,1, 6,0 },
		{   96,0,0,0,0,0, 132,0,0,0,2, 576,1, 6,0 },
		{   96,0,0,0,0,0, 172,0,0,0,2, 592,1, 6,0 },
	},
	g_blood_4_oam[] =
	{
		// [t^ABOAB] 
		{   96,0,0,0,0,0,  52,0,0,0,2, 608,1, 7,0 },
		{   96,0,0,0,0,0,  92,0,0,0,2, 624,1, 7,0 },
		{   96,0,0,0,0,0, 132,0,0,0,2, 640,1, 7,0 },
		{   96,0,0,0,0,0, 172,0,0,0,2, 656,1, 7,0 },
	},
	g_nenrei_1_oam[] =
	{
		// [Ȃ̔NĂ] 
		{   16,0,0,0,0,1,  40,0,0,0,2, 368,1, 2,0 },
		{   16,0,0,0,0,1,  72,0,0,0,2, 376,1, 2,0 },
		{   16,0,0,0,0,1, 104,0,0,0,2, 384,1, 2,0 },
		{   16,0,0,0,0,1, 136,0,0,0,2, 392,1, 2,0 },
		{   16,0,0,0,0,1, 168,0,0,0,2, 400,1, 2,0 },
		{   16,0,0,0,0,0, 200,0,0,0,1, 408,1, 2,0 },
	},
	g_nenrei_2_oam[] =
	{
		// [Ȃ̔NĂ] 
		{   16,0,0,0,0,1,  40,0,0,0,2, 412,1, 1,0 },
		{   16,0,0,0,0,1,  72,0,0,0,2, 420,1, 1,0 },
		{   16,0,0,0,0,1, 104,0,0,0,2, 428,1, 1,0 },
		{   16,0,0,0,0,1, 136,0,0,0,2, 436,1, 1,0 },
		{   16,0,0,0,0,1, 168,0,0,0,2, 444,1, 1,0 },
		{   16,0,0,0,0,0, 200,0,0,0,1, 452,1, 1,0 },
	},
	g_tanjoubi_1_oam[] =
	{
		// [Ȃ̒a͂łH] 
		{   72,0,0,0,0,1,  40,0,0,0,2, 456,1, 2,0 },
		{   72,0,0,0,0,1,  72,0,0,0,2, 464,1, 2,0 },
		{   72,0,0,0,0,1, 104,0,0,0,2, 472,1, 2,0 },
		{   72,0,0,0,0,1, 136,0,0,0,2, 480,1, 2,0 },
		{   72,0,0,0,0,1, 168,0,0,0,2, 488,1, 2,0 },
		{   72,0,0,0,0,0, 200,0,0,0,1, 496,1, 2,0 },
	},
	g_tanjoubi_2_oam[] =
	{
		// [Ȃ̒a͂łH] 
		{   72,0,0,0,0,1,  40,0,0,0,2, 500,1, 1,0 },
		{   72,0,0,0,0,1,  72,0,0,0,2, 508,1, 1,0 },
		{   72,0,0,0,0,1, 104,0,0,0,2, 516,1, 1,0 },
		{   72,0,0,0,0,1, 136,0,0,0,2, 524,1, 1,0 },
		{   72,0,0,0,0,1, 168,0,0,0,2, 532,1, 1,0 },
		{   72,0,0,0,0,0, 200,0,0,0,1, 540,1, 1,0 },
	},
	g_father_name_oam[] =
	{
		{    0,0,0,0,0,0,   0,0,0,0,1, 768,2,15,0 },
		{    0,0,0,0,0,0,  14,0,0,0,1, 772,2,15,0 },
		{    0,0,0,0,0,0,  28,0,0,0,1, 776,2,15,0 },
		{    0,0,0,0,0,0,  42,0,0,0,1, 780,2,15,0 },
		{    0,0,0,0,0,0,  56,0,0,0,1, 784,2,15,0 },
		{    0,0,0,0,0,0,  70,0,0,0,1, 788,2,15,0 },
	},
	g_daughter_name_oam[] =
	{
		{    0,0,0,0,0,0,   0,0,0,0,1, 792,2,15,0 },
		{    0,0,0,0,0,0,  14,0,0,0,1, 796,2,15,0 },
		{    0,0,0,0,0,0,  28,0,0,0,1, 800,2,15,0 },
		{    0,0,0,0,0,0,  42,0,0,0,1, 804,2,15,0 },
		{    0,0,0,0,0,0,  56,0,0,0,1, 808,2,15,0 },
		{    0,0,0,0,0,0,  70,0,0,0,1, 812,2,15,0 },
	},
	g_father_name_u_oam[] =
	{
		{   95,0,0,0,0,0, 128,0,0,0,1,  64,0, 0,0 },
		{   95,0,0,0,0,0, 142,0,0,0,1,  68,0, 0,0 },
		{   95,0,0,0,0,0, 156,0,0,0,1,  72,0, 0,0 },
		{   95,0,0,0,0,0, 170,0,0,0,1,  76,0, 0,0 },
		{   95,0,0,0,0,0, 184,0,0,0,1,  80,0, 0,0 },
		{   95,0,0,0,0,0, 198,0,0,0,1,  84,0, 0,0 },
	},
	g_daughter_name_u_oam[] =
	{
		{   29,0,0,0,0,0, 128,0,0,0,1,  88,0, 0,0 },
		{   29,0,0,0,0,0, 142,0,0,0,1,  92,0, 0,0 },
		{   29,0,0,0,0,0, 156,0,0,0,1,  96,0, 0,0 },
		{   29,0,0,0,0,0, 170,0,0,0,1, 100,0, 0,0 },
		{   29,0,0,0,0,0, 184,0,0,0,1, 104,0, 0,0 },
		{   29,0,0,0,0,0, 198,0,0,0,1, 108,0, 0,0 },
	},
	g_daughter_birth_u_oam[] =
	{
		{   51,0,0,0,0,0, 128,0,0,0,1, 112,0, 0,0 },
		{   51,0,0,0,0,0, 142,0,0,0,1, 116,0, 0,0 },
		{   51,0,0,0,0,0, 156,0,0,0,1, 120,0, 0,0 },
		{   51,0,0,0,0,0, 170,0,0,0,1, 124,0, 0,0 },
		{   51,0,0,0,0,0, 184,0,0,0,1, 128,0, 0,0 },
		{   51,0,0,0,0,0, 198,0,0,0,1, 132,0, 0,0 },
	},
	g_father_birth_u_oam[] =
	{
		{  117,0,0,0,0,0, 128,0,0,0,1, 136,0, 0,0 },
		{  117,0,0,0,0,0, 142,0,0,0,1, 140,0, 0,0 },
		{  117,0,0,0,0,0, 156,0,0,0,1, 144,0, 0,0 },
		{  117,0,0,0,0,0, 170,0,0,0,1, 148,0, 0,0 },
		{  117,0,0,0,0,0, 184,0,0,0,1, 152,0, 0,0 },
		{  117,0,0,0,0,0, 198,0,0,0,1, 156,0, 0,0 },
	},
	g_daughter_blood_u_oam[] =
	{
		{   73,0,0,0,0,0, 128,0,0,0,1, 160,0, 0,0 },
		{   73,0,0,0,0,0, 142,0,0,0,1, 164,0, 0,0 },
	},
	g_father_age_u_oam[] =
	{
		{  139,0,0,0,0,0, 128,0,0,0,1, 168,0, 0,0 },
		{  139,0,0,0,0,0, 142,0,0,0,1, 172,0, 0,0 },
	};


// -------------------------------------
// [J֐`
// -------------------------------------
static void initEntryScreen(void);
static void waitEntryName(void);
static void mainEntryName(void);
static void checkEntryNameKey(s16);
static void toEntryDaughter(void);
static void mainEntryDaughter(void);
static void putEntryDaughterObj(void);
static void dayControl(int);
static void cancelToEntryName(void);
static void toEntryName(void);
static void setToEntryFather(void);
static void toEntryFather(void);
static void mainEntryFather(void);
static void backToEntryDaughter(void);
static void putEntryFatherObj(void);
static void cancelToEntryDaughter(void);
static void setDialog(u8);
static void toDialog(void);
static void mainDialog(void);
static void decideDialog(void);
static void fromDialog(void);
static void waitDialog(void);
static void execMainScreen(void);
static void setMainObj(void);
static void endEntry(void);

//---------------------------------------------------------------------------
//
// ֐
//
//---------------------------------------------------------------------------
// -------------------------------------
//  
// -------------------------------------
void initEntry(void)
{
	g_step = ENTRY_MODE_INIT;
}

// -------------------------------------
//  C
// -------------------------------------
void execEntry(void)
{
	switch (g_step)
	{
		case ENTRY_MODE_INIT:
			initEntryScreen();
			break;
		case ENTRY_MODE_NAME_WAIT:
			execMainScreen();
			waitEntryName();
			break;
		case ENTRY_MODE_NAME_MAIN:
			execMainScreen();
			mainEntryName();
			break;
		case ENTRY_MODE_NAME_TO_DAUGHTER:
			execMainScreen();
			toEntryDaughter();
			break;
		case ENTRY_MODE_DAUGHTER_MAIN:
			execMainScreen();
			mainEntryDaughter();
			break;
		case ENTRY_MODE_DAUGHTER_TO_NAME:
			execMainScreen();
			toEntryName();
			break;
		case ENTRY_MODE_DAUGHTER_TO_FATHER:
			execMainScreen();
			toEntryFather();
			break;
		case ENTRY_MODE_FATHER_MAIN:
			execMainScreen();
			mainEntryFather();
			break;
		case ENTRY_MODE_FATHER_TO_DAUGHTER:
			execMainScreen();
			backToEntryDaughter();
			break;
		case ENTRY_MODE_TO_DIALOG:
			execMainScreen();
			toDialog();
			break;
		case ENTRY_MODE_DIALOG_MAIN:
			execMainScreen();
			mainDialog();
			break;
		case ENTRY_MODE_DIALOG_DECIDE:
			execMainScreen();
			decideDialog();
			break;
		case ENTRY_MODE_FROM_DIALOG:
			execMainScreen();
			fromDialog();
			break;
		case ENTRY_MODE_DIALOG_WAIT:
			waitDialog();
			break;
		case ENTRY_MODE_END:
			endEntry();
			break;
		default:
			;
	}
}

// -------------------------------------
//  ʏ
// -------------------------------------
static void initEntryScreen(void)
{
	u8 m, d, w;
	int i;

	putLCDC(0, 0);
	setMainLCDC(LCDC_UP);		// Cɂ
	setVRAMBank(VRAM_SIZE_256, VRAM_SIZE_64, VRAM_SIZE_128, VRAM_SIZE_128);
	setVisible(PLANE_ALL, 0);
	setAlpha(PLANE_MAIN_BG, 0, ALPHA_OFF);
	clearObjData(ALL_OBJ);
	resetFade(FADE_MAIN_BG|FADE_MAIN_OBJ|FADE_SUB_BG|FADE_SUB_OBJ, FADE_NORMAL);
	setBgPos(PLANE_ALL_BG, 0, 0);

	setFontFile(_LC12X12_2_BIN);

	// 
//	setFadeFrom(FADE_MAIN_BG, FADE_NORMAL, FADE_BLACK, 60);

//	setBgMode(PLANE_MAIN_BG0, VRAM_BG_CHARBASE_0x04000, VRAM_BG_SCRBASE_0x0000, BG_SCRSIZE_256x256, COLOR_MODE_16);
//	readFileToVRAM(_WHITE_BG_CG, VRAM_MAIN_BG0_CG, 0);
//	readFileToVRAM(_WHITE_BG_MAP, VRAM_MAIN_BG0_SCR, 0);
//	readFileToVRAM(_WHITE_BG_PAL, VRAM_MAIN_BG_PAL, 0);

	for (i=0; i<6; i++)
	{
		g_daughter_birth[i*2] = g_birth[0];
		g_daughter_birth[i*2+1] = g_birth[1];
		g_father_birth[i*2] = g_birth[0];
		g_father_birth[i*2+1] = g_birth[1];
	}
	for (i=0; i<2; i++)
	{
		g_daughter_blood[i*2] = g_birth[0];
		g_daughter_blood[i*2+1] = g_birth[1];
		g_father_age[i*2] = g_birth[0];
		g_father_age[i*2+1] = g_birth[1];
	}
	readTextPtrToFontVRAM(g_daughter_birth, 12, 0, VRAM_MAIN_OBJ_CG, 0xe00);
	readTextPtrToFontVRAM(g_daughter_blood, 4, 0, VRAM_MAIN_OBJ_CG, 0x1400);
	readTextPtrToFontVRAM(g_father_birth, 12, 0, VRAM_MAIN_OBJ_CG, 0x1100);
	readTextPtrToFontVRAM(g_father_age, 4, 0, VRAM_MAIN_OBJ_CG, 0x1500);

	readFileToVRAM(_WHITE_OBJ_CG, VRAM_MAIN_OBJ_CG, 0);
	readFileToVRAM(_WHITE_OBJ_PAL, VRAM_MAIN_OBJ_PAL, 0);

	setObjData(MAIN_OBJ, (void *)g_white_wall_oam, 12);
	setAlpha(0, PLANE_MAIN_BG2|PLANE_MAIN_BG3, 16);
	g_movie_count = 48;

	// 
	setFadeFrom(FADE_SUB_BG|FADE_SUB_OBJ, FADE_WHITE, FADE_NORMAL, 60);

	setBgMode(PLANE_SUB_BG0, VRAM_BG_CHARBASE_0x04000, VRAM_BG_SCRBASE_0x0000, BG_SCRSIZE_256x256, COLOR_MODE_16);
	setBgMode(PLANE_SUB_BG1, VRAM_BG_CHARBASE_0x10000, VRAM_BG_SCRBASE_0x2800, BG_SCRSIZE_256x256, COLOR_MODE_16);
	setBgMode(PLANE_SUB_BG2, VRAM_BG_CHARBASE_0x08000, VRAM_BG_SCRBASE_0x1800, BG_SCRSIZE_256x256, COLOR_MODE_16);
	setBgMode(PLANE_SUB_BG3, VRAM_BG_CHARBASE_0x08000, VRAM_BG_SCRBASE_0x2000, BG_SCRSIZE_256x256, COLOR_MODE_16);

	readFileToVRAM(_ENTRY_03_CG, VRAM_SUB_BG0_CG, 0);
	readFileToVRAM(_ENTRY_02_CG, VRAM_SUB_BG1_CG, 0);
	readFileToVRAM(_ENTRY_01_CG, VRAM_SUB_BG2_CG, 0);
	readFileToVRAM(_ENTRY_03A_MAP, VRAM_SUB_BG0_SCR, 0);
	readFileToVRAM(_ENTRY_03B_MAP, VRAM_SUB_BG0_SCR, 0x800);
	readFileToVRAM(_ENTRY_03C_MAP, VRAM_SUB_BG0_SCR, 0x1000);
	readFileToVRAM(_ENTRY_02A_MAP, VRAM_SUB_BG1_SCR, 0);
	readFileToVRAM(_ENTRY_02B_MAP, VRAM_SUB_BG1_SCR, 0x800);
	readFileToVRAM(_ENTRY_01A_MAP, VRAM_SUB_BG2_SCR, 0);
	readFileToVRAM(_ENTRY_01B_MAP, VRAM_SUB_BG3_SCR, 0);
	readFileToVRAM(_ENTRY_BG_PAL, VRAM_SUB_BG_PAL, 0);

	readFileToVRAM(_ENTRY_OBJ_CG, VRAM_SUB_OBJ_CG, 0);
	readFileToVRAM(_ENTRY_OBJ_PAL, VRAM_SUB_OBJ_PAL, 0);
	setObjData(SUB_OBJ, (void *)g_entry_1_oam, 6);

	for (i=0; i<6; i++)
	{
		g_father_name[i*2] = g_underbar[0];
		g_father_name[i*2+1] = g_underbar[1];
		g_daughter_name[i*2] = g_underbar[0];
		g_daughter_name[i*2+1] = g_underbar[1];
	}
	g_father_name_len = 0;
	g_daughter_name_len = 0;
	g_name_input = 0;
	//memcpyBDS((s8 *)g_father_name, (s8 *)g_underbar, 12);
	//memcpyBDS((s8 *)g_daughter_name, (s8 *)g_father_name, 12);

	//readTextPtrToFontVRAM(g_father_name, 12, 0, VRAM_SUB_OBJ_CG, 0xe80);
	//readTextPtrToFontVRAM(g_daughter_name, 12, 0, VRAM_SUB_OBJ_CG, 0x1180);
	readTextPtrToFontVRAM(g_father_name, 12, 0, VRAM_SUB_OBJ_CG, 0x6000);
	readTextPtrToFontVRAM(g_daughter_name, 12, 0, VRAM_SUB_OBJ_CG, 0x6300);
	setObjDataPos(SUB_OBJ+9, (void *)g_father_name_oam, 6, 87, 30);

	setVisible(PLANE_MAIN_OBJ|PLANE_SUB_BG2|PLANE_SUB_OBJ, 1);
	putLCDC(1, 1);

	g_step = ENTRY_MODE_NAME_WAIT;

	g_name_wait = 60;
	g_name_count = 1;
	g_name_mode = 0;

	g_blood = getBlood();
	getBirth(&g_birth_y, &g_birth_m, &g_birth_d);
	getDays(&g_now_y, &m, &d, &w);
	getFBirth(&g_fbirth_y, &g_fbirth_m, &g_fbirth_d);

	readFile(_HIRA_TXT, (void *)&g_hiragana);
	readFile(_KATA_TXT, (void *)&g_katakana);
	initTouchPenData();

	g_dialog_select = -1;

	setBGM(SEQ_PRM4_03);
	playMovie(_OP_MODS);
	g_movie_mode = 0;
}


// -------------------------------------
//  ʂ̏
// -------------------------------------
static void execMainScreen(void)
{
	if (g_movie_mode == 0)
	{
		// [r[Đ
		if (g_movie_count > 0)
		{
			g_movie_count--;
			setAlpha(0, PLANE_MAIN_BG2|PLANE_MAIN_BG3, g_movie_count/3);
			if (g_movie_count == 0)
				setObjData(MAIN_OBJ, (void *)g_black_wall_oam, 12);
		} else
		if (!isPlayMovie())
		{
			// ĐI
			g_movie_mode = 1;

			setFadeFrom(FADE_MAIN_BG|FADE_MAIN_OBJ, FADE_BLACK, FADE_NORMAL, 60);

			setBgMode(PLANE_MAIN_BG0, VRAM_BG_CHARBASE_0x04000, VRAM_BG_SCRBASE_0x0000, BG_SCRSIZE_256x256, COLOR_MODE_16);
			readFileToVRAM(_ENTRY_END_CG, VRAM_MAIN_BG0_CG, 0);
			readFileToVRAM(_ENTRY_END_MAP, VRAM_MAIN_BG0_SCR, 0);
			readFileToVRAM(_ENTRY_END_PAL, VRAM_MAIN_BG_PAL, 0);
			//readFileToVRAM(_WHITE_OBJ_CG, VRAM_MAIN_OBJ_CG, 0);

			readFileToVRAM(_ENTRY_END_OBJ_PAL, VRAM_MAIN_OBJ_PAL, 0);
			clearObjDatas(MAIN_OBJ, 12);
			setMainObj();
			setAlpha(PLANE_MAIN_BG, 0, ALPHA_OFF);
			setVisibleReq(PLANE_MAIN_BG0|PLANE_MAIN_OBJ, 1);
		} else {
			s32 last_frame;

			last_frame = getMovieTotalFrame() - getMovieFrame();
			if (last_frame < 16 * 4)
				setAlpha(0, PLANE_MAIN_BG2|PLANE_MAIN_BG3, 16-(last_frame/4));
		}
	} else
	if (g_movie_mode == 1)
	{
		if (!isFade(FADE_MAIN_BG))
		{
			playBGM();
			g_movie_mode = 2;
		}
	}
}

// -------------------------------------
//  󋵔fnaiݒ
// -------------------------------------
static void setMainObj(void)
{
	int p;

	if (g_step == ENTRY_MODE_NAME_MAIN)
	{
		if (g_name_mode == 0)
		{
			if (g_father_name_len > 0)
				readTextPtrToFontVRAM(&g_father_name[0], g_father_name_len*2, 0, VRAM_MAIN_OBJ_CG, 0x800);
		} else {
			if (g_daughter_name_len > 0)
				readTextPtrToFontVRAM(&g_daughter_name[0], g_daughter_name_len*2, 0, VRAM_MAIN_OBJ_CG, 0xb00);
		}
	} else
	if (g_step == ENTRY_MODE_DAUGHTER_MAIN)
	{
		// ̒a
		for (p=0; p<6; p++)
		{
			g_daughter_birth[p*2+0] = g_birth[0];
			g_daughter_birth[p*2+1] = g_birth[1];
		}
		p = 0;
		if (g_birth_m >= 10)
		{
			g_daughter_birth[p+0] = g_suuji[1*2+0];
			g_daughter_birth[p+1] = g_suuji[1*2+1];
			p += 2;
		}
		g_daughter_birth[p+0] = g_suuji[(g_birth_m%10)*2+0];
		g_daughter_birth[p+1] = g_suuji[(g_birth_m%10)*2+1];
		p += 2;
		g_daughter_birth[p+0] = g_birth[2];
		g_daughter_birth[p+1] = g_birth[3];
		p += 2;
		if (g_birth_d >= 10)
		{
			g_daughter_birth[p+0] = g_suuji[(g_birth_d/10)*2+0];
			g_daughter_birth[p+1] = g_suuji[(g_birth_d/10)*2+1];
			p += 2;
		}
		g_daughter_birth[p+0] = g_suuji[(g_birth_d%10)*2+0];
		g_daughter_birth[p+1] = g_suuji[(g_birth_d%10)*2+1];
		p += 2;
		g_daughter_birth[p+0] = g_birth[4];
		g_daughter_birth[p+1] = g_birth[5];
		readTextPtrToFontVRAM(g_daughter_birth, 12, 0, VRAM_MAIN_OBJ_CG, 0xe00);
		// ̌t^
		g_daughter_blood[0] = g_blood_str[g_blood*4+0];
		g_daughter_blood[1] = g_blood_str[g_blood*4+1];
		g_daughter_blood[2] = g_blood_str[g_blood*4+2];
		g_daughter_blood[3] = g_blood_str[g_blood*4+3];
		readTextPtrToFontVRAM(g_daughter_blood, 4, 0, VRAM_MAIN_OBJ_CG, 0x1400);
	} else
	if (g_step == ENTRY_MODE_FATHER_MAIN)
	{
		// ̒a
		for (p=0; p<6; p++)
		{
			g_father_birth[p*2+0] = g_birth[0];
			g_father_birth[p*2+1] = g_birth[1];
		}
		p = 0;
		if (g_fbirth_m >= 10)
		{
			g_father_birth[p+0] = g_suuji[1*2+0];
			g_father_birth[p+1] = g_suuji[1*2+1];
			p += 2;
		}
		g_father_birth[p+0] = g_suuji[(g_fbirth_m%10)*2+0];
		g_father_birth[p+1] = g_suuji[(g_fbirth_m%10)*2+1];
		p += 2;
		g_father_birth[p+0] = g_birth[2];
		g_father_birth[p+1] = g_birth[3];
		p += 2;
		if (g_fbirth_d >= 10)
		{
			g_father_birth[p+0] = g_suuji[(g_fbirth_d/10)*2+0];
			g_father_birth[p+1] = g_suuji[(g_fbirth_d/10)*2+1];
			p += 2;
		}
		g_father_birth[p+0] = g_suuji[(g_fbirth_d%10)*2+0];
		g_father_birth[p+1] = g_suuji[(g_fbirth_d%10)*2+1];
		p += 2;
		g_father_birth[p+0] = g_birth[4];
		g_father_birth[p+1] = g_birth[5];
		readTextPtrToFontVRAM(g_father_birth, 12, 0, VRAM_MAIN_OBJ_CG, 0x1100);
		// ̔N
		g_father_age[0] = g_suuji[((g_now_y - g_fbirth_y)/10)*2+0];
		g_father_age[1] = g_suuji[((g_now_y - g_fbirth_y)/10)*2+1];
		g_father_age[2] = g_suuji[((g_now_y - g_fbirth_y)%10)*2+0];
		g_father_age[3] = g_suuji[((g_now_y - g_fbirth_y)%10)*2+1];
		readTextPtrToFontVRAM(g_father_age, 4, 0, VRAM_MAIN_OBJ_CG, 0x1500);
	}
	if (g_movie_mode == 0)
		return;			// [r[Đ

	clearObjDatas(MAIN_OBJ, 12);
	if (g_father_name_len > 0)
		setObjData(MAIN_OBJ, (void *)g_father_name_u_oam, g_father_name_len);
	if (g_daughter_name_len > 0)
		setObjData(MAIN_OBJ+6, (void *)g_daughter_name_u_oam, g_daughter_name_len);
	setObjData(MAIN_OBJ+12, (void *)g_daughter_birth_u_oam, 6);
	setObjData(MAIN_OBJ+18, (void *)g_father_birth_u_oam, 6);
	setObjData(MAIN_OBJ+24, (void *)g_daughter_blood_u_oam, 2);
	setObjData(MAIN_OBJ+26, (void *)g_father_age_u_oam, 2);
}

// -------------------------------------
//  \EFCg
// -------------------------------------
static void waitEntryName(void)
{
	if (!isFade(FADE_SUB_BG))
	{
		g_cursor_count = 0;
		g_cursor_pal = 0;
		g_cursor_wait = 4;

		g_count = 0;
		g_kana_mode = 0;
		g_wait = 0;

		g_step = ENTRY_MODE_NAME_MAIN;

		setTouchPenData(_ENTRY_A_TPD);
		setTouchPenKeyDecide(PAD_BUTTON_L, 82);
		setTouchPenKeyDecide(PAD_BUTTON_R, 82);
		setTouchPenKeyDecide(PAD_BUTTON_SELECT, 82);
		setTouchPenKeyDecide(PAD_BUTTON_B, 83);
		setTouchPenKeySelect(PAD_BUTTON_START, 84);
		setTouchPenDoubleMove(TRUE);
	}
}

// -------------------------------------
//  ʕ\
// -------------------------------------
static void mainEntryName(void)
{
	s16 select, i, w;

	// ʃAt@؂ւ
	if (g_wait > 0)
	{
		if (g_kana_mode == 0)
			g_count++;
		else
			g_count--;
		setAlpha(PLANE_SUB_BG2, PLANE_SUB_BG3, g_count);
		if (g_count == 0 || g_count == 16)
		{
			if (g_kana_mode == 0)
				setVisible(PLANE_SUB_BG3, 0);
			else
				setVisible(PLANE_SUB_BG2, 0);
			setAlpha(PLANE_SUB_BG, 0, ALPHA_OFF);
			g_wait = 0;
		}
		return;
	}

	// ʓ
	if (getTouchPenDecide() != -1)
	{
		checkEntryNameKey(getTouchPenDecide());
	} else
	if (getTouchPenSelect() != getTouchPenOldSelect())
	{
		if (getTouchPenSelect() != -1)
			playSE(SE_01);
	}

	// O\
	if (g_name_mode == 0)
	{
		g_name_wait--;
		if (g_name_wait == 0)
		{
			if (g_name_count == 0)
			{
				g_name_count = 1;
				g_name_wait = 60;
				setObjDataPos(SUB_OBJ+9, (void *)g_father_name_oam, 6, 87, 30);
			} else {
				g_name_count = 0;
				g_name_wait = 30;
				clearObjData(SUB_OBJ+9+g_name_input);
			}
		}
	} else
	if (g_name_mode == 1)
	{
		w = 0;
		for (i=0; i<6; i++)
		{
			if (g_name_move[i] > 0)
			{
				g_name_move[i]--;
			} else {
				g_name_x[i] /= 2;
				setObjDataPos(SUB_OBJ+9+i, (void *)&g_father_name_oam[i], 1, 134 - g_name_x[i], 30);
				if (g_name_x[i] == 0)
					w++;
			}
		}
		if (w == 6)
		{
			g_name_count = 1;
			g_name_wait = 30;
			g_name_input = 0;
			resumeTouchPenData();
			g_name_mode = 2;
		}
	} else
	if (g_name_mode == 2)
	{
		g_name_wait--;
		if (g_name_wait == 0)
		{
			if (g_name_count == 0)
			{
				g_name_count = 1;
				g_name_wait = 60;
				setObjDataPos(SUB_OBJ+15, (void *)g_daughter_name_oam, 6, 40, 30);
			} else {
				g_name_count = 0;
				g_name_wait = 30;
				clearObjData(SUB_OBJ+15+g_name_input);
			}
		}
	} else {
		w = 0;
		for (i=0; i<6; i++)
		{
			if (g_name_move[i] > 0)
			{
				g_name_move[i]--;
			} else {
				g_name_x[i] /= 2;
				setObjDataPos(SUB_OBJ+9+i, (void *)&g_father_name_oam[i], 1, 87 + g_name_x[i], 30);
				if (g_name_x[i] == 0)
					w++;
			}
		}
		if (w == 6)
		{
			g_name_count = 1;
			g_name_wait = 30;
			g_name_input = 5;
			while (!memcmpBDS((s8 *)&g_father_name[(g_name_input-1)*2], (s8 *)g_underbar, 2))
				g_name_input--;
			resumeTouchPenData();
			g_name_mode = 0;
		}
	}

	// J[\\
	g_cursor_wait--;
	if (g_cursor_wait == 0)
	{
		g_cursor_wait = 4;
		g_cursor_pal++;
		if (g_cursor_pal == 7)
			g_cursor_pal = 0;
		setFileToPalette(VRAM_SUB_OBJ_PAL, 0, _ENTRY_OBJ_ANIM_PAL, g_cursor_pal, 1);
	}
	select = getTouchPenSelect();
	if (select != -1)
	{
		if (getTouchPenRectY(select) == 164)
		{
			setObjDataPos(SUB_OBJ+7, (void *)g_cursor_1_oam, 2, getTouchPenRectX(select), getTouchPenRectY(select));
		} else {
			setObjDataPos(SUB_OBJ+7, (void *)g_cursor_2_oam, 1, getTouchPenRectX(select), getTouchPenRectY(select));
			clearObjData(SUB_OBJ+8);
		}
	} else
		clearObjDatas(SUB_OBJ+7, 2);
}


// -------------------------------------
//  L[`FbN
// -------------------------------------
static void checkEntryNameKey(s16 in_select)
{
	if (in_select == -1)
		return;

	if (in_select < 81 || in_select == 85)
	{
		// 
		s16 moji;
		moji = in_select;
		if (moji == 85)
			moji = 81;
		if (g_name_mode == 0)
		{
			if (g_kana_mode == 0)
				memcpyBDS((s8 *)&g_father_name[g_name_input*2], (s8 *)&g_hiragana[moji*2], 2);
			else
				memcpyBDS((s8 *)&g_father_name[g_name_input*2], (s8 *)&g_katakana[moji*2], 2);
			readTextPtrToFontVRAM(&g_father_name[g_name_input*2], 2, 0, VRAM_SUB_OBJ_CG, (u32)(0x6000+0x80*g_name_input));
		} else {
			if (g_kana_mode == 0)
				memcpyBDS((s8 *)&g_daughter_name[g_name_input*2], (s8 *)&g_hiragana[moji*2], 2);
			else
				memcpyBDS((s8 *)&g_daughter_name[g_name_input*2], (s8 *)&g_katakana[moji*2], 2);
			readTextPtrToFontVRAM(&g_daughter_name[g_name_input*2], 2, 0, VRAM_SUB_OBJ_CG, (u32)(0x6300+0x80*g_name_input));
		}
		if (g_name_input == 5)
		{
			setTouchPenKeySelectPos(84);		// ɂ킹
			if (g_name_mode == 0)
				g_father_name_len = 6;
			else
				g_daughter_name_len = 6;
		} else {
			g_name_input++;
			if (g_name_mode == 0)
				g_father_name_len = g_name_input;
			else
				g_daughter_name_len = g_name_input;
		}
		g_name_count = 1;
		g_name_wait = 60;
		if (g_name_mode == 0)
			setObjDataPos(SUB_OBJ+9, (void *)g_father_name_oam, 6, 87, 30);
		else
			setObjDataPos(SUB_OBJ+15, (void *)g_daughter_name_oam, 6, 40, 30);
		setMainObj();
		//playAdxM(SE_CUR_OK);
		playSE(SE_02);
	} else
	if (in_select == 81)
	{
		// Ђ炪
		if (g_kana_mode == 1)
		{
			g_count = 0;
			setAlpha(PLANE_SUB_BG2, PLANE_SUB_BG3, 0);
			setVisible(PLANE_SUB_BG2, 1);
			g_kana_mode = 0;
			g_wait = 2;
			//playAdxM(SE_CUR_OK);
			playSE(SE_02);
			// LRL[łЂ炪
			setTouchPenData(_ENTRY_A_TPD);
			setTouchPenKeyDecide(PAD_BUTTON_L, 82);
			setTouchPenKeyDecide(PAD_BUTTON_R, 82);
			setTouchPenKeyDecide(PAD_BUTTON_SELECT, 82);
			if (g_dialog_select == 85)
				g_dialog_select = -1;
		} else
			//playAdxM(SE_CUR_CANCEL);
			playSE(SE_03);
	} else
	if (in_select == 82)
	{
		// J^Ji
		if (g_kana_mode == 0)
		{
			g_count = 16;
			setAlpha(PLANE_SUB_BG2, PLANE_SUB_BG3, 16);
			setVisible(PLANE_SUB_BG3, 1);
			g_kana_mode = 1;
			g_wait = 2;
			//playAdxM(SE_CUR_OK);
			playSE(SE_02);
			// LRL[ŃJ^Ji
			setTouchPenData(_ENTRY_B_TPD);
			setTouchPenKeyDecide(PAD_BUTTON_L, 81);
			setTouchPenKeyDecide(PAD_BUTTON_R, 81);
			setTouchPenKeyDecide(PAD_BUTTON_SELECT, 81);
		} else
			//playAdxM(SE_CUR_CANCEL);
			playSE(SE_03);
	} else
	if (in_select == 83)
	{
		// ߂
		if (g_name_mode == 0 && g_name_input == 0)
		{
			// ^Cg
			setDialog(ENTRY_DIALOG_TITLE);
			//playAdxM(SE_CUR_CANCEL);
			playSE(SE_03);
		} else
		if (g_name_mode == 2 && g_name_input == 0)
		{
			// O疼
			g_name_move[0] = 0;
			g_name_move[1] = 2;
			g_name_move[2] = 4;
			g_name_move[3] = 6;
			g_name_move[4] = 8;
			g_name_move[5] = 10;
			g_name_x[0] = 47;
			g_name_x[1] = 47;
			g_name_x[2] = 47;
			g_name_x[3] = 47;
			g_name_x[4] = 47;
			g_name_x[5] = 47;
			g_name_count = 1;
			g_name_wait = 60;
			setObjDataPos(SUB_OBJ+9, (void *)g_father_name_oam, 6, 134, 30);
			clearObjDatas(SUB_OBJ+15, 6);
			setObjData(SUB_OBJ, (void *)g_entry_1_oam, 6);
			pauseTouchPenData();
			g_name_mode = 3;
			//playAdxM(SE_CUR_CANCEL);
			playSE(SE_03);
		} else
		if (g_name_input > 0)
		{
			if (g_name_mode == 0)
			{
				if (g_name_input == 5 && memcmpBDS((s8 *)&g_father_name[g_name_input*2], (s8 *)g_underbar, 2))
				{
					memcpyBDS((s8 *)&g_father_name[g_name_input*2], (s8 *)g_underbar, 2);
				} else {
					if (g_name_input > 0)
						g_name_input--;
					memcpyBDS((s8 *)&g_father_name[g_name_input*2], (s8 *)g_underbar, 2);
				}
				readTextPtrToFontVRAM(&g_father_name[g_name_input*2], 2, 0, VRAM_SUB_OBJ_CG, (u32)(0x6000+0x80*g_name_input));
				g_father_name_len = g_name_input;
			} else {
				if (g_name_input == 5 && memcmpBDS((s8 *)&g_daughter_name[g_name_input*2], (s8 *)g_underbar, 2))
				{
					memcpyBDS((s8 *)&g_daughter_name[g_name_input*2], (s8 *)g_underbar, 2);
				} else {
					if (g_name_input > 0)
						g_name_input--;
					memcpyBDS((s8 *)&g_daughter_name[g_name_input*2], (s8 *)g_underbar, 2);
				}
				readTextPtrToFontVRAM(&g_daughter_name[g_name_input*2], 2, 0, VRAM_SUB_OBJ_CG, (u32)(0x6300+0x80*g_name_input));
				g_daughter_name_len = g_name_input;
			}
			g_name_count = 1;
			g_name_wait = 60;
			if (g_name_mode == 0)
				setObjDataPos(SUB_OBJ+9, (void *)g_father_name_oam, 6, 87, 30);
			else
				setObjDataPos(SUB_OBJ+15, (void *)g_daughter_name_oam, 6, 40, 30);
			setMainObj();
			//playAdxM(SE_CUR_CANCEL);
			playSE(SE_03);
		} else
			//playAdxM(SE_CUR_CANCEL_2);
			playSE(SE_06);
	} else
	if (in_select == 84)
	{
		// 
		int i;
		BOOL hit;

		if (g_name_mode == 0)
		{
			// 疼O
			if (g_name_input == 0)
			{
				memcpyBDS((s8 *)g_father_name, (s8 *)getName(1), 12);
				g_father_name_len = 6;
				hit = FALSE;
				for (i=0; i<6; i++)
				{
					if (g_father_name[i*2] == 0 && g_father_name[i*2+1] == 0)
					{
						g_father_name[i*2] = g_underbar[0];
						g_father_name[i*2+1] = g_underbar[1];
						if (!hit)
						{
							g_father_name_len = (u8)i;
							hit = TRUE;
						}
					}
				}
				readTextPtrToFontVRAM(g_father_name, 12, 0, VRAM_SUB_OBJ_CG, 0x6000);
				setMainObj();
			}
			g_name_move[0] = 10;
			g_name_move[1] = 8;
			g_name_move[2] = 6;
			g_name_move[3] = 4;
			g_name_move[4] = 2;
			g_name_move[5] = 0;
			g_name_x[0] = 47;
			g_name_x[1] = 47;
			g_name_x[2] = 47;
			g_name_x[3] = 47;
			g_name_x[4] = 47;
			g_name_x[5] = 47;
			g_name_count = 1;
			g_name_wait = 60;
			setObjDataPos(SUB_OBJ+9, (void *)g_father_name_oam, 6, 87, 30);
			setObjDataPos(SUB_OBJ+15, (void *)g_daughter_name_oam, 6, 40, 30);
			setObjData(SUB_OBJ, (void *)g_entry_2_oam, 5);
			clearObjData(SUB_OBJ+5);
			pauseTouchPenData();
			g_name_mode = 1;
		} else
		if (g_name_mode == 2)
		{
			// Oa
			if (g_name_input == 0)
			{
				memcpyBDS((s8 *)g_daughter_name, (s8 *)getName(0), 12);
				g_daughter_name_len = 6;
				hit = FALSE;
				for (i=0; i<6; i++)
				{
					if (g_daughter_name[i*2] == 0 && g_daughter_name[i*2+1] == 0)
					{
						g_daughter_name[i*2] = g_underbar[0];
						g_daughter_name[i*2+1] = g_underbar[1];
						if (!hit)
						{
							g_daughter_name_len = (u8)i;
							hit = TRUE;
						}
					}
				}
				readTextPtrToFontVRAM(g_daughter_name, 12, 0, VRAM_SUB_OBJ_CG, 0x6300);
				setMainObj();
				setObjDataPos(SUB_OBJ+15, (void *)g_daughter_name_oam, 6, 40, 30);
			}
			g_count = 0;
			g_wait = 15;
			setAlpha(PLANE_SUB_BG1, PLANE_SUB_BG2|PLANE_SUB_BG3|PLANE_SUB_OBJ, 0);
			setVisible(PLANE_SUB_BG1, 1);
			g_step = ENTRY_MODE_NAME_TO_DAUGHTER;
		}
		//playAdxM(SE_CUR_OK_2);
		playSE(SE_05);
	}
}


// -------------------------------------
//  aEt^̓͂ֈڍs
// -------------------------------------
static void toEntryDaughter(void)
{
	g_wait--;
	if (g_wait == 0)
	{
		g_wait = 1;
		g_count++;
		setAlpha(PLANE_SUB_BG1, PLANE_SUB_BG2|PLANE_SUB_BG3|PLANE_SUB_OBJ, g_count);
		if (g_count == 16)
		{
			setVisible(PLANE_SUB_BG2|PLANE_SUB_BG3, 0);
			setAlpha(PLANE_SUB_BG, 0, ALPHA_OFF);

			g_blood_select = -1;
			g_days_select = -1;
			g_next_select = -1;
			g_tp_repeat = 0;
			g_tp_count = 0;
			g_key_input = 0;
			g_key_mode = 0;
			g_key_select = 0;

			setMainObj();
			clearObjData(ALL_SUB_OBJ);
			putEntryDaughterObj();

			initTouchPenData();
			setTouchPenData(_ENTRY_C_TPD);
			setTouchPenUseKey(FALSE);

			g_step = ENTRY_MODE_DAUGHTER_MAIN;
		}
	}
}


// -------------------------------------
//  aEt^̓
// -------------------------------------
static void mainEntryDaughter(void)
{
	s16 select, selold, decide;
	u16 m, rep;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	m = getTouchMode();
	rep = getPadRep();
	if (decide != -1)
	{
		g_key_input = 0;
		if (decide == 8)
		{
			// ߂
			cancelToEntryName();
		} else
		if (decide == 9)
		{
			// 
			setToEntryFather();
		} else {
			if (decide >= 4)
			{
				g_blood = (u8)(decide - 4);
				g_blood_select = -1;
			} else
			if (g_tp_repeat < 45)
			{
				if (decide == 0)
					g_birth_m++;
				else
				if (decide == 1)
					g_birth_m--;
				else
				if (decide == 2)
					g_birth_d++;
				else
				if (decide == 3)
					g_birth_d--;
				dayControl(0);
				g_days_select = -1;
			}
			g_tp_repeat = 0;
			putEntryDaughterObj();
			setMainObj();
		}
	} else
	if (select != selold)
	{
		if (select != -1)
		{
			g_key_input = 0;
			playSE(SE_01);
		}
		if (select < 4)
			g_days_select = select;
		else
			g_days_select = -1;
		if (select >= 4 && select < 8)
			g_blood_select = (s16)(select - 4);
		else
			g_blood_select = -1;
		if (select == 8)
			g_next_select = 0;
		else
		if (select == 9)
			g_next_select = 1;
		else
			g_next_select = -1;
		g_tp_repeat = 0;
		putEntryDaughterObj();
		setMainObj();
	} else
	if (select != -1 && select < 4)
	{
		g_key_input = 0;
		if (g_tp_repeat < 45)
		{
			g_tp_repeat++;
			if (g_tp_repeat == 45)
				g_tp_count = 0;
		} else {
			g_tp_count++;
			if (g_tp_count >= 6)
			{
				g_tp_count = 0;
				if (select == 0)
					g_birth_m++;
				else
				if (select == 1)
					g_birth_m--;
				else
				if (select == 2)
					g_birth_d++;
				else
				if (select == 3)
					g_birth_d--;
				dayControl(0);
				putEntryDaughterObj();
				setMainObj();
				playSE(SE_01);
			}
		}
	} else
	if (m == TOUCH_PEN_NONE)
	{
		// ^b`yŐGĂȂ΃L[͂
		if (rep & PAD_BUTTON_START)
		{
			// ݒɂ
			g_next_select = 1;
			if (g_blood_select != -1)
				g_blood = (u8)g_blood_select;
			putEntryDaughterObj();
			setMainObj();
			setToEntryFather();
		} else
		if (g_key_input == 0)
		{
			if (rep & (PAD_KEY_UP|PAD_KEY_DOWN|PAD_KEY_LEFT|PAD_KEY_RIGHT|PAD_BUTTON_A|PAD_BUTTON_SELECT))
			{
				g_key_input = 1;
				g_days_select = (s16)(g_key_select + 4);
				playSE(SE_01);
				putEntryDaughterObj();
			} else
			if (rep & PAD_BUTTON_B)
			{
				// O͂ɖ߂
				cancelToEntryName();
			}
		} else
		if (g_key_mode == 0)
		{
			// 
			if (rep & (PAD_BUTTON_A|PAD_BUTTON_SELECT))
			{
				// t^͂ɂ
				g_key_mode = 1;
				g_blood_select = g_blood;
				g_days_select = -1;
				playSE(SE_01);
				putEntryDaughterObj();
			} else
			if (rep & PAD_BUTTON_B)
			{
				// O͂ɖ߂
				cancelToEntryName();
			} else
			if (rep & PAD_KEY_UP)
			{
				if (g_key_select == 0)
					g_birth_m++;
				else
					g_birth_d++;
				dayControl(0);
				playSE(SE_01);
				putEntryDaughterObj();
				setMainObj();
			} else
			if (rep & PAD_KEY_DOWN)
			{
				if (g_key_select == 0)
					g_birth_m--;
				else
					g_birth_d--;
				dayControl(0);
				playSE(SE_01);
				putEntryDaughterObj();
				setMainObj();
			} else
			if (rep & PAD_KEY_LEFT)
			{
				g_key_select = 0;
				g_days_select = 4;
				putEntryDaughterObj();
				playSE(SE_01);
			} else
			if (rep & PAD_KEY_RIGHT)
			{
				g_key_select = 1;
				g_days_select = 5;
				putEntryDaughterObj();
				playSE(SE_01);
			}
		} else
		if (g_key_mode == 1)
		{
			// t^
			if (rep & PAD_BUTTON_A)
			{
				// ݒɂ
				g_next_select = 1;
				g_blood = (u8)g_blood_select;
				putEntryDaughterObj();
				setMainObj();
				setToEntryFather();
			} else
			if (rep & (PAD_BUTTON_B|PAD_BUTTON_SELECT))
			{
				// ͂ɂ
				g_key_mode = 0;
				g_blood_select = -1;
				g_days_select = (s16)(g_key_select + 4);
				playSE(SE_01);
				putEntryDaughterObj();
			} else
			if (rep & PAD_KEY_LEFT)
			{
				if (g_blood_select == 0)
					g_blood_select = 3;
				else
					g_blood_select--;
				putEntryDaughterObj();
				setMainObj();
				playSE(SE_01);
			} else
			if (rep & PAD_KEY_RIGHT)
			{
				if (g_blood_select == 3)
					g_blood_select = 0;
				else
					g_blood_select++;
				putEntryDaughterObj();
				setMainObj();
				playSE(SE_01);
			}
		}
	} else
	if (g_key_input != 0)
	{
		g_key_input = 0;
		g_days_select = -1;
		g_blood_select = -1;
		putEntryDaughterObj();
	}
}

// -------------------------------------
//  a̒
// -------------------------------------
static void dayControl(int in_num)
{
	if (in_num == 0)
	{
		// ̒a
		if (g_birth_m == 0)
			g_birth_m = 12;
		else
		if (g_birth_m == 13)
			g_birth_m = 1;
		if (g_birth_m < 4)
			g_birth_y = 90;
		else
			g_birth_y = 89;
		if (g_birth_d == 0)
			g_birth_d = getMaxday(g_birth_m);
		else
		if (g_birth_d > getMaxday(g_birth_m))
			g_birth_d = 1;
	} else {
		// pp̒a
		if (g_fbirth_y > 200)
			g_fbirth_y += 80;
		else
		if (g_fbirth_y > 79)
			g_fbirth_y -= 80;
		if (g_fbirth_m == 0)
			g_fbirth_m = 12;
		else
		if (g_fbirth_m == 13)
			g_fbirth_m = 1;
		if (g_fbirth_d == 0)
			g_fbirth_d = getMaxday(g_fbirth_m);
		else
		if (g_fbirth_d > getMaxday(g_fbirth_m))
			g_fbirth_d = 1;
	}
}

// -------------------------------------
//  aEt^̂nai\
// -------------------------------------
static void putEntryDaughterObj(void)
{
	u8 i;

	if (g_key_input != 0 && g_key_mode == 0)
		setObjData(SUB_OBJ, (void *)g_birth_2_oam, 5);
	else
		setObjData(SUB_OBJ, (void *)g_birth_1_oam, 5);
	if (g_key_input != 0 && g_key_mode == 1)
		setObjData(SUB_OBJ+5, (void *)g_blood_2_oam, 6);
	else
		setObjData(SUB_OBJ+5, (void *)g_blood_1_oam, 6);
	if (g_next_select == 0)
		setObjData(SUB_OBJ+11, (void *)g_back_2_oam, 1);
	else
		setObjData(SUB_OBJ+11, (void *)g_back_1_oam, 1);
	if (g_next_select == 1)
		setObjData(SUB_OBJ+12, (void *)g_next_2_oam, 1);
	else
		setObjData(SUB_OBJ+12, (void *)g_next_1_oam, 1);
	setObjData(SUB_OBJ+13, (void *)g_suuji_1a_oam, 3);
	if (g_birth_y == 89)
		setObjData(SUB_OBJ+16, (void *)&g_suuji_1a_oam[3], 1);
	else
		setObjDataChar(SUB_OBJ+16, (void *)&g_suuji_1a_oam[3], 1, 4);
	if (g_key_input != 0 && g_key_mode == 0 && g_key_select == 0)
	{
		if (g_birth_m >= 10)
			setObjData(SUB_OBJ+17, (void *)&g_suuji_1b_oam[4], 1);
		else
			clearObjData(SUB_OBJ+17);
		setObjDataChar(SUB_OBJ+18, (void *)&g_suuji_1b_oam[5], 1, (g_birth_m % 10) * 4);
	} else {
		if (g_birth_m >= 10)
			setObjData(SUB_OBJ+17, (void *)&g_suuji_1a_oam[4], 1);
		else
			clearObjData(SUB_OBJ+17);
		setObjDataChar(SUB_OBJ+18, (void *)&g_suuji_1a_oam[5], 1, (g_birth_m % 10) * 4);
	}
	if (g_key_input != 0 && g_key_mode == 0 && g_key_select == 1)
	{
		if (g_birth_d >= 10)
			setObjDataChar(SUB_OBJ+19, (void *)&g_suuji_1b_oam[6], 1, (g_birth_d / 10) * 4);
		else
			clearObjData(SUB_OBJ+19);
		setObjDataChar(SUB_OBJ+20, (void *)&g_suuji_1b_oam[7], 1, (g_birth_d % 10) * 4);
	} else {
		if (g_birth_d >= 10)
			setObjDataChar(SUB_OBJ+19, (void *)&g_suuji_1a_oam[6], 1, (g_birth_d / 10) * 4);
		else
			clearObjData(SUB_OBJ+19);
		setObjDataChar(SUB_OBJ+20, (void *)&g_suuji_1a_oam[7], 1, (g_birth_d % 10) * 4);
	}
	for (i=0; i<4; i++)
	{
		if (g_days_select == i || (g_days_select == 4 && i < 2) || (g_days_select == 5 && i >= 2))
			setObjData(SUB_OBJ+21+i, (void *)&g_selecter_1b_oam[i], 1);
		else
			setObjData(SUB_OBJ+21+i, (void *)&g_selecter_1a_oam[i], 4);
	}
	if (g_blood_select == -1)
		clearObjDatas(SUB_OBJ+25, 4);
	else
		setObjDataPos(SUB_OBJ+25, (void *)g_selecter_1c_oam, 4, 52+g_blood_select*40, 96);
	for (i=0; i<4; i++)
	{
		if (g_blood == i)
			setObjData(SUB_OBJ+29+i, (void *)&g_blood_4_oam[i], 1);
		else
			setObjData(SUB_OBJ+29+i, (void *)&g_blood_3_oam[i], 1);
	}
}

// -------------------------------------
// O͂ɖ߂
// -------------------------------------
static void cancelToEntryName(void)
{
	g_next_select = 0;
	putEntryDaughterObj();
	g_wait = 4;
	g_step = ENTRY_MODE_DAUGHTER_TO_NAME;
}

// -------------------------------------
//  O͂ֈڍs
// -------------------------------------
static void toEntryName(void)
{
	if (g_wait > 0)
	{
		g_wait--;
		if (g_wait == 0)
		{
			clearObjData(ALL_SUB_OBJ);
			setObjData(SUB_OBJ, (void *)g_entry_2_oam, 5);
			setObjDataPos(SUB_OBJ+9, (void *)g_father_name_oam, 6, 134, 30);
			setObjDataPos(SUB_OBJ+15, (void *)g_daughter_name_oam, 6, 40, 30);
			setBgMode(PLANE_SUB_BG2, VRAM_BG_CHARBASE_0x08000, VRAM_BG_SCRBASE_0x1800, BG_SCRSIZE_256x256, COLOR_MODE_16);
			g_count = 16;
			setAlpha(PLANE_SUB_BG1, PLANE_SUB_BG2|PLANE_SUB_BG3|PLANE_SUB_OBJ, 16);
			if (g_kana_mode == 0)
				setVisible(PLANE_SUB_BG2, 1);
			else
				setVisible(PLANE_SUB_BG3, 1);
		}
		return;
	}
	g_count--;
	setAlpha(PLANE_SUB_BG1, PLANE_SUB_BG2|PLANE_SUB_BG3|PLANE_SUB_OBJ, g_count);
	if (g_count == 0)
	{
		setVisible(PLANE_SUB_BG1, 0);
		setAlpha(PLANE_SUB_BG, 0, ALPHA_OFF);

		initTouchPenData();
		if (g_kana_mode == 0)
		{
			// Ђ炪
			setTouchPenData(_ENTRY_A_TPD);
			setTouchPenKeyDecide(PAD_BUTTON_L, 82);
			setTouchPenKeyDecide(PAD_BUTTON_R, 82);
			setTouchPenKeyDecide(PAD_BUTTON_SELECT, 82);
		} else {
			// J^Ji
			setTouchPenData(_ENTRY_B_TPD);
			setTouchPenKeyDecide(PAD_BUTTON_L, 81);
			setTouchPenKeyDecide(PAD_BUTTON_R, 81);
			setTouchPenKeyDecide(PAD_BUTTON_SELECT, 81);
		}
		setTouchPenKeyDecide(PAD_BUTTON_B, 83);
		setTouchPenKeySelect(PAD_BUTTON_START, 84);
		setTouchPenDoubleMove(TRUE);

		g_name_input = g_daughter_name_len;
		if (g_name_input == 6)
			g_name_input = 5;
		g_step = ENTRY_MODE_NAME_MAIN;
	}
}

// -------------------------------------
// NEaݒɈڍs
// -------------------------------------
static void setToEntryFather(void)
{
	g_wait = 15;
	g_step = ENTRY_MODE_DAUGHTER_TO_FATHER;
}

// -------------------------------------
// NEaݒɈڍs
// -------------------------------------
static void toEntryFather(void)
{
	if (g_wait > 0)
	{
		g_wait--;
		if (g_wait == 0)
		{
			//clearObjData(ALL_SUB_OBJ);
			setBgMode(PLANE_SUB_BG2, VRAM_BG_CHARBASE_0x10000, VRAM_BG_SCRBASE_0x3000, BG_SCRSIZE_256x256, COLOR_MODE_16);
			setBgPrio(PLANE_SUB_BG2, 0);
			g_count = 0;
			setAlpha(PLANE_SUB_BG2, PLANE_SUB_BG1|PLANE_SUB_OBJ, 0);
			setVisible(PLANE_SUB_BG2, 1);
		}
		return;
	}
	g_count++;
	setAlpha(PLANE_SUB_BG2, PLANE_SUB_BG1|PLANE_SUB_OBJ, g_count);
	if (g_count == 16)
	{
		clearObjData(ALL_SUB_OBJ);
		setVisible(PLANE_SUB_BG1, 0);
		setAlpha(PLANE_SUB_BG, 0, ALPHA_OFF);
		setBgPrioReq(PLANE_SUB_BG2, 2);

		g_days_select = -1;
		g_next_select = -1;
		g_tp_repeat = 0;
		g_tp_count = 0;
		g_key_input = 0;
		g_key_mode = 0;
		g_key_select = 0;

		setMainObj();
		putEntryFatherObj();

		initTouchPenData();
		setTouchPenData(_ENTRY_D_TPD);
		setTouchPenUseKey(FALSE);

		g_step = ENTRY_MODE_FATHER_MAIN;
	}
}

// -------------------------------------
// NEaݒ
// -------------------------------------
static void mainEntryFather(void)
{
	s16 select, selold, decide;
	u16 m, pad, rep;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	m = getTouchMode();
	pad = getPad();
	rep = getPadRep();
	if (decide != -1)
	{
		g_key_input = 0;
		if (decide == 8)
		{
			// ߂
			cancelToEntryDaughter();
		} else
		if (decide == 9)
		{
			// mF
			setMainObj();
			if (g_movie_mode == 0)
				setDialog(ENTRY_DIALOG_SKIP);
			else
				setDialog(ENTRY_DIALOG_CONFIRM);
		} else {
			if (g_tp_repeat < 45)
			{
				if (decide == 0)
					g_fbirth_y -= 10;
				else
				if (decide == 1)
					g_fbirth_y += 10;
				else
				if (decide == 2)
					g_fbirth_y--;
				else
				if (decide == 3)
					g_fbirth_y++;
				else
				if (decide == 4)
					g_fbirth_m++;
				else
				if (decide == 5)
					g_fbirth_m--;
				else
				if (decide == 6)
					g_fbirth_d++;
				else
				if (decide == 7)
					g_fbirth_d--;
				dayControl(1);
				g_days_select = -1;
			}
			g_tp_repeat = 0;
			putEntryFatherObj();
			setMainObj();
		}
	} else
	if (select != selold)
	{
		if (select != -1)
		{
			g_key_input = 0;
			playSE(SE_01);
		}
		if (select < 8)
			g_days_select = select;
		else
			g_days_select = -1;
		if (select == 8)
			g_next_select = 0;
		else
		if (select == 9)
			g_next_select = 1;
		else
			g_next_select = -1;
		g_tp_repeat = 0;
		putEntryFatherObj();
	} else
	if (select != -1 && select < 8)
	{
		g_key_input = 0;
		if (g_tp_repeat < 45)
		{
			g_tp_repeat++;
			if (g_tp_repeat == 45)
				g_tp_count = 0;
		} else {
			g_tp_count++;
			if (g_tp_count >= 6)
			{
				g_tp_count = 0;
				if (select == 0)
					g_fbirth_y -= 10;
				else
				if (select == 1)
					g_fbirth_y += 10;
				else
				if (select == 2)
					g_fbirth_y--;
				else
				if (select == 3)
					g_fbirth_y++;
				else
				if (select == 4)
					g_fbirth_m++;
				else
				if (select == 5)
					g_fbirth_m--;
				else
				if (select == 6)
					g_fbirth_d++;
				else
				if (select == 7)
					g_fbirth_d--;
				dayControl(1);
				putEntryFatherObj();
				setMainObj();
				playSE(SE_01);
			}
		}
	} else
	if (m == TOUCH_PEN_NONE)
	{
		// ^b`yŐGĂȂ΃L[͂
		if (rep & PAD_BUTTON_START)
		{
			// mF
			g_next_select = 1;
			setMainObj();
			putEntryFatherObj();
			if (g_movie_mode == 0)
				setDialog(ENTRY_DIALOG_SKIP);
			else
				setDialog(ENTRY_DIALOG_CONFIRM);
		} else
		if (g_key_input == 0)
		{
			if (rep & (PAD_KEY_UP|PAD_KEY_DOWN|PAD_KEY_LEFT|PAD_KEY_RIGHT|PAD_BUTTON_A|PAD_BUTTON_START|PAD_BUTTON_SELECT))
			{
				g_key_input = 1;
				g_days_select = (s16)(g_key_select + 8);
				playSE(SE_01);
				putEntryFatherObj();
			} else
			if (rep & PAD_BUTTON_B)
			{
				// ߂
				cancelToEntryDaughter();
			}
		} else
		if (g_key_mode == 0)
		{
			// N
			if (rep & (PAD_BUTTON_A|PAD_BUTTON_SELECT))
			{
				// ͂ɂ
				g_key_mode = 1;
				g_key_select = 2;
				g_days_select = 10;
				playSE(SE_01);
				putEntryFatherObj();
			} else
			if (rep & PAD_BUTTON_B)
			{
				// ߂
				cancelToEntryDaughter();
			} else
			if (rep & PAD_KEY_UP)
			{
				if (g_key_select == 0)
					g_fbirth_y -= 10;
				else
					g_fbirth_y--;
				dayControl(1);
				playSE(SE_01);
				putEntryFatherObj();
				setMainObj();
			} else
			if (rep & PAD_KEY_DOWN)
			{
				if (g_key_select == 0)
					g_fbirth_y += 10;
				else
					g_fbirth_y++;
				dayControl(1);
				playSE(SE_01);
				putEntryFatherObj();
				setMainObj();
			} else
			if (rep & PAD_KEY_LEFT)
			{
				g_key_select = 0;
				g_days_select = 8;
				putEntryFatherObj();
				playSE(SE_01);
			} else
			if (rep & PAD_KEY_RIGHT)
			{
				g_key_select = 1;
				g_days_select = 9;
				putEntryFatherObj();
				playSE(SE_01);
			}
		} else
		if (g_key_mode == 1)
		{
			// 
			if (rep & PAD_BUTTON_A)
			{
				// mF
				g_next_select = 1;
				setMainObj();
				putEntryFatherObj();
				if (g_movie_mode == 0)
					setDialog(ENTRY_DIALOG_SKIP);
				else
					setDialog(ENTRY_DIALOG_CONFIRM);
			} else
			if (rep & (PAD_BUTTON_B|PAD_BUTTON_SELECT))
			{
				// N͂ɂ
				g_key_mode = 0;
				g_key_select = 0;
				g_days_select = 8;
				playSE(SE_01);
				putEntryFatherObj();
			} else
			if (rep & PAD_KEY_UP)
			{
				if (g_key_select == 2)
					g_fbirth_m++;
				else
					g_fbirth_d++;
				dayControl(1);
				playSE(SE_01);
				putEntryFatherObj();
				setMainObj();
			} else
			if (rep & PAD_KEY_DOWN)
			{
				if (g_key_select == 2)
					g_fbirth_m--;
				else
					g_fbirth_d--;
				dayControl(1);
				playSE(SE_01);
				putEntryFatherObj();
				setMainObj();
			} else
			if (rep & PAD_KEY_LEFT)
			{
				g_key_select = 2;
				g_days_select = 10;
				putEntryFatherObj();
				playSE(SE_01);
			} else
			if (rep & PAD_KEY_RIGHT)
			{
				g_key_select = 3;
				g_days_select = 11;
				putEntryFatherObj();
				playSE(SE_01);
			}
		}
	} else
	if (g_key_input != 0)
	{
		g_key_input = 0;
		g_days_select = -1;
		putEntryFatherObj();
	}
}

// -------------------------------------
// ݒɖ߂
// -------------------------------------
static void backToEntryDaughter(void)
{
	if (g_wait > 0)
	{
		g_wait--;
		if (g_wait == 0)
		{
			g_count = 0;
			//clearObjData(ALL_SUB_OBJ);
			setAlpha(PLANE_SUB_BG1, PLANE_SUB_BG2|PLANE_SUB_OBJ, 0);
			setBgPrio(PLANE_SUB_BG1, 0);
			setVisible(PLANE_SUB_BG1, 1);
		}
		return;
	}
	g_count++;
	setAlpha(PLANE_SUB_BG1, PLANE_SUB_BG2|PLANE_SUB_OBJ, g_count);
	if (g_count == 16)
	{
		clearObjData(ALL_SUB_OBJ);
		setVisible(PLANE_SUB_BG2, 0);
		setAlpha(PLANE_SUB_BG, 0, ALPHA_OFF);
		setBgPrioReq(PLANE_SUB_BG1, 1);

		g_blood_select = -1;
		g_days_select = -1;
		g_next_select = -1;
		g_tp_repeat = 0;
		g_tp_count = 0;
		g_key_input = 0;
		g_key_mode = 0;
		g_key_select = 0;

		putEntryDaughterObj();

		initTouchPenData();
		setTouchPenData(_ENTRY_C_TPD);
		setTouchPenUseKey(FALSE);

		g_step = ENTRY_MODE_DAUGHTER_MAIN;
	}
}

// -------------------------------------
//  NEânai\
// -------------------------------------
static void putEntryFatherObj(void)
{
	if (g_key_input != 0 && g_key_mode == 0)
		setObjData(SUB_OBJ, (void *)g_nenrei_2_oam, 6);
	else
		setObjData(SUB_OBJ, (void *)g_nenrei_1_oam, 6);
	if (g_key_input != 0 && g_key_mode == 1)
		setObjData(SUB_OBJ+6, (void *)g_tanjoubi_2_oam, 6);
	else
		setObjData(SUB_OBJ+6, (void *)g_tanjoubi_1_oam, 6);
	if (g_next_select == 0)
		setObjData(SUB_OBJ+12, (void *)g_back_2_oam, 1);
	else
		setObjData(SUB_OBJ+12, (void *)g_back_1_oam, 1);
	if (g_next_select == 1)
		setObjData(SUB_OBJ+13, (void *)g_next_2_oam, 1);
	else
		setObjData(SUB_OBJ+13, (void *)g_next_1_oam, 1);
	if (g_key_input != 0 && g_key_mode == 0 && g_key_select == 0)
		setObjDataChar(SUB_OBJ+14, (void *)&g_suuji_2b_oam[0], 1, ((g_now_y - g_fbirth_y) / 10) * 4);
	else
		setObjDataChar(SUB_OBJ+14, (void *)&g_suuji_2a_oam[0], 1, ((g_now_y - g_fbirth_y) / 10) * 4);
	if (g_key_input != 0 && g_key_mode == 0 && g_key_select == 1)
		setObjDataChar(SUB_OBJ+15, (void *)&g_suuji_2b_oam[1], 1, ((g_now_y - g_fbirth_y) % 10) * 4);
	else
		setObjDataChar(SUB_OBJ+15, (void *)&g_suuji_2a_oam[1], 1, ((g_now_y - g_fbirth_y) % 10) * 4);
	setObjData(SUB_OBJ+16, (void *)g_suuji_3a_oam, 1);
	setObjDataChar(SUB_OBJ+17, (void *)&g_suuji_3a_oam[1], 1, (((1341 + g_fbirth_y) / 100) % 10) * 4);
	setObjDataChar(SUB_OBJ+18, (void *)&g_suuji_3a_oam[2], 1, (((1341 + g_fbirth_y) / 10) % 10) * 4);
	setObjDataChar(SUB_OBJ+19, (void *)&g_suuji_3a_oam[3], 1, ((1341 + g_fbirth_y) % 10) * 4);
	if (g_key_input != 0 && g_key_mode == 1 && g_key_select == 2)
	{
		if (g_fbirth_m >= 10)
			setObjData(SUB_OBJ+20, (void *)&g_suuji_3b_oam[4], 1);
		else
			clearObjData(SUB_OBJ+20);
		setObjDataChar(SUB_OBJ+21, (void *)&g_suuji_3b_oam[5], 1, (g_fbirth_m % 10) * 4);
	} else {
		if (g_fbirth_m >= 10)
			setObjData(SUB_OBJ+20, (void *)&g_suuji_3a_oam[4], 1);
		else
			clearObjData(SUB_OBJ+20);
		setObjDataChar(SUB_OBJ+21, (void *)&g_suuji_3a_oam[5], 1, (g_fbirth_m % 10) * 4);
	}
	if (g_key_input != 0 && g_key_mode == 1 && g_key_select == 3)
	{
		if (g_fbirth_d >= 10)
			setObjDataChar(SUB_OBJ+22, (void *)&g_suuji_3b_oam[6], 1, (g_fbirth_d / 10) * 4);
		else
			clearObjData(SUB_OBJ+22);
		setObjDataChar(SUB_OBJ+23, (void *)&g_suuji_3b_oam[7], 1, (g_fbirth_d % 10) * 4);
	} else {
		if (g_fbirth_d >= 10)
			setObjDataChar(SUB_OBJ+22, (void *)&g_suuji_3a_oam[6], 1, (g_fbirth_d / 10) * 4);
		else
			clearObjData(SUB_OBJ+22);
		setObjDataChar(SUB_OBJ+23, (void *)&g_suuji_3a_oam[7], 1, (g_fbirth_d % 10) * 4);
	}
	if (g_days_select == 0 || g_days_select == 8)
		setObjData(SUB_OBJ+24, (void *)&g_selecter_2b_oam[0], 1);
	else
		setObjData(SUB_OBJ+24, (void *)&g_selecter_2a_oam[0], 1);
	if (g_days_select == 1 || g_days_select == 8)
		setObjData(SUB_OBJ+25, (void *)&g_selecter_2b_oam[1], 1);
	else
		setObjData(SUB_OBJ+25, (void *)&g_selecter_2a_oam[1], 1);
	if (g_days_select == 2 || g_days_select == 9)
		setObjData(SUB_OBJ+26, (void *)&g_selecter_2b_oam[2], 1);
	else
		setObjData(SUB_OBJ+26, (void *)&g_selecter_2a_oam[2], 1);
	if (g_days_select == 3 || g_days_select == 9)
		setObjData(SUB_OBJ+27, (void *)&g_selecter_2b_oam[3], 1);
	else
		setObjData(SUB_OBJ+27, (void *)&g_selecter_2a_oam[3], 1);
	if (g_days_select == 4 || g_days_select == 10)
		setObjData(SUB_OBJ+28, (void *)&g_selecter_2b_oam[4], 1);
	else
		setObjData(SUB_OBJ+28, (void *)&g_selecter_2a_oam[4], 1);
	if (g_days_select == 5 || g_days_select == 10)
		setObjData(SUB_OBJ+29, (void *)&g_selecter_2b_oam[5], 1);
	else
		setObjData(SUB_OBJ+29, (void *)&g_selecter_2a_oam[5], 1);
	if (g_days_select == 6 || g_days_select == 11)
		setObjData(SUB_OBJ+30, (void *)&g_selecter_2b_oam[6], 1);
	else
		setObjData(SUB_OBJ+30, (void *)&g_selecter_2a_oam[6], 1);
	if (g_days_select == 7 || g_days_select == 11)
		setObjData(SUB_OBJ+31, (void *)&g_selecter_2b_oam[7], 1);
	else
		setObjData(SUB_OBJ+31, (void *)&g_selecter_2a_oam[7], 1);
}

// -------------------------------------
// ̐ݒɖ߂
// -------------------------------------
static void cancelToEntryDaughter(void)
{
	g_next_select = 0;
	putEntryFatherObj();
	g_wait = 4;
	g_step = ENTRY_MODE_FATHER_TO_DAUGHTER;
}


// -------------------------------------
//  _CAOֈڍs
// -------------------------------------
static void setDialog(u8 in_num)
{
	if (getTouchPenSelect() != -1)
		g_dialog_select = getTouchPenSelect();
	g_dialog_num = in_num;
	switch (in_num)
	{
		case ENTRY_DIALOG_TITLE:		// ^Cgɖ߂܂H
			setScrBlock(PLANE_SUB_BG0, VRAM_BG_SCRBASE_0x0000);
			break;
		case ENTRY_DIALOG_SKIP:			// [r[XLbv
			setScrBlock(PLANE_SUB_BG0, VRAM_BG_SCRBASE_0x0800);
			break;
		case ENTRY_DIALOG_CONFIRM:		// łł
			setScrBlock(PLANE_SUB_BG0, VRAM_BG_SCRBASE_0x1000);
			break;
	}
	g_dialog_count = 0;
	setAlpha(PLANE_SUB_BG0, PLANE_SUB_BG1|PLANE_SUB_BG2|PLANE_SUB_BG3|PLANE_SUB_OBJ, 0);
	setVisible(PLANE_SUB_BG0, 1);

	setFadeSystem(FADE_SUB_BG, 0x0c, FALSE);
	setFadeSystem(FADE_SUB_BG, 0x0d, FALSE);
	setFadeSystem(FADE_SUB_BG, 0x0e, FALSE);
	setFadeSystem(FADE_SUB_BG, 0x0f, FALSE);
	setFadeSystem(FADE_SUB_OBJ, 0x0a, FALSE);
	setFade(FADE_SUB_BG|FADE_SUB_OBJ, FADE_BLACK_HALF, 30);

	g_step = ENTRY_MODE_TO_DIALOG;
}


// -------------------------------------
//  _CAO
// -------------------------------------
static void toDialog(void)
{
	g_dialog_count++;
	setAlpha(PLANE_SUB_BG0, PLANE_SUB_BG1|PLANE_SUB_BG2|PLANE_SUB_BG3|PLANE_SUB_OBJ, g_dialog_count);
	if (g_dialog_count == 16)
	{
		if (g_dialog_num == ENTRY_DIALOG_TITLE)
		{
			clearObjDatas(SUB_OBJ+7, 2);
		} else {
			g_next_select = -1;
			putEntryFatherObj();
		}
		initTouchPenData();
		setTouchPenData(_ENTRY_DIALOG_TPD);
		setTouchPenKeyDecide(PAD_BUTTON_B, 1);
		setTouchPenKeySelectPos(1);

		setAlpha(PLANE_SUB_BG, 0, ALPHA_OFF);
		g_step = ENTRY_MODE_DIALOG_MAIN;
	}
	if (g_dialog_num == ENTRY_DIALOG_TITLE)
	{
		// ܂Ńpbg
		g_cursor_wait--;
		if (g_cursor_wait == 0)
		{
			g_cursor_wait = 4;
			g_cursor_pal++;
			if (g_cursor_pal == 7)
				g_cursor_pal = 0;
			setFileToPalette(VRAM_SUB_OBJ_PAL, 0, _ENTRY_OBJ_ANIM_PAL, g_cursor_pal, 1);
		}
	}
}

// -------------------------------------
//  _CAO
// -------------------------------------
static void mainDialog(void)
{
	s16 select, selold, decide;

	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	decide = getTouchPenDecide();
	if (decide == 0)
	{
		playSE(SE_02);
		g_dialog_decide = 0;
		g_dialog_wait = 0;
		g_step = ENTRY_MODE_DIALOG_DECIDE;
	} else
	if (decide == 1)
	{
		playSE(SE_03);
		g_dialog_decide = 1;
		g_dialog_wait = 0;
		g_step = ENTRY_MODE_DIALOG_DECIDE;
	} else
	if (select != selold)
	{
		if (select != -1)
			playSE(SE_01);
		if (select == 0)
			setObjData(SUB_OBJ+64, (void *)g_dialog_yes_oam, 1);
		else
		if (select == 1)
			setObjData(SUB_OBJ+64, (void *)g_dialog_no_oam, 1);
		else
			clearObjData(SUB_OBJ+64);
	}
}

// -------------------------------------
//  _CAO
// -------------------------------------
static void decideDialog(void)
{
	int i;

	g_dialog_wait++;
	if (g_dialog_wait % 8 == 0)
	{
		clearObjData(SUB_OBJ+64);
	} else
	if (g_dialog_wait % 4 == 0)
	{
		if (g_dialog_decide == 0)
			setObjData(SUB_OBJ+64, (void *)g_dialog_yes_oam, 1);
		else
			setObjData(SUB_OBJ+64, (void *)g_dialog_no_oam, 1);
	} else
	if (g_dialog_wait > 20)
	{
		if (g_dialog_decide == 0)
		{
			// u͂v͏󋵂ɂċقȂ
			switch (g_dialog_num)
			{
				case ENTRY_DIALOG_TITLE:		// ^Cgɖ߂܂H
					// ^Cgɖ߂
					if (g_movie_mode == 0)
					{
						// [r[Đ
						//setObjData(MAIN_OBJ, (void *)g_black_wall_oam, 12);
						setFade(FADE_SUB_BG|FADE_SUB_OBJ, FADE_WHITE, 60);
						//setVisible(PLANE_MAIN_OBJ, 1);
						setAlpha(0, PLANE_MAIN_BG2|PLANE_MAIN_BG3, 0);
					} else {
						// ʕ\
						setFade(FADE_MAIN_BG|FADE_MAIN_OBJ, FADE_WHITE, 60);
					}
					clearObjData(SUB_OBJ+64);
					setAlpha(PLANE_SUB_BG0, PLANE_SUB_BG1|PLANE_SUB_BG2|PLANE_SUB_BG3|PLANE_SUB_OBJ, 16);
					g_dialog_count = 0;
					g_next_mode = GAME_MODE_TITLE;
					g_step = ENTRY_MODE_END;
					break;
				case ENTRY_DIALOG_SKIP:			// [r[XLbv
					// [r[XLbvłł̂̊mF
					if (g_movie_mode == 0)
					{
						// [r[Đ
						//setObjData(MAIN_OBJ, (void *)g_black_wall_oam, 12);
						setFade(FADE_SUB_BG|FADE_SUB_OBJ, FADE_WHITE, 60);
						//setVisible(PLANE_MAIN_OBJ, 1);
						setAlpha(0, PLANE_MAIN_BG2|PLANE_MAIN_BG3, 0);
					}
					g_dialog_count = 16;
					setAlpha(PLANE_SUB_BG0, PLANE_SUB_BG1|PLANE_SUB_BG2|PLANE_SUB_BG3|PLANE_SUB_OBJ, 16);
					setFade(FADE_SUB_BG|FADE_SUB_OBJ, FADE_NORMAL, 30);
					clearObjData(SUB_OBJ+64);
					g_step = ENTRY_MODE_DIALOG_WAIT;
					break;
				case ENTRY_DIALOG_CONFIRM:		// łł
					// ݒۑ
					for (i=0; i<6; i++)
					{
						if (g_father_name[i*2+0] == g_underbar[0] && g_father_name[i*2+1] == g_underbar[1])
						{
							g_father_name[i*2+0] = 0;
							g_father_name[i*2+1] = 0;
						}
						if (g_daughter_name[i*2+0] == g_underbar[0] && g_daughter_name[i*2+1] == g_underbar[1])
						{
							g_daughter_name[i*2+0] = 0;
							g_daughter_name[i*2+1] = 0;
						}
					}
					setName(1, g_father_name);
					setName(0, g_daughter_name);
					setBlood(g_blood);
					setBirth(g_birth_y, g_birth_m, g_birth_d);
					setFBirth(g_fbirth_y, g_fbirth_m, g_fbirth_d);
					initParam();
					clearObjData(SUB_OBJ+64);
					setAlpha(PLANE_SUB_BG0, PLANE_SUB_BG1|PLANE_SUB_BG2|PLANE_SUB_BG3|PLANE_SUB_OBJ, 16);
					g_dialog_count = 0;
					setFade(FADE_MAIN_BG|FADE_MAIN_OBJ|FADE_SUB_BG|FADE_SUB_OBJ, FADE_WHITE, 60);
					g_next_mode = GAME_MODE_ROOM;
					g_step = ENTRY_MODE_END;
					break;
			}
		} else {
			// uv͒ʏ̏ɖ߂邾
			g_dialog_count = 16;
			setAlpha(PLANE_SUB_BG0, PLANE_SUB_BG1|PLANE_SUB_BG2|PLANE_SUB_BG3|PLANE_SUB_OBJ, 16);
			setFade(FADE_SUB_BG|FADE_SUB_OBJ, FADE_NORMAL, 30);
			clearObjData(SUB_OBJ+64);
			g_step = ENTRY_MODE_FROM_DIALOG;
		}
	}
}

// -------------------------------------
//  _CAO
// -------------------------------------
static void fromDialog(void)
{
	g_dialog_count -= 2;
	setAlpha(PLANE_SUB_BG0, PLANE_SUB_BG1|PLANE_SUB_BG2|PLANE_SUB_BG3|PLANE_SUB_OBJ, g_dialog_count);
	if (g_dialog_count == 0)
	{
		clearObjData(SUB_OBJ+64);
		setVisible(PLANE_SUB_BG0, 0);
		setAlpha(PLANE_SUB_BG, 0, ALPHA_OFF);
		setFadeSystem(FADE_SUB_BG, 0x0c, TRUE);
		setFadeSystem(FADE_SUB_BG, 0x0d, TRUE);
		setFadeSystem(FADE_SUB_BG, 0x0e, TRUE);
		setFadeSystem(FADE_SUB_BG, 0x0f, TRUE);
		setFadeSystem(FADE_SUB_OBJ, 0x0a, TRUE);
		switch (g_dialog_num)
		{
			case ENTRY_DIALOG_TITLE:		// ^Cgɖ߂܂H
				// ͂ɖ߂
				if (g_kana_mode == 0)
				{
					// Ђ炪
					initTouchPenData();
					setTouchPenData(_ENTRY_A_TPD);
					setTouchPenKeyDecide(PAD_BUTTON_L, 82);
					setTouchPenKeyDecide(PAD_BUTTON_R, 82);
					setTouchPenKeyDecide(PAD_BUTTON_SELECT, 82);
				} else {
					// J^Ji
					setTouchPenData(_ENTRY_B_TPD);
					setTouchPenKeyDecide(PAD_BUTTON_L, 81);
					setTouchPenKeyDecide(PAD_BUTTON_R, 81);
					setTouchPenKeyDecide(PAD_BUTTON_SELECT, 81);
				}
				setTouchPenKeyDecide(PAD_BUTTON_B, 83);
				setTouchPenKeySelect(PAD_BUTTON_START, 84);
				setTouchPenDoubleMove(TRUE);
				if (g_dialog_select != -1)
					setTouchPenKeySelectPos(g_dialog_select);
				g_step = ENTRY_MODE_NAME_MAIN;
				break;
			case ENTRY_DIALOG_SKIP:			// [r[XLbv
			case ENTRY_DIALOG_CONFIRM:		// łł
				// ppݒ͂ɖ߂
				initTouchPenData();
				setTouchPenData(_ENTRY_D_TPD);
				setTouchPenUseKey(FALSE);

				g_step = ENTRY_MODE_FATHER_MAIN;
				break;
		}
	}
}

// -------------------------------------
//  
// -------------------------------------
static void waitDialog(void)
{
	if (g_dialog_count > 0)
	{
		g_dialog_count--;
		setAlpha(PLANE_SUB_BG0, PLANE_SUB_BG1|PLANE_SUB_BG2|PLANE_SUB_BG3|PLANE_SUB_OBJ, g_dialog_count);
		setAlpha(0, PLANE_MAIN_BG2|PLANE_MAIN_BG3, 16-g_dialog_count);
		if (g_dialog_count == 0)
		{
			stopMovie();
			execMainScreen();
		}
	}
	if (!isFade(FADE_SUB_BG))
		setDialog(ENTRY_DIALOG_CONFIRM);
}
// -------------------------------------
//  I
// -------------------------------------
static void endEntry(void)
{
	if (g_dialog_count < 16*3)
	{
		g_dialog_count++;
		setAlpha(PLANE_SUB_BG0, PLANE_SUB_BG1|PLANE_SUB_BG2|PLANE_SUB_BG3|PLANE_SUB_OBJ, 16-(g_dialog_count/3));
		if (g_movie_mode == 0)
		{
			// [r[Đ
			setAlpha(0, PLANE_MAIN_BG2|PLANE_MAIN_BG3, g_dialog_count/3);
			if (g_dialog_count == 16*3)
				stopMovie();
		}
	}
	if (!isFade(FADE_SUB_BG))
	{
		setFadeSystem(FADE_SUB_BG, 0x0c, TRUE);
		setFadeSystem(FADE_SUB_BG, 0x0d, TRUE);
		setFadeSystem(FADE_SUB_BG, 0x0e, TRUE);
		setFadeSystem(FADE_SUB_BG, 0x0f, TRUE);
		setFadeSystem(FADE_SUB_OBJ, 0x0a, TRUE);
		changeGameMode(g_next_mode);
	}
}
