//---------------------------------------------------------------------------
//
// n |p
//
//---------------------------------------------------------------------------
#include <nitro.h>
#include "bds_lib.h"
#include "pack_data.h"
#include "game.h"
#include "ha03.h"
#include "ha01.h"
#include "fe00.h"
#include "graph.h"
#include "prime4.h"
#include "event_grp.h"
#include "script.h"
#include "schedule.h"
#include "sound_data.h"
#include "item.h"
#include "def/fe00_def.h"
#include "def/fe01_def.h"
#include "def/fe03_def.h"

// -------------------------------------
// 萔`
// -------------------------------------

// -------------------------------------
// NXE\̒`
// -------------------------------------
// -------------------------------------
// [Jϐ`
// -------------------------------------

static int
	ha03RankParamTbl[] = 
	{
	//       
		 55, 45, 40,			// QN
		 90, 85, 55,			// RN
		125,117, 75,			// SN
		132,128, 90,			// TN
		140,135,100,			// UN
		152,145,120,			// VN
		170,155,135				// WN
	};
static u8
	ha03RankSetTbl[] = 
	{
		btcMA, btcKA, btcCL,	// 0
		btcMA, btcCL, btcKA,  	// 1
		btcMA, btcKA, btcCL,	// 2
		btcMA, btcCL, btcKA,  	// 3
		btcMA, btcKA, btcCL,	// 4
		btcMA, btcCL, btcKA,  	// 5
		btcMA, btcKA, btcCL,	// 6
		btcMA, btcCL, btcKA,  	// 7
		btcMA, btcKA, btcCL,	// 8
		btcMA, btcCL, btcKA,  	// 9
		btcKA, btcMA, btcCL,  	// 10
		btcCL, btcMA, btcKA,  	// 11
		btcKA, btcMA, btcCL,  	// 12
		btcCL, btcMA, btcKA,  	// 13
		btcKA, btcCL, btcMA,  	// 14
		btcCL, btcKA, btcMA  	// 15
	};

// -------------------------------------
// [J֐`
// -------------------------------------
static void ha03_000(void);
static void ha03_main(void);
static void ha3_rank_set(void);
static void ha03_001(void);
static void ha03_002(void);

//---------------------------------------------------------------------------
//
// ֐
//
//---------------------------------------------------------------------------
// -------------------------------------
//  
// -------------------------------------
void ha03(void)
{
	addParam(pR3, 500);		// }[

	setBGM(SEQ_PRM4_35);
	playBGM();				// nՂBGM

	setBgNum(BG_har_bg02);
	waitChangeGraph();
	waitOnly(30);
	setBgNum(BG_har_bg05);
	waitChangeGraph();
	waitOnly(60);

	// |pՊJňt
	setScript(_FE03_PSC, FE03_FE03_0);
	waitScript();

	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();

	ha03_000();			// Q̑䎌ij

	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();

	ha03_main();

	ha03_001();		// \
	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();

	fadeBGM(60);

	//-----------------------------------------
	// L[ȗ䎌iD̏ꍇADłȂꍇj
	setBgNum(BG_bgr000);	// #m_roomBg
	waitChangeGraph();
	if (getbtWinNo(0) == btcDA)
	{
		// D
		switch (getRandom() % 3)
		{
			case 0:
				setScript(_FE03_PSC, FE03_FE03_11);
				waitScript();
				break;
			case 1:
				setScript(_FE03_PSC, FE03_FE03_12);
				waitScript();
				break;
			case 2:
				setScript(_FE03_PSC, FE03_FE03_13);
				waitScript();
				break;
		}
	} else
	if (getbtWinNo(1) == btcDA || getbtWinNo(2) == btcDA)
	{
		setScript(_FE01_PSC, FE01_FE01_36);
		waitScript();
	} else {
		setScript(_FE01_PSC, FE01_FE01_35);
		waitScript();
	}
	//	#call{ fe00_56 }	// DłȂ
	// ͌\[XRgAEg

	RichAndFamous();	//܋ƒmx

	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setBgNum(BG_black);
	setChangeLock(FALSE);
	waitChangeGraph();
}

//--------------------------------------------------------------------
//
//--------------------------------------------------------------------
static void ha03_main(void)
{
	setChangeLock(TRUE);
	if (getRoomPic() == 2)
		setBgNum(BG_ge_bg02);
	else
	if (getRoomPic() == 3)
		setBgNum(BG_ge_bg03);
	else
		setBgNum(BG_ge_bg01);
	// l
	putGeijutsuAnim(TRUE);
	setChangeLock(FALSE);
	waitChangeGraph();
	waitOnly(30);

	setScript(_FE03_PSC, FE03_FE03_MAIN_01);
	waitScript();

	ha03_002();

	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();
	ha3_rank_set();

	putGeijutsuAnim(FALSE);
	waitChangeGraph();
	setScript(_FE03_PSC, FE03_FE03_MAIN_02);
	waitScript();
	//#spr.clear{ SPN_BT_SBG, efAlpha1s, 0 }
}

//--------------------------
// ܏ʂ߂
//--------------------------
static void ha3_rank_set(void)
{
	int val0, val1, index;

	val1 =(int)((getParam(pKANNJYU) / 30) + (getSchDays(jGeijyutu) / 5));
	if (getRoomPic() == 1)
		val1 += 30;		// `G̃xP
	else
	if (getRoomPic() == 2)
		val1 += 50;		// `G̃xQ
	else
	if (getRoomPic() == 3)
		val1 += 70;		// `G̃xR

	index = (getGameY()-1) * 3;
	val0 = (int)((getRandom() % 16) * 3);

	if (val1 >= ha03RankParamTbl[index])
	{
		setbtWinNo(0, btcDA);
		setbtWinNo(1, ha03RankSetTbl[val0]);
		setbtWinNo(2, ha03RankSetTbl[val0+1]);
	} else
	if (val1 >= ha03RankParamTbl[index+1])
	{
		setbtWinNo(1, btcDA);
		setbtWinNo(0, ha03RankSetTbl[val0]);
		setbtWinNo(2, ha03RankSetTbl[val0+1]);
	} else
	if (val1 >= ha03RankParamTbl[index+2])
	{
		setbtWinNo(2, btcDA);
		setbtWinNo(0, ha03RankSetTbl[val0]);
		setbtWinNo(1, ha03RankSetTbl[val0+1]);
	} else {
		setbtWinNo(0, ha03RankSetTbl[val0]);
		setbtWinNo(1, ha03RankSetTbl[val0+1]);
		setbtWinNo(2, ha03RankSetTbl[val0+2]);
	}
}


//--------------------------
// Q̑䎌
//--------------------------
static void ha03_000(void)
{
	if (getLabel(LF_ha03_000) == OFF)
	{
		if (getageWidth() == ageC)
			setScript(_FE03_PSC, FE03_FE03_1);
		else
		if (getageWidth() == ageL)
			setScript(_FE03_PSC, FE03_FE03_2);
		else
			setScript(_FE03_PSC, FE03_FE03_3);
		waitScript();
		setLabel(LF_ha03_000, ON);
	} else {
		if (getageWidth() == ageC)
			setScript(_FE03_PSC, FE03_FE03_4);
		else
		if (getageWidth() == ageL)
			setScript(_FE03_PSC, FE03_FE03_5);
		else
			setScript(_FE03_PSC, FE03_FE03_6);
		waitScript();
	}
}


//--------------------------
// I
//--------------------------
static void ha03_001(void)
{
	//#frame{ 1 } #frame.off
	//#call{ ha02_Victory_Frame_begin }
	bt_func_set_win_name();

	setBgNum(BG_har_bg02);		// wi
	waitChangeGraph();
	putResult23();
	waitChangeGraph();
	// 
	putResult3name();
	waitOnly(60);
	// 
	putResult2name();
	waitOnly(60);
	// 
	putResult1();
	waitChangeGraph();
	setScript(_FE03_PSC, FE03_FE03_10);
	waitScript();
	putResult1name();
	setScript(_FE03_PSC, FE03_FE03_10A);
	waitScript();

	// ̃gtB[^
	if (getbtWinNo(0) == btcDA)
	{
		if (getageWidth() == ageC)
			setBgNum(BG_ev44a);
		else
		if (getageWidth() == ageL)
			setBgNum(BG_ev44b);
		else
			setBgNum(BG_ev44c);
		waitChangeGraph();
		setScript(_FE03_PSC, FE03_HA03_001);
		waitScript();
	}

	// l̂t
	switch (getbtWinNo(0))
	{
		case btcDA:		// 
			if (getageWidth() == ageC)
				setScript(_FE03_PSC, FE03_FE03_26);
			else
			if (getageWidth() == ageL)
				setScript(_FE03_PSC, FE03_FE03_27);
			else
				setScript(_FE03_PSC, FE03_FE03_28);
			waitScript();
			break;

		case btcMA:
			if (getageWidth() == ageC)
				setScript(_FE03_PSC, FE03_FE03_29);
			else
			if (getageWidth() == ageL)
				setScript(_FE03_PSC, FE03_FE03_30);
			else
				setScript(_FE03_PSC, FE03_FE03_31);
			waitScript();
			break;

		case btcKA:
			if (getageWidth() == ageC)
				setScript(_FE00_PSC, FE00_FE00_80);
			else
			if (getageWidth() == ageL)
				setScript(_FE00_PSC, FE00_FE00_83);
			else
				setScript(_FE00_PSC, FE00_FE00_86);
			waitScript();
			break;

		case btcCL:
			if (getageWidth() == ageC)
				setScript(_FE00_PSC, FE00_FE00_107);
			else
			if (getageWidth() == ageL)
				setScript(_FE00_PSC, FE00_FE00_110);
			else
				setScript(_FE00_PSC, FE00_FE00_113);
			waitScript();
			break;

		default:
			;
	}
	fe00_conY();		// sǂ̏ꍇi͒łĂ܂j

	//-------------------------------
	// ȍ~Aƃ}[̉biKj
	//-------------------------------
	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setBgNum(BG_bg01);
	setChangeLock(FALSE);
	waitChangeGraph();

	if (getbtWinNo(0) == btcDA)
	{
		// D
		if (getageWidth() == ageC)
			setScript(_FE03_PSC, FE03_FE03_23);
		else
		if (getageWidth() == ageL)
			setScript(_FE03_PSC, FE03_FE03_24);
		else
			setScript(_FE03_PSC, FE03_FE03_25);
		waitScript();
	} else
	if (getbtWinNo(0) == btcMA)
	{
		// }[D
		if (getageWidth() == ageC)
			setScript(_FE03_PSC, FE03_FE03_17);
		else
		if (getageWidth() == ageL)
			setScript(_FE03_PSC, FE03_FE03_18);
		else
			setScript(_FE03_PSC, FE03_FE03_19);
		waitScript();
	} else {
		// A}[ɗDŖꍇ
		if (getageWidth() == ageC)
			setScript(_FE03_PSC, FE03_FE03_32);
		else
		if (getageWidth() == ageL)
			setScript(_FE03_PSC, FE03_FE03_33);
		else
			setScript(_FE03_PSC, FE03_FE03_34);
		waitScript();
	}
}

//--------------------------------------
// ̊GAbvɂȂAz
//--------------------------------------
static void ha03_002(void)
{
	// G
	putRoomPic(TRUE);
	waitChangeGraph();
	switch (getRandom() % 3)
	{
		case 0:
			setScript(_FE03_PSC, FE03_HA03_002_00);
			waitScript();
			setScript(_FE03_PSC, FE03_HA03_002_01);
			waitScript();
			setScript(_FE03_PSC, FE03_HA03_002_02);
			waitScript();
			break;
		case 1:
			setScript(_FE03_PSC, FE03_HA03_002_10);
			waitScript();
			setScript(_FE03_PSC, FE03_HA03_002_11);
			waitScript();
			setScript(_FE03_PSC, FE03_HA03_002_12);
			waitScript();
			break;
		case 2:
			setScript(_FE03_PSC, FE03_HA03_002_20);
			waitScript();
			setScript(_FE03_PSC, FE03_HA03_002_21);
			waitScript();
			setScript(_FE03_PSC, FE03_HA03_002_22);
			waitScript();
			break;
	}
	putRoomPic(FALSE);
	waitChangeGraph();
}

