//---------------------------------------------------------------------------
//
// n 
//
//---------------------------------------------------------------------------
#include <nitro.h>
#include "bds_lib.h"
#include "pack_data.h"
#include "game.h"
#include "ha01.h"
#include "fe00.h"
#include "graph.h"
#include "prime4.h"
#include "event_grp.h"
#include "script.h"
#include "schedule.h"
#include "sound_data.h"
#include "item.h"
#include "room.h"
#include "def/fe00_def.h"
#include "def/fe01_def.h"
#include "def/fe02_def.h"
#include "def/fe03_def.h"

// -------------------------------------
// 萔`
// -------------------------------------

// -------------------------------------
// NXE\̒`
// -------------------------------------
// -------------------------------------
// [Jϐ`
// -------------------------------------
static BOOL
	bt_exec_result;
static u8
	bt_vsLi,
	bt_EnfEnable,
	bt_Yoroi,
	haParam,
	sts[8];
static s8
	bt_tlist[8],
	bt_tstate[8],
	bt_at_type;
static s16
	btParamAT_OFS,		// ɂItZbgî݁j
	btParamDF_OFS,		// hɊւItZbgî݁j
	btParamMAT_OFS,		// @pAւItZbgî݁j
	btParamMDF_OFS,		// @pAւItZbgî݁j
	btEnemy,			// ł̓Gԍ
	btMyIndex,			// ł̖CfbNX
	btDamage,
	bt_EnfXps,
	bt_EnfYps,
	btParamHP[2],
	btParamAT[2],
	btParamDF[2],
	btParamMAT[2],
	btParamMDF[2],
	HP[2],			// HPí̗j
	AT[2],			// ATiÚj
	DF[2],			// DFih́j
	MAT[2],			// MATi@U)
	MDF[2];			// MDFi@h)


static s16
	btcEnemyParam[] = 
	{
	//    HP   AT   DF  MAT  MDF
		 250, 201, 138,   0,   0,	// QNځF[[
		 103,   2,  21, 186,  47,	// QNځFNX`[i
		  42,   0,  67, 170,  46,	// QNځF}[
		  76,  27,  40, 264,  60,	// QNځFJ
		 165,  84,  81,  97,  59,	// QNځFNA
		 231, 169,  49, 231,  97,	// QNځFWF
		 262, 160, 127, 118,  14,	// QNځFVFi

		 305, 286, 171,   0,  13,	// RNځF[[
		 173,  12,  27, 220,  74,	// RNځFNX`[i
		  68,  53,  63, 200,  58,	// RNځF}[
		 109,  57,  59, 308,  91,	// RNځFJ
		 232, 130,  70, 151,  72,	// RNځFNA
		 239, 126, 104, 236,  89,	// RNځFWF
		 310, 265, 129, 151,  21,	// RNځFVFi

		 421, 400, 205,   0,  18,	// SNځF[[
		 255,  34,  33, 250,  89,	// SNځFNX`[i
		 200,  80,  70, 230,  74,	// SNځF}[
		 150,  82,  68, 504, 124,	// SNځFJ
		 300, 191,  75, 202, 119,	// SNځFNA
		 311, 171, 130, 308, 110,	// SNځFWF
		 430, 368, 125, 186,  37,	// SNځFVFi

		 540, 512, 240,   1,  21,	// TNځF[[
		 311,  46,  49, 280, 104,	// TNځFNX`[i
		 254, 108,  76, 250,  91,	// TNځF}[
		 184, 109,  75, 528, 155,	// TNځFJ
		 367, 173,  95, 252, 106,	// TNځFNA
		 382, 216, 157, 379, 148,	// TNځFWF
		 512, 471, 176, 223,  51,	// TNځFVFi

		 660, 624, 276,   3,  24,	// UNځF[[
		 367,  59,  57, 300, 121,	// UNځFNX`[i
		 283, 134,  84, 260, 107,	// UNځF}[
		 221, 137,  80, 638, 183,	// UNځFJ
		 435, 213, 105, 301, 125,	// UNځFNA
		 435, 261, 184, 451, 175,	// UNځFWF
		 617, 574, 199, 270,  64,	// UNځFVFi

		 774, 734, 313,   4,  30,	// VNځF[[
		 380,  71,  62, 330, 137,	// VNځFNX`[i
		 325, 159,  92, 280, 124,	// VNځF}[
		 260, 167,  84, 748, 211,	// VNځFJ
		 502, 253, 116, 349, 144,	// VNځFNA
		 525, 306, 211, 522, 202,	// VNځFWF
		 718, 674, 226,  77,  62,	// VNځFVFi

		 887, 844, 351,   7,  39,	// WNځF[[
		 434,  83,  67, 350, 153,	// WNځFNX`[i
		 210, 184, 100, 300, 141,	// WNځF}[
		 300, 196,  89, 859, 510,	// WNځFJ
		 569, 292, 128, 397, 164,	// WNځFNA
		 597, 450, 238, 594, 228,	// WNځFWF
		 816, 772, 254, 344,  81	// WNځFVFi
	};


// -------------------------------------
// [J֐`
// -------------------------------------
static void BattleArmsSet(void);
static void BattleProtectorSet(void);
static void bt_main(void);
static void bt_exec(void);
static void ha01_000(void);
static void ha01_001(void);
static void ha01_002(void);
static void ha01_002_l(void);
static void ha01_003(void);
static void bt_func_vs_list(void);
static s16 btSetWinIndex(s16, s16);
static void bt_func_InitParam(void);
static BOOL bt_exec_my_start(void);
static BOOL bt_exec_en_start(void);
static void bt_func_get_dmg(u8);
static void bt_func_set_enemy_name(void);

//---------------------------------------------------------------------------
//
// ֐
//
//---------------------------------------------------------------------------
//----------------------------------------------------------
// n 
//----------------------------------------------------------
void ha01(void)
{
	setParamUp(pR1, 500);		// [[

	bt_vsLi = OFF;
	btParamAT_OFS  = 0;			// ɂ␳(%)
	btParamDF_OFS  = 0;			// hɂ␳(%)
	btParamMAT_OFS = 0;			// @pɂ␳(%)
	btParamMDF_OFS = 0;			// hɂ␳(%)
	bt_Yoroi = OFF;				// Z𑕔

	bt_func_vs_list();

	setBGM(SEQ_PRM4_35);
	playBGM();				// nՂBGM

	setBgNum(BG_har_bg02);
	waitChangeGraph();
	waitOnly(30);
	setBgNum(BG_har_bg03);
	waitChangeGraph();
	waitOnly(60);

	// Jňt
	setScript(_FE01_PSC, FE01_FE01_0);
	waitScript();

	setChangeLock(TRUE);
	setBgNum(BG_har_bg02);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();

	bt_main();

	setBgNum(BG_har_bg02);
	waitChangeGraph();
	ha01_003();

	fe00_conY();		// sǂ̏ꍇi͒łĂ܂j

	// A[[ɗDł͂ȂAQlΐ킵ĂȂꍇ̂
	if (getbtWinNo(0) != btcDA && getbtWinNo(0) != btcLI && bt_vsLi == OFF)
	{
		setChangeLock(TRUE);
		clearMessage();
		putFaceWindow(FALSE);
		putMessageWindow(FALSE);
		setBgNum(BG_bg01);
		setChangeLock(FALSE);
		waitChangeGraph();

		if (getageWidth() == ageC)
			setScript(_FE01_PSC, FE01_FE01_32);
		else
		if (getageWidth() == ageL)
			setScript(_FE01_PSC, FE01_FE01_33);
		else
			setScript(_FE01_PSC, FE01_FE01_34);
		waitScript();
		setChangeLock(TRUE);
		clearMessage();
		putFaceWindow(FALSE);
		putMessageWindow(FALSE);
		setChangeLock(FALSE);
		waitChangeGraph();
	}

	setBgNum(BG_bgr000);	// #m_roomBg
	waitChangeGraph();
	if (getbtWinNo(0) == btcDA)
	{
		// L[ȗ䎌iDꍇ̑䎌j
		switch (getRandom() % 3)
		{
			case 0:
				setScript(_FE01_PSC, FE01_FE01_23);
				break;
			case 1:
				setScript(_FE01_PSC, FE01_FE01_24);
				break;
			case 2:
				setScript(_FE01_PSC, FE01_FE01_25);
				break;
		}
		waitScript();
	} else
	if (getbtWinNo(1) == btcDA)
	{
		setScript(_FE01_PSC, FE01_FE01_36);
		waitScript();
	} else {
		setScript(_FE01_PSC, FE01_FE01_35);
		waitScript();
	}

	RichAndFamous();	//܋ƒmxZiL[ȗ䎌Lj

	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setBgNum(BG_black);
	setChangeLock(FALSE);
	waitChangeGraph();
}

//----------------------------------------------------------------------
// ̑
static void BattleArmsSet(void)
{
	if (isItem(1) != -1 || isItem(2) != -1 || isItem(3) != -1 || isItem(4) != -1 || isItem(5) != -1 || 
		isItem(6) != -1 || isItem(7) != -1 || isItem(75) != -1 || isItem(76) != -1 || isItem(80) != -1)
	{
		funcSetWeapon();
		setScript(_FE01_PSC, FE01_FE01_ARMS);
		waitScript();
		putStartMessage();
		waitSelectShop();

		switch (getSelectItem())
		{
			case 1:
				btParamAT_OFS += 5;
				break;
			case 2:
				btParamAT_OFS += 15;
				break;
			case 3:
				btParamAT_OFS += 25;
				break;
			case 4:
				btParamAT_OFS += 30;
				break;
			case 5:
				btParamMAT_OFS += 5;
				break;
			case 6:
				btParamMAT_OFS += 15;
				break;
			case 7:
				btParamMAT_OFS += 35;
				break;
			case 75:
				btParamAT_OFS += 50;
				btParamDF_OFS += 20;
				break;
			case 76:
				btParamAT_OFS += 40;
				btParamDF_OFS += 10;
				break;
			case 80:
				btParamAT_OFS += 30;
				btParamMAT_OFS += 30;
				btParamDF_OFS += 10;
				btParamMDF_OFS += 10;
				break;
		}

		setChangeLock(TRUE);
		clearMessage();
		putFaceWindow(FALSE);
		putMessageWindow(FALSE);
		setChangeLock(FALSE);
		waitChangeGraph();
	}
}

//----------------------------------------------------------------------
// h̑
static void BattleProtectorSet(void)
{
	if (isItem(8) != -1 || isItem(9) != -1 || isItem(10) != -1 || isItem(11) != -1 || isItem(12) != -1)
	{
		funcSetArmor();
		setScript(_FE01_PSC, FE01_FE01_PROTECTOR);
		waitScript();
		putStartMessage();
		waitSelectShop();

		switch (getSelectItem())
		{
			case 8:
				btParamDF_OFS += 5;
				btParamMDF_OFS += 5;
				bt_Yoroi = ON;
				break;
			case 9:
				btParamDF_OFS += 15;
				btParamMDF_OFS += 10;
				bt_Yoroi = ON;
				break;
			case 10:
				btParamDF_OFS += 25;
				btParamMDF_OFS += 25;
				bt_Yoroi = ON;
				break;
			case 11:
				btParamDF_OFS += 30;
				btParamMDF_OFS += 30;
				bt_Yoroi = ON;
				break;
			case 12:
				btParamDF_OFS += 35;
				btParamMDF_OFS += 40;
				bt_Yoroi = ON;
				break;
		}
		setChangeLock(TRUE);
		clearMessage();
		putFaceWindow(FALSE);
		putMessageWindow(FALSE);
		setChangeLock(FALSE);
		waitChangeGraph();
	}
}



//----------------------------------------------------------------------
//
// 						g[ig
//
//	ij̐is͂Ă
//----------------------------------------------------------------------
static void bt_main(void)
{
	s16 index, ha_tmp[4];

	cmdBattleT_Init(bt_tlist, bt_tstate);
	cmdBattleT_Open();
	waitChangeGraph();
	waitOnly(120);
	ha01_000();					// Q̑䎌

	BattleArmsSet();			// ̐ݒ
	BattleProtectorSet();		// h̐ݒ

	//------------------------
	// Pi0vs1)
	bt_tstate[0] = 1;
	bt_tstate[1] = 1;
	cmdBattleT_Update();
	waitChangeGraph();

	if (bt_tlist[0] == btcDA || bt_tlist[1] == btcDA)
	{
		if (bt_tlist[0] == btcDA)
		{
			btMyIndex = 0;
			btEnemy = bt_tlist[1];
		} else {
			btMyIndex = 1;
			btEnemy = bt_tlist[0];
		}
		ha01_001();

		cmdBattleT_Close();
		waitChangeGraph();

		bt_exec();

		index = btMyIndex;
		if (bt_exec_result == FALSE)
			index ^= 1;

		setBGM(SEQ_PRM4_35);
		playBGM();				// nՂBGM

		cmdBattleT_Open();
		waitChangeGraph();
	} else {
		waitOnly(60);
		index = btSetWinIndex(0, 1);
	}

	ha_tmp[0] = index;				// 0or1 
	bt_tstate[index] = 2;			// 
	bt_tstate[index^1] = -1;		// 
	cmdBattleT_Update();
	waitChangeGraph();

	//------------------------
	// Qi2vs3)
	bt_tstate[2] = 1;
	bt_tstate[3] = 1;
	cmdBattleT_Update();
	waitChangeGraph();

	if (bt_tlist[2] == btcDA || bt_tlist[3] == btcDA)
	{
		if (bt_tlist[2] == btcDA)
		{
			btMyIndex = 0;
			btEnemy = bt_tlist[3];
		} else {
			btMyIndex = 1;
			btEnemy = bt_tlist[2];
		}

		ha01_001();
		cmdBattleT_Close();
		waitChangeGraph();
		bt_exec();

		index = btMyIndex;
		if (bt_exec_result == FALSE)
			index ^= 1;

		setBGM(SEQ_PRM4_35);
		playBGM();				// nՂBGM

		cmdBattleT_Open();
		waitChangeGraph();
	} else {
		waitOnly(60);
		index = btSetWinIndex(2, 3);
	}
	ha_tmp[1] = (s16)(index+2);				// 2or3 
	bt_tstate[index+2] = 2;				// 
	bt_tstate[(index^1)+2] = -1;		// 
	cmdBattleT_Update();
	waitChangeGraph();

	//------------------------
	// Ri4vs5)
	bt_tstate[4] = 1;
	bt_tstate[5] = 1;
	cmdBattleT_Update();
	waitChangeGraph();

	if (bt_tlist[4] == btcDA || bt_tlist[5] == btcDA)
	{
		if (bt_tlist[4] == btcDA)
		{
			btMyIndex = 0;
			btEnemy = bt_tlist[5];
		} else {
			btMyIndex = 1;
			btEnemy = bt_tlist[4];
		}

		ha01_001();
		cmdBattleT_Close();
		waitChangeGraph();
		bt_exec();

		index = btMyIndex;
		if (bt_exec_result == FALSE)
			index ^= 1;

		setBGM(SEQ_PRM4_35);
		playBGM();				// nՂBGM

		cmdBattleT_Open();
		waitChangeGraph();
	} else {
		waitOnly(60);
		index = btSetWinIndex(4, 5);
	}
	ha_tmp[2] = (s16)(index+4);				// 4or5 
	bt_tstate[index+4] = 2;					// 
	bt_tstate[(index^1)+4] = -1;			// 
	cmdBattleT_Update();
	waitChangeGraph();

	//------------------------
	// Si6vs7)
	bt_tstate[6] = 1;
	bt_tstate[7] = 1;
	cmdBattleT_Update();
	waitChangeGraph();

	if (bt_tlist[6] == btcDA || bt_tlist[7] == btcDA)
	{
		if (bt_tlist[6] == btcDA)
		{
			btMyIndex = 0;
			btEnemy = bt_tlist[7];
		} else {
			btMyIndex = 1;
			btEnemy = bt_tlist[6];
		}

		ha01_001();
		cmdBattleT_Close();
		waitChangeGraph();
		bt_exec();

		index = btMyIndex;
		if (bt_exec_result == FALSE)
			index ^= 1;

		setBGM(SEQ_PRM4_35);
		playBGM();				// nՂBGM

		cmdBattleT_Open();
		waitChangeGraph();
	} else {
		waitOnly(60);
		index = btSetWinIndex(6, 7);
	}
	ha_tmp[3] = (s16)(index+6);				// 6or7 
	bt_tstate[index+6] = 2;				// 
	bt_tstate[(index^1)+6] = -1;		// 
	cmdBattleT_Update();
	waitChangeGraph();

	//------------------------
	// Ti0or1 vs 2or3)
	bt_tstate[ha_tmp[0]] = 3;
	bt_tstate[ha_tmp[1]] = 3;
	cmdBattleT_Update();
	waitChangeGraph();

	if (bt_tlist[ha_tmp[0]] == btcDA || bt_tlist[ha_tmp[1]] == btcDA)
	{
		if (bt_tlist[ha_tmp[0]] == btcDA)
		{
			btMyIndex = 0;
			btEnemy = bt_tlist[ha_tmp[1]];
		} else {
			btMyIndex = 1;
			btEnemy = bt_tlist[ha_tmp[0]];
		}

		ha01_001();
		cmdBattleT_Close();
		waitChangeGraph();
		bt_exec();

		index = btMyIndex;
		if (bt_exec_result == FALSE)
			index ^= 1;

		setBGM(SEQ_PRM4_35);
		playBGM();				// nՂBGM

		cmdBattleT_Open();
		waitChangeGraph();
	} else {
		waitOnly(60);
		index = btSetWinIndex(ha_tmp[0], ha_tmp[1]);
	}
	bt_tstate[ha_tmp[index]] =  4;		// 
	bt_tstate[ha_tmp[index^1]] = -1;	// 
	ha_tmp[0] = ha_tmp[index];			// 
	cmdBattleT_Update();
	waitChangeGraph();

	//------------------------
	// Ui4or5 vs 6or7)
	bt_tstate[ha_tmp[2]] = 3;
	bt_tstate[ha_tmp[3]] = 3;
	cmdBattleT_Update();
	waitChangeGraph();

	if (bt_tlist[ha_tmp[2]] == btcDA || bt_tlist[ha_tmp[3]] == btcDA)
	{
		if (bt_tlist[ha_tmp[2]] == btcDA)
		{
			btMyIndex = 0;
			btEnemy = bt_tlist[ha_tmp[3]];
		} else {
			btMyIndex = 1;
			btEnemy = bt_tlist[ha_tmp[2]];
		}

		ha01_001();
		cmdBattleT_Close();
		waitChangeGraph();
		bt_exec();

		index = btMyIndex;
		if (bt_exec_result == FALSE)
			index ^= 1;

		setBGM(SEQ_PRM4_35);
		playBGM();				// nՂBGM

		cmdBattleT_Open();
		waitChangeGraph();
	} else {
		waitOnly(60);
		index = btSetWinIndex(ha_tmp[2], ha_tmp[3]);
	}
	bt_tstate[ha_tmp[index+2]] = 4;		// 
	bt_tstate[ha_tmp[(index^1)+2]] = -1;	// 
	ha_tmp[1] = ha_tmp[index+2];		// 
	cmdBattleT_Update();
	waitChangeGraph();

	//------------------------
	// 
	// iVji0or1or2or3 vs 4or5or6or7)
//	bt_tstate[ha_tmp[0]] = 5;
//	bt_tstate[ha_tmp[1]] = 5;
//	cmdBattleT_Update();
//	waitChangeGraph();

	if (bt_tlist[ha_tmp[0]] == btcDA || bt_tlist[ha_tmp[1]] == btcDA)
	{
		if (bt_tlist[ha_tmp[0]] == btcDA)
		{
			btMyIndex = 0;
			btEnemy = bt_tlist[ha_tmp[1]];
		} else {
			btMyIndex = 1;
			btEnemy = bt_tlist[ha_tmp[0]];
		}

		ha01_001();
		cmdBattleT_Close();
		waitChangeGraph();
		bt_exec();

		index = btMyIndex;
		if (bt_exec_result == FALSE)
			index ^= 1;

		setBGM(SEQ_PRM4_35);
		playBGM();				// nՂBGM
	} else {
		waitOnly(60);
		index = btSetWinIndex(ha_tmp[0], ha_tmp[1]);
	}
	bt_tstate[ha_tmp[index]] = 5;
	bt_tstate[ha_tmp[index^1]] = -1;					// 
	cmdBattleT_Update();
	waitChangeGraph();

	setbtWinNo(0, (u8)bt_tlist[ha_tmp[index]]);				// 
	setbtWinNo(1, (u8)bt_tlist[ha_tmp[index^1]]);				// 

	fadeBGM(60);

	cmdBattleT_Delete();
	waitChangeGraph();
	//#spr.clear{ SPN_BG, efChange, 0 }
	//#screen.on
}

//----------------------------------------------------------------------
//
//
// 								퓬
//
//
//----------------------------------------------------------------------
static void bt_exec(void)
{
	BOOL turn_over;
	int val0, val1;
	u8 turn;

	//----------------------------------
	// 
	//----------------------------------
	bt_EnfEnable = ON;

	haParam = 0;			// ^[

	if (btEnemy == btcLI || btEnemy == btcSN)
		bt_EnfEnable = OFF;

	bt_exec_result = FALSE;
	bt_func_InitParam();

	battleInit(HP[0], HP[1], (u8)btEnemy);
	setBattleGraph(sts);
	setBGM(SEQ_PRM4_28);
	playBGM();
	waitChangeGraph();

	// Lƒe̓ǂݍ
	// G:rcL̓ǂݍ
	// GFJbgC̓ǂݍ
	// GFe̓ǂݍ
	initBattleObj((bt_Yoroi==ON));

	// LN^̔zu
	setBattleObj(0, HA1_ANM_N,  30, 54);
	setBattleObj(1, HA1_ANM_N, 162, 54);
	waitOnly(60);

	// ܂Ł@

	//--------------------------
	// s_Ō߂
	turn = (u8)(getRandom() % 2);

	// ^[Jn
	do
	{
		turn_over = FALSE;
		if (turn == 0)
		{
			if (!bt_exec_my_start())
				break;
			if (!bt_exec_en_start())
				break;
		} else {
			if (!bt_exec_en_start())
				break;
			if (!bt_exec_my_start())
				break;
		}
		turn_over = TRUE;
		haParam++;		// ^[+1
	} while (haParam < 10);

	//--------------------------------
	// A퓬̏I
	//--------------------------------
	moveBattleObj(0, 62, 54, 60);
	moveBattleObj(1,130, 54, 60);
	waitDanceMove();

	if (turn_over)
	{
		// ^[ɂII
		val0 = (HP[0] * 100) / btParamHP[0];	// G̊
		val1 = (HP[1] * 100) / btParamHP[1];	// ̊

		if (val1 >= val0)			//  >= G
		{
			// ̏
			bt_exec_result = TRUE;
			setEnemyName(1);
		} else {
			// G̏
			bt_exec_result = FALSE;
			bt_func_set_enemy_name();
		}
		setScript(_FE01_PSC, FE01_HA01_DRAW);
		waitScript();
	}

	// sJbgC
	if (bt_exec_result == TRUE)
	{
		//#spr.image{ SPN_BT_LCI, BTCI_ANM_LL, BTCI_LX, BTCI_LY, efAlpha005s, 0  }	// ENFCutIN(LOSE)
		poseBattleObj(0, HA1_ANM_L);
	} else {
		//#spr.image{ SPN_BT_RCI, BTCI_ANM_RL, BTCI_RX, BTCI_RY, efAlpha005s, 0  }	// FCutIN(LOSE)
		poseBattleObj(1, HA1_ANM_L);
	}
	waitOnly(10);
	if (bt_exec_result == TRUE)
	{
		//#spr.image{ SPN_BT_RCI, BTCI_ANM_RW, BTCI_RX, BTCI_RY, efAlpha005s, 0  }	// FCutIN(WIN)
		poseBattleObj(1, HA1_ANM_W);
	} else {
		//#spr.image{ SPN_BT_LCI, BTCI_ANM_LW, BTCI_LX, BTCI_LY, efAlpha005s, 0  }	// ENFCutIN(WIN)
		poseBattleObj(0, HA1_ANM_W);
	}
	fadeBGM(60);

	ha01_002();

	clearBattleObj(0);
	clearBattleObj(1);
	clearBattleObj(2);
	clearBattleObj(3);
	waitOnly(10);

	endBattleObj();
	setParamGraph();
	setChangeLock(TRUE);
	battleExit();
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setBgNum(BG_black);
	setChangeLock(FALSE);
	waitChangeGraph();

	setBgNum(BG_har_bg02);		// wi
	waitChangeGraph();
}

//----------------------------------
//
// ̃^[
//
//----------------------------------
static BOOL bt_exec_my_start(void)
{
	setScript(_FE01_PSC, FE01_HA01_SELECT);
	waitScript();
	putStartMessage();
	setRoomBattle();
	bt_at_type = waitSelectBattle();

	bt_func_get_dmg(1);

	clearMessage();
	setScript(_FE01_PSC, FE01_HA01_ATTACK);
	waitScript();
	putStartMessage();
	waitScriptMessageNoKeyWait();

	if (bt_at_type == 0)
	{
		//------------------------------------
		// ʏU
		//------------------------------------
		// JbgC
		//#spr.image{ SPN_BT_RCI, BTCI_ANM_RA, BTCI_RX_S, BTCI_RY, efAlpha01s, SPR_ASYNC }
		//#spr.image{ SPN_BT_LCI, BTCI_ANM_LA, BTCI_LX_S, BTCI_LY, efAlpha01s, SPR_ASYNC }
		// oFwi؂ւ
		///battleBG(TRUE);
		///waitChangeGraph();
		// FJbgC
		//#spr.move{ SPN_BT_RCI, BTCI_RX, BTCI_RY, 200 }
		// F\Dxグ
		prioBattleObj(1);
		// Fړ
		moveBattleObj(1, 62, 54, 30);
		waitDanceMove();
		// ENFJbgC
		//#spr.move{ SPN_BT_LCI, BTCI_LX, BTCI_LY, 200 }							
		if (getOptionSFX() != 0)
			playAdxM(_SE_08_AHX);
		// UbZ[W
		setScriptPoint(btDamage);
		setScriptNoInit(_FE01_PSC, FE01_HA01_DAMAGE);
		waitScript();
		putStartMessage();
		// FU
		poseBattleObj(1, HA1_ANM_A);
		// ENF_[W
		poseBattleObj(0, HA1_ANM_D);
		// _[W
		HP[0] -= btDamage;
		if (HP[0] <= 0)
			HP[0] = 0;
		cmdBattleStatusUpdate(HP[0], HP[1]);
		// ENFCutIN(Damage)
		//#spr.image{ SPN_BT_LCI, BTCI_ANM_LD, BTCI_LX, BTCI_LY, efChange, 0  }
		// EGCg
		waitOnlyNoSkip(30);
		waitChangeHP();
		// FJbgC̏
		// ENFJbgC̏
		// Fm[}
		poseBattleObj(1, HA1_ANM_N);
		// F߂
		moveBattleObj(1, 162, 54, 60);
		waitDanceMove();
		// ENFm[}
		poseBattleObj(0, HA1_ANM_N);
		// wi߂
		///battleBG(FALSE);
		///waitChangeGraph();
	} else {
		//------------------------------------
		// @U
		//------------------------------------
		// JbgC
		//#spr.image{ SPN_BT_RCI, BTCI_ANM_RA, BTCI_RX_S, BTCI_RY, efAlpha01s, SPR_ASYNC }
		//#spr.image{ SPN_BT_LCI, BTCI_ANM_LA, BTCI_LX_S, BTCI_LY, efAlpha01s, SPR_ASYNC }
		// oFwi؂ւ
		///battleBG(TRUE);
		///waitChangeGraph();
		// FJbgC
		//#spr.move{ SPN_BT_RCI, BTCI_RX, BTCI_RY, 200 }
		// ENFJbgC
		//#spr.move{ SPN_BT_LCI, BTCI_LX, BTCI_LY, 200 }
		// F@
		poseBattleObj(1, HA1_ANM_M);
		// F@e
		setBattleObj(3, HA1_ANM_EFFECT_A, 146, 54);
		if (getOptionSFX() != 0)
			playAdxM(_SE_11_AHX);
		// EGCg
		moveBattleObj(3, 140, 54, 30);
		waitDanceMove();
		// Feړ
		moveBattleObj(3, 38, 54, 30);
		waitDanceMove();
		// Fe
		poseBattleObj(3, HA1_ANM_EFFECT_B);
		if (getOptionSFX() != 0)
			playAdxM(_SE_14_AHX);
		// ENF_[W
		poseBattleObj(0, HA1_ANM_D);
		// ENFCutIN(Damage)
		//#spr.image{ SPN_BT_LCI, BTCI_ANM_LD, BTCI_LX, BTCI_LY, efChange, 0  }
		// UbZ[W
		setScriptPoint(btDamage);
		setScriptNoInit(_FE01_PSC, FE01_HA01_DAMAGE);
		waitScript();
		putStartMessage();
		// _[W
		HP[0] -= btDamage;
		if (HP[0] <= 0)
			HP[0] = 0;
		cmdBattleStatusUpdate(HP[0], HP[1]);
		waitOnlyNoSkip(20);
		// Fe
		clearBattleObj(3);
		// EGCg
		waitOnly(6);
		// FJbgC̏
		//#spr.clear{ SPN_BT_RCI, efAlpha02s, SPR_ASYNC }
		// ENFJbgC̏
		//#spr.clear{ SPN_BT_LCI, efAlpha02s, SPR_ASYNC }
		// wi߂
		///battleBG(FALSE);
		///waitChangeGraph();
		// EGCg
		waitOnly(10);
		// Fm[}
		poseBattleObj(1, HA1_ANM_N);
		// GFm[}
		poseBattleObj(0, HA1_ANM_N);
	}
	waitScriptMessage();

	if (HP[0] == 0)
	{
		// GHP
		bt_exec_result = TRUE;
		return FALSE;
	}
	return TRUE;
}

//----------------------------------
//
// G̃^[
//
//----------------------------------
static BOOL bt_exec_en_start(void)
{
	bt_at_type = 0;
	if (bt_EnfEnable == ON)
		//bt_at_type = (s8)(getRandom() & 1);
		bt_at_type = 1;

	bt_func_get_dmg(0);
	bt_func_set_enemy_name();

	clearMessage();
	setScript(_FE01_PSC, FE01_HA01_ATTACK_2);
	waitScript();
	putStartMessage();
	waitScriptMessageNoKeyWait();

	if (bt_at_type == 0)
	{
		//------------------------------------
		// ʏU
		//------------------------------------
		// JbgC
		//#spr.image{ SPN_BT_LCI, BTCI_ANM_LA, BTCI_LX_S, BTCI_LY, efAlpha01s, SPR_ASYNC }
		//#spr.image{ SPN_BT_RCI, BTCI_ANM_RA, BTCI_RX_S, BTCI_RY, efAlpha01s, SPR_ASYNC }
		// oFwi؂ւ
		///battleBG(TRUE);
		///waitChangeGraph();
		// ENFJbgC
		//#spr.move{ SPN_BT_LCI, BTCI_LX, BTCI_LY, 200 }
		// ENF\Dxグ
		prioBattleObj(0);
		// ENFړ
		moveBattleObj(0, 140, 54, 30);
		waitDanceMove();
		// FJbgC
		//#spr.move{ SPN_BT_RCI, BTCI_RX, BTCI_RY, 200 }
		if (getOptionSFX() != 0)
			playAdxM(_SE_08_AHX);
		// UbZ[W
		setScriptPoint(btDamage);
		setScriptNoInit(_FE01_PSC, FE01_HA01_DAMAGE_2);
		waitScript();
		putStartMessage();
		// ENFU
		poseBattleObj(0, HA1_ANM_A);
		// F_[W
		poseBattleObj(1, HA1_ANM_D);
		// _[W
		HP[1] -= btDamage;
		if (HP[1] <= 0)
			HP[1] = 0;
		cmdBattleStatusUpdate(HP[0], HP[1]);
		// FCutIN(Damage)
		//#spr.image{ SPN_BT_RCI, BTCI_ANM_RD, BTCI_RX, BTCI_RY, efChange, 0  }
		// EGCg
		waitOnlyNoSkip(30);
		waitChangeHP();
		// FJbgC̏
		// ENFJbgC̏
		// GFm[}
		poseBattleObj(0, HA1_ANM_N);
		// GF߂
		moveBattleObj(0, 30, 54, 60);
		waitDanceMove();
		// Fm[}
		poseBattleObj(1, HA1_ANM_N);
		// wi߂
		///battleBG(FALSE);
		///waitChangeGraph();
	} else {
		//------------------------------------
		// @U
		//------------------------------------
		// JbgC
		//#spr.image{ SPN_BT_LCI, BTCI_ANM_LA, BTCI_LX_S, BTCI_LY, efAlpha01s, SPR_ASYNC }
		//#spr.image{ SPN_BT_RCI, BTCI_ANM_RA, BTCI_RX_S, BTCI_RY, efAlpha01s, SPR_ASYNC }
		// oFwi؂ւ
		///battleBG(TRUE);
		///waitChangeGraph();
		// ENFJbgC
		//#spr.move{ SPN_BT_LCI, BTCI_LX, BTCI_LY, 200 }
		// FJbgC
		//#spr.move{ SPN_BT_RCI, BTCI_RX, BTCI_RY, 200 }
		// ENFU
		poseBattleObj(0, HA1_ANM_M);
		// GF@e
		setBattleObj(2, HA1_ANM_EFFECT_A, 46, 54);
		if (getOptionSFX() != 0)
			playAdxM(_SE_11_AHX);
		// EGCg
		moveBattleObj(2, 52, 54, 30);
		waitDanceMove();
		// ENFeړ
		moveBattleObj(2, 154, 54, 30);
		waitDanceMove();
		// ENFe
		poseBattleObj(2, HA1_ANM_EFFECT_B);
		if (getOptionSFX() != 0)
			playAdxM(_SE_14_AHX);
		// F_[W
		poseBattleObj(1, HA1_ANM_D);
		// FCutIN(Damage)
		//#spr.image{ SPN_BT_RCI, BTCI_ANM_RD, BTCI_RX, BTCI_RY, efChange, 0  }
		// UbZ[W
		setScriptPoint(btDamage);
		setScriptNoInit(_FE01_PSC, FE01_HA01_DAMAGE_2);
		waitScript();
		putStartMessage();
		// _[W
		HP[1] -= btDamage;
		if (HP[1] <= 0)
			HP[1] = 0;
		cmdBattleStatusUpdate(HP[0], HP[1]);
		waitOnlyNoSkip(20);
		// GF
		clearBattleObj(2);
		// EGCg
		waitOnly(6);
		// ENFJbgC̏
		//#spr.clear{ SPN_BT_LCI, efAlpha02s, SPR_ASYNC }
		// FJbgC̏
		//#spr.clear{ SPN_BT_RCI, efAlpha02s, SPR_ASYNC }
		// wi߂
		///battleBG(FALSE);
		///waitChangeGraph();
		// EGCg
		waitOnly(10);
		// GFm[}
		poseBattleObj(0, HA1_ANM_N);
		// Fm[}
		poseBattleObj(1, HA1_ANM_N);
	}
	waitScriptMessage();

	if (HP[1] == 0)
		return FALSE;
	return TRUE;
}


//----------------------------------------------------------
//
// ViIʌn
//
//----------------------------------------------------------
//--------------------------
// Q̑䎌
//--------------------------
static void ha01_000(void)
{
	if (getLabel(LF_ha01_000) == OFF)
	{
		if (getageWidth() == ageC)
			setScript(_FE01_PSC, FE01_FE01_1);
		else
		if (getageWidth() == ageL)
			setScript(_FE01_PSC, FE01_FE01_2);
		else
			setScript(_FE01_PSC, FE01_FE01_3);
		waitScript();
		setLabel(LF_ha01_000, ON);
	} else {
		if (getageWidth() == ageC)
			setScript(_FE01_PSC, FE01_FE01_4);
		else
		if (getageWidth() == ageL)
			setScript(_FE01_PSC, FE01_FE01_5);
		else
			setScript(_FE01_PSC, FE01_FE01_6);
		waitScript();
	}
}

//--------------------------
// Ȏ䎌
//--------------------------
static void ha01_001(void)
{
	switch (btEnemy)
	{
		case btcLI:		// [[
			if (getageWidth() == ageC)
				setScript(_FE01_PSC, FE01_FE01_7);
			else
			if (getageWidth() == ageL)
				setScript(_FE01_PSC, FE01_FE01_8);
			else
				setScript(_FE01_PSC, FE01_FE01_9);
			waitScript();
			break;

		case btcKR:		// NX`[i
			if (getageWidth() == ageC)
				setScript(_FE02_PSC, FE02_FE02_7);
			else
			if (getageWidth() == ageL)
				setScript(_FE02_PSC, FE02_FE02_8);
			else
				setScript(_FE02_PSC, FE02_FE02_9);
			waitScript();
			break;

		case btcMA:		// }[
			if (getageWidth() == ageC)
				setScript(_FE03_PSC, FE03_FE03_7);
			else
			if (getageWidth() == ageL)
				setScript(_FE03_PSC, FE03_FE03_8);
			else
				setScript(_FE03_PSC, FE03_FE03_9);
			waitScript();
			break;

		case btcKA:		// J
			if (getageWidth() == ageC)
				setScript(_FE00_PSC, FE00_FE00_57);
			else
			if (getageWidth() == ageL)
				setScript(_FE00_PSC, FE00_FE00_58);
			else
				setScript(_FE00_PSC, FE00_FE00_59);
			waitScript();
			break;

		case btcCL:		// NA
			if (getageWidth() == ageC)
				setScript(_FE00_PSC, FE00_FE00_66);
			else
			if (getageWidth() == ageL)
				setScript(_FE00_PSC, FE00_FE00_67);
			else
				setScript(_FE00_PSC, FE00_FE00_68);
			waitScript();
			break;

		case btcRA:		// WF
			if (getageWidth() == ageC)
				setScript(_FE00_PSC, FE00_FE00_63);
			else
			if (getageWidth() == ageL)
				setScript(_FE00_PSC, FE00_FE00_64);
			else
				setScript(_FE00_PSC, FE00_FE00_65);
			waitScript();
			break;

		case btcSN:		// VFi
			if (getageWidth() == ageC)
				setScript(_FE00_PSC, FE00_FE00_69);
			else
			if (getageWidth() == ageL)
				setScript(_FE00_PSC, FE00_FE00_70);
			else
				setScript(_FE00_PSC, FE00_FE00_71);
			waitScript();
			break;
	}
	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();
}

//--------------------------
// 퓬Ii퓬ʓj
//--------------------------
static void ha01_002(void)
{
	if (!bt_exec_result)
	{
		ha01_002_l();
		return;
	}
	// 
	switch (btEnemy)
	{
		case btcLI:		// [[
			if (getageWidth() == ageC)
				setScript(_FE01_PSC, FE01_FE01_19);
			else
			if (getageWidth() == ageL)
				setScript(_FE01_PSC, FE01_FE01_20);
			else
				setScript(_FE01_PSC, FE01_FE01_21);
			waitScript();
			break;

		case btcKR:		// NX`[i
			if (getageWidth() == ageC)
				setScript(_FE02_PSC, FE02_FE02_23);
			else
			if (getageWidth() == ageL)
				setScript(_FE02_PSC, FE02_FE02_24);
			else
				setScript(_FE02_PSC, FE02_FE02_25);
			waitScript();
			break;

		case btcMA:		// }[
			if (getageWidth() == ageC)
				setScript(_FE03_PSC, FE03_FE03_23);
			else
			if (getageWidth() == ageL)
				setScript(_FE03_PSC, FE03_FE03_24);
			else
				setScript(_FE03_PSC, FE03_FE03_25);
			waitScript();
			break;

		case btcKA:		// J
			if (getageWidth() == ageC)
			{
				setScript(_FE01_PSC, FE01_FE01_10);
				waitScript();
				setScript(_FE00_PSC, FE00_FE00_79);
			} else
			if (getageWidth() == ageL)
			{
				setScript(_FE01_PSC, FE01_FE01_11);
				waitScript();
				setScript(_FE00_PSC, FE00_FE00_82);
			} else {
				setScript(_FE01_PSC, FE01_FE01_12);
				waitScript();
				setScript(_FE00_PSC, FE00_FE00_85);
			}
			waitScript();
			break;

		case btcCL:		// NA
			if (getageWidth() == ageC)
			{
				setScript(_FE01_PSC, FE01_FE01_10);
				waitScript();
				setScript(_FE00_PSC, FE00_FE00_106);
			} else
			if (getageWidth() == ageL)
			{
				setScript(_FE01_PSC, FE01_FE01_11);
				waitScript();
				setScript(_FE00_PSC, FE00_FE00_109);
			} else {
				setScript(_FE01_PSC, FE01_FE01_12);
				waitScript();
				setScript(_FE00_PSC, FE00_FE00_112);
			}
			waitScript();
			break;

		case btcRA:		// WF
			if (getageWidth() == ageC)
			{
				setScript(_FE01_PSC, FE01_FE01_10);
				waitScript();
				setScript(_FE00_PSC, FE00_FE00_97);
			} else
			if (getageWidth() == ageL)
			{
				setScript(_FE01_PSC, FE01_FE01_11);
				waitScript();
				setScript(_FE00_PSC, FE00_FE00_100);
			} else {
				setScript(_FE01_PSC, FE01_FE01_12);
				waitScript();
				setScript(_FE00_PSC, FE00_FE00_103);
			}
			waitScript();
			break;

		case btcSN:		// VFi
			if (getageWidth() == ageC)
			{
				setScript(_FE01_PSC, FE01_FE01_10);
				waitScript();
				setScript(_FE00_PSC, FE00_FE00_115);
			} else
			if (getageWidth() == ageL)
			{
				setScript(_FE01_PSC, FE01_FE01_11);
				waitScript();
				setScript(_FE00_PSC, FE00_FE00_118);
			} else {
				setScript(_FE01_PSC, FE01_FE01_12);
				waitScript();
				setScript(_FE00_PSC, FE00_FE00_121);
			}
			waitScript();
			break;
	}
	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();
}

// 
static void ha01_002_l(void)
{
	switch (btEnemy)
	{
		case btcLI:		// [[
			if (getageWidth() == ageC)
				setScript(_FE01_PSC, FE01_FE01_13);
			else
			if (getageWidth() == ageL)
				setScript(_FE01_PSC, FE01_FE01_14);
			else
				setScript(_FE01_PSC, FE01_FE01_15);
			waitScript();
			break;

		case btcKR:		// NX`[i
			if (getageWidth() == ageC)
				setScript(_FE02_PSC, FE02_FE02_17);
			else
			if (getageWidth() == ageL)
				setScript(_FE02_PSC, FE02_FE02_18);
			else
				setScript(_FE02_PSC, FE02_FE02_19);
			waitScript();
			break;

		case btcMA:		// }[
			if (getageWidth() == ageC)
				setScript(_FE03_PSC, FE03_FE03_17);
			else
			if (getageWidth() == ageL)
				setScript(_FE03_PSC, FE03_FE03_18);
			else
				setScript(_FE03_PSC, FE03_FE03_19);
			waitScript();
			break;

		case btcKA:		// J
			if (getageWidth() == ageC)
			{
				setScript(_FE00_PSC, FE00_FE00_78);
				waitScript();
				setScript(_FE01_PSC, FE01_FE01_16);
			} else
			if (getageWidth() == ageL)
			{
				setScript(_FE00_PSC, FE00_FE00_81);
				waitScript();
				setScript(_FE01_PSC, FE01_FE01_17);
			} else {
				setScript(_FE00_PSC, FE00_FE00_84);
				waitScript();
				setScript(_FE01_PSC, FE01_FE01_18);
			}
			waitScript();
			break;

		case btcCL:		// NA
			if (getageWidth() == ageC)
			{
				setScript(_FE00_PSC, FE00_FE00_105);
				waitScript();
				setScript(_FE01_PSC, FE01_FE01_16);
			} else
			if (getageWidth() == ageL)
			{
				setScript(_FE00_PSC, FE00_FE00_108);
				waitScript();
				setScript(_FE01_PSC, FE01_FE01_17);
			} else {
				setScript(_FE00_PSC, FE00_FE00_111);
				waitScript();
				setScript(_FE01_PSC, FE01_FE01_18);
			}
			waitScript();
			break;

		case btcRA:		// WF
			if (getageWidth() == ageC)
			{
				setScript(_FE00_PSC, FE00_FE00_96);
				waitScript();
				setScript(_FE01_PSC, FE01_FE01_16);
			} else
			if (getageWidth() == ageL)
			{
				setScript(_FE00_PSC, FE00_FE00_99);
				waitScript();
				setScript(_FE01_PSC, FE01_FE01_17);
			} else {
				setScript(_FE00_PSC, FE00_FE00_102);
				waitScript();
				setScript(_FE01_PSC, FE01_FE01_18);
			}
			waitScript();
			break;

		case btcSN:		// VFi
			if (getageWidth() == ageC)
			{
				setScript(_FE00_PSC, FE00_FE00_114);
				waitScript();
				setScript(_FE01_PSC, FE01_FE01_16);
			} else
			if (getageWidth() == ageL)
			{
				setScript(_FE00_PSC, FE00_FE00_117);
				waitScript();
				setScript(_FE01_PSC, FE01_FE01_17);
			} else {
				setScript(_FE00_PSC, FE00_FE00_120);
				waitScript();
				setScript(_FE01_PSC, FE01_FE01_18);
			}
			waitScript();
			break;
	}
	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();
}

//--------------------------
// I
//--------------------------
static void ha01_003(void)
{
	//-------------------------------
	// \plO\ݒ

	bt_func_set_win_name();		// D҂̖OZbg

	///endDanceObj();
	setChangeLock(TRUE);
	putDanceBG(FALSE);
	setBgNum(BG_har_bg02);		// wi
	setChangeLock(FALSE);
	waitChangeGraph();
	putResult23();
	waitChangeGraph();

	// D
	putResult2name();
	waitOnly(60);

	// D
	putResult1();
	waitChangeGraph();

// l̂t
	//#frame{ 0 }
	setScript(_FE01_PSC, FE01_FE01_22);
	waitScript();
	putResult1name();
	setScript(_FE01_PSC, FE01_FE01_22A);
	waitScript();

	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();

// ̃gtB[^
	if (getbtWinNo(0) == btcDA)
	{
		if (getageWidth() == ageC)
			setBgNum(BG_ev44a);
		else
		if (getageWidth() == ageL)
			setBgNum(BG_ev44b);
		else
			setBgNum(BG_ev44c);
		waitChangeGraph();
		setScript(_FE01_PSC, FE01_HA01_003);
		waitScript();
	}
	stopAdxM();

	switch (getbtWinNo(0))
	{
		case btcDA:		// 
			if (getageWidth() == ageC)
				setScript(_FE01_PSC, FE01_FE01_26);
			else
			if (getageWidth() == ageL)
				setScript(_FE01_PSC, FE01_FE01_27);
			else
				setScript(_FE01_PSC, FE01_FE01_28);
			waitScript();
			break;

		case btcLI:		// [[
			if (getageWidth() == ageC)
				setScript(_FE01_PSC, FE01_FE01_29);
			else
			if (getageWidth() == ageL)
				setScript(_FE01_PSC, FE01_FE01_30);
			else
				setScript(_FE01_PSC, FE01_FE01_31);
			waitScript();
			break;

		case btcKR:		// NX`[i
			if (getageWidth() == ageC)
				setScript(_FE02_PSC, FE02_FE02_29);
			else
			if (getageWidth() == ageL)
				setScript(_FE02_PSC, FE02_FE02_30_1);
			else
				setScript(_FE02_PSC, FE02_FE02_31_1);
			waitScript();
			break;

		case btcMA:		// }[
			if (getageWidth() == ageC)
				setScript(_FE03_PSC, FE03_FE03_29);
			else
			if (getageWidth() == ageL)
				setScript(_FE03_PSC, FE03_FE03_30);
			else
				setScript(_FE03_PSC, FE03_FE03_31);
			waitScript();
			break;

		case btcKA:		// J
			if (getageWidth() == ageC)
				setScript(_FE00_PSC, FE00_FE00_80);
			else
			if (getageWidth() == ageL)
				setScript(_FE00_PSC, FE00_FE00_83);
			else
				setScript(_FE00_PSC, FE00_FE00_86);
			waitScript();
			break;

		case btcCL:		// NA
			if (getageWidth() == ageC)
				setScript(_FE00_PSC, FE00_FE00_107);
			else
			if (getageWidth() == ageL)
				setScript(_FE00_PSC, FE00_FE00_110);
			else
				setScript(_FE00_PSC, FE00_FE00_113);
			waitScript();
			break;

		case btcRA:		// WF
			if (getageWidth() == ageC)
				setScript(_FE00_PSC, FE00_FE00_98);
			else
			if (getageWidth() == ageL)
				setScript(_FE00_PSC, FE00_FE00_101);
			else
				setScript(_FE00_PSC, FE00_FE00_104);
			waitScript();
			break;

		case btcSN:		// VFi
			if (getageWidth() == ageC)
				setScript(_FE00_PSC, FE00_FE00_116);
			else
			if (getageWidth() == ageL)
				setScript(_FE00_PSC, FE00_FE00_119);
			else
				setScript(_FE00_PSC, FE00_FE00_122);
			waitScript();
			break;
	}
}


//----------------------------------------------------------
// g[ig\쐬
//----------------------------------------------------------
static void bt_func_vs_list(void)
{
	int i, j, val0;

	for (i=0; i<8; i++)
	{
		bt_tlist[i] = -1;
		bt_tstate[i] = 0;
	}

	for (i=8; i>0; )
	{
		val0 = (int)(getRandom() % i);		// val0 = XԖ
		i--;
		for (j=0; j<8; j++)
		{
			if (bt_tlist[j] < 0)
			{
				if (val0 == 0)
				{
					bt_tlist[j] = (s8)i;
					break;
				}
				val0--;
			}
		}
	}
}

//----------------------------------
// p[^̏ݒ
//----------------------------------
static void bt_func_InitParam(void)
{
	s16 val0, val1, val2, index;

	//------------------------------------------------------
	// ̃p[^
	val1 = 100;				// pnɃx{[iX >= 100(%)
	val2 = 100;				// pnɃx{[iX >= 100(%)

	// HP
	btParamHP[1] = (s16)getParam(pTAIRYOKU);
	if (btParamHP[1] <= 0)
		btParamHP[1] = 1;

	// AT
	val0 = (s16)(((getParam(pPRIDE)+1)*100) / (getParam(pPRIDE)+getParam(pMORAL)+2));
	btParamAT[1] = (s16)((getParam(pBUJYUTU) * (val0+btParamAT_OFS)) / 100);

	// DF
	val0 = (s16)(((getParam(pMORAL)+1)*100) / (getParam(pPRIDE)+getParam(pMORAL)+2));
	btParamDF[1] = (s16)((getParam(pBUJYUTU) * (val0+btParamDF_OFS)) / 100);

	// MAT
	val0 = (s16)(((getParam(pCHIRYOKU)+1)*100) / (getParam(pCHIRYOKU)+getParam(pKANNJYU)+2));
	btParamMAT[1] = (s16)((getParam(pMAJYUTU) * (val0+btParamMAT_OFS)) / 100);

	// MDF
	val0 = (s16)(((getParam(pKANNJYU)+1)*100) / (getParam(pCHIRYOKU)+getParam(pKANNJYU)+2));
	btParamMDF[1] = (s16)((getParam(pMAJYUTU) * (val0+btParamMDF_OFS)) / 100);

	HP[1] = btParamHP[1];
	AT[1] = (s16)(btParamAT[1]/10);
	if (AT[1] > 99)
		AT[1] = 99;

	DF[1] = (s16)(btParamDF[1]/10);
	if (DF[1] > 99)
		DF[1] = 99;

	MAT[1] = (s16)(btParamMAT[1]/10);
	if (MAT[1] > 99)
		MAT[1] = 99;

	MDF[1] = (s16)(btParamMDF[1]/10);
	if (MDF[1] > 99)
		MDF[1] = 99;

	// G̖OAp[^
	switch (btEnemy)
	{
		case btcLI:
			bt_vsLi = ON;
			break;

		case btcKR:
			//bt_EnfXps = (s16)(BT_CLX + 63);
			//bt_EnfYps = (s16)(BT_CY  - 80);
			break;

		case btcMA:
			//bt_EnfXps = (s16)(BT_CLX +61);
			//bt_EnfYps = (s16)(BT_CY  -61);
			break;

		case btcKA:
			//bt_EnfXps = (s16)(BT_CLX + 63);
			//bt_EnfYps = (s16)(BT_CY  - 59);
			break;

		case btcCL:
			//bt_EnfXps = (s16)(BT_CLX + 53);
			//bt_EnfYps = (s16)(BT_CY  - 79);
			break;

		case btcRA:
			//bt_EnfXps = (s16)(BT_CLX + 39);
			//bt_EnfYps = (s16)(BT_CY  - 57);
			break;

		case btcSN:
			break;
	}
	index = (s16)(((getGameY()-1)*35) + ((btEnemy-1) * 5));

	btParamHP[0]  = btcEnemyParam[ index ];	// HP
	btParamAT[0]  = btcEnemyParam[index+1];	// AT
	btParamDF[0]  = btcEnemyParam[index+2];	// DF
	btParamMAT[0] = btcEnemyParam[index+3];	// MAT
	btParamMDF[0] = btcEnemyParam[index+4];	// MDF

	HP[0] = btParamHP[0];
	AT[0] = (s16)(btParamAT[0]/10);
	DF[0] = (s16)(btParamDF[0]/10);
	MAT[0] = (s16)(btParamMAT[0]/10);
	MDF[0] = (s16)(btParamMDF[0]/10);

	sts[0] = (u8)AT[0];
	sts[1] = (u8)DF[0];
	sts[2] = (u8)MAT[0];
	sts[3] = (u8)MDF[0];
	sts[4] = (u8)AT[1];
	sts[5] = (u8)DF[1];
	sts[6] = (u8)MAT[1];
	sts[7] = (u8)MDF[1];
}

//----------------------------------
// ɗ^_[Wl߂
//----------------------------------
static void bt_func_get_dmg(u8 atk)
{
	u8 def;
	int val2;

// $val0 ŨCfbNXi{Tu[`ĂԑOɐݒj
// $val1 ̃CfbNX
// $val2 _[Wl̗h炬
	def = (u8)(atk ^ 1);

	if (bt_at_type == 0)
	{
		// ʏU
		btDamage = (s16)(btParamAT[atk] - btParamDF[def]);
		if (btDamage < 0)
			btDamage = 0;
		val2 = (int)(getRandom() % 6);
		if (val2 != 0)
			val2 = (btDamage * val2) / 100;
		btDamage += val2;
	} else {
		// @U
		btDamage = (s16)(btParamMAT[atk] - btParamMDF[def]);
		if (btDamage < 0)
			btDamage = 0;
		val2 = (int)(getRandom() % 6);
		if (val2 != 0)
			val2 = (btDamage * val2) / 100;
		btDamage += val2;
	}
	btDamage += (getRandom() % 5) + 1;
}


//----------------------------------------------------------------
//
//----------------------------------------------------------------
void bt_func_set_win_name(void)
{
	// D
	switch (getbtWinNo(0))
	{
		case btcDA:		// 
			setEnemyName(1);
			break;
		case btcLI:
			setEnemyName(2);
			break;
		case btcKR:
			setEnemyName(3);
			break;
		case btcMA:
			setEnemyName(4);
			break;
		case btcKA:
			setEnemyName(5);
			break;
		case btcCL:
			setEnemyName(6);
			break;
		case btcRA:
			setEnemyName(7);
			break;
		case btcSN:
			setEnemyName(8);
			break;
		case btcMI:
			setEnemyName(9);
			break;
	}
}


//---------------------------------------------------------
// CPU mőΐ̏ꍇ̏҂߂
// $val0,$val1$BT_TLIST̃CfbNXČĂяo
//
// [[ vs }[NX`[ȉꍇ́A΂Ƀ[[̏
// [[ vs ̑̏ꍇ́A70Ń[[̏
// NX`[i vs@}[̏ꍇ́A50ŏs߂
// NX`[i vs ̑ ̏ꍇA25ŃNX`[ȉ
// }[ vs ̑̏ꍇA25Ń}[̏
// LɊYȂꍇ́A50ŏs߂
//---------------------------------------------------------
static s16 btSetWinIndex(s16 val0, s16 val1)
{
	s16 index, par;

	index = -1;
	par = (s16)(getRandom() % 100);
	if (bt_tlist[val0] == btcLI)
	{
		// [[ vs iNX`[i or }[j
		if (bt_tlist[val1] == btcKR || bt_tlist[val1] == btcMA)
			index = 0;
		else
		if (par < 70)
			index = 0;
		else
			index = 1;

	} else
	if (bt_tlist[val1] == btcLI)
	{
		// iNX`[i or }[jvs [[
		if (bt_tlist[val0] == btcKR || bt_tlist[val0] == btcMA)
			index = 1;
		else
		if (par < 70)
			index = 1;
		else
			index = 0;
	} else
	if ((bt_tlist[val0] == btcKR && bt_tlist[val1] == btcMA) || (bt_tlist[val0] == btcMA && bt_tlist[val1] == btcKR))
	{
		// (NX`[i vs }[) or (}[ vs NX`[i) ̏ꍇ
		index = (s16)(getRandom() & 1);
	} else
	if (bt_tlist[val0] == btcKR || bt_tlist[val0] == btcMA)
	{
		// iNX`[i or }[j vs HHH ̏ꍇ
		if (par < 25)
			index = 0;
		else
			index = 1;
	} else
	if (bt_tlist[val1] == btcKR || bt_tlist[val1] == btcMA)
	{
		// HHH vs iNX`[i or }[j̏ꍇ
		if (par < 25)
			index = 1;
		else
			index = 0;
	}

	if (index < 0)
		index = (s16)(getRandom() & 1);
	return index;
}

static void bt_func_set_enemy_name(void)
{
	switch (btEnemy)
	{
		case btcLI:
			setEnemyName(12);
			break;
		case btcKR:
			setEnemyName(13);
			break;
		case btcMA:
			setEnemyName(14);
			break;
		case btcKA:
			setEnemyName(15);
			break;
		case btcCL:
			setEnemyName(16);
			break;
		case btcRA:
			setEnemyName(17);
			break;
		case btcSN:
			setEnemyName(18);
			break;
	}
}

