//---------------------------------------------------------------------------
//
// n _XReXg
//
//---------------------------------------------------------------------------
#include <nitro.h>
#include "bds_lib.h"
#include "pack_data.h"
#include "game.h"
#include "ha02.h"
#include "ha01.h"
#include "fe00.h"
#include "graph.h"
#include "prime4.h"
#include "event_grp.h"
#include "script.h"
#include "schedule.h"
#include "sound_data.h"
#include "item.h"
#include "def/fe00_def.h"
#include "def/fe01_def.h"
#include "def/fe02_def.h"

// -------------------------------------
// 萔`
// -------------------------------------


// -------------------------------------
// NXE\̒`
// -------------------------------------
// -------------------------------------
// [Jϐ`
// -------------------------------------
static s8
	bt_tstate[4];
static int
	btEnemy,
	haParam[3],
	btMyIndex,
	ha2_ng_min,
	ha2_ng_max,
	ha2_ng_par,
	ha2_x,
	ha2_y,
	ha2_seq_num;

//------------------------------------------------------------
// _XReXg ܐݒl
//------------------------------------------------------------
static int
	ha02RankParamTbl[] = 
	{
		 2600, 1330, 1575,	// QN
		 4698, 1973, 2486,	// RN
		 6901, 2673, 3429,	// SN
		 8700, 3373, 4371,	// TN
		 9800, 4072, 5289,	// UN
		11500, 4767, 6190,	// VN
		12990, 5465, 7095	// WN
	};
static u8
	ha02RankSetTbl[] =
	{
		btcKR, btcRA, btcMI,	// 0
		btcKR, btcMI, btcRA,	// 1
		btcKR, btcRA, btcMI,	// 2
		btcKR, btcMI, btcRA,	// 3
		btcKR, btcRA, btcMI,	// 4
		btcKR, btcMI, btcRA,	// 5
		btcKR, btcRA, btcMI,	// 6
		btcKR, btcMI, btcRA,	// 7
		btcKR, btcRA, btcMI,	// 8
		btcKR, btcMI, btcRA,	// 9
		btcRA, btcKR, btcMI,	// 10
		btcMI, btcKR, btcRA,	// 11
		btcRA, btcKR, btcMI,	// 12
		btcMI, btcKR, btcRA,	// 13
		btcMI, btcRA, btcKR,	// 14
		btcRA, btcMI, btcKR		// 15
	},
	ha2_char_tbl[] =
	{
		btcDA, btcKR, btcRA, btcMI
	};
static u16
	ha2_cx[4] = 
	{
		66,
		33,
		0,
		98,
	},
	ha2_cy[4] = 
	{
		24-8,
		30-8,
		36-8,
		52-8,
	};


//------------------------------------------------------------
// _XReXg 萔
//------------------------------------------------------------


// -------------------------------------
// [J֐`
// -------------------------------------
static void ha02_main(void);
static void ha2_func_set_entry_list(void);
static void ha2_rank_set(void);
static void ha2_dance_init(void);
static void ha2_dance_start_move(void);
static void ha2_dance_start(void);
static void ha2_dance_end(void);
static void ha2_get_ng_par(void);
static void ha2_dance_ng_L(void);
static void ha2_dance_ng_R(void);
static void ha2_dance_ng_N(void);
static void ha2_dance_01(void);
static void ha2_dance_02(void);
static void ha2_dance_03(void);
static void ha2_dance_04(void);
static void ha2_dance_05(void);
static void ha2_dance_06(void);
static void ha2_dance_07(void);
static void ha2_dance_08(void);
static void ha02_000(void);
static void ha02_001(void);
static void ha02_002(void);
static void ha02_003(void);
static void ha02_004(void);


//---------------------------------------------------------------------------
//
// ֐
//
//---------------------------------------------------------------------------
//----------------------------------------------------------------
//
//----------------------------------------------------------------
void ha02(void)
{
	addParam(pR2, 500);		// NX`[i

	btEnemy = (int)(getRandom() % 3);
	setbtWinNo(0, 99);
	setbtWinNo(1, 99);
	setbtWinNo(2, 99);

	setBGM(SEQ_PRM4_35);
	playBGM();				// nՂBGM

	setBgNum(BG_har_bg02);
	waitChangeGraph();
	waitOnly(30);
	setBgNum(BG_har_bg04);
	waitChangeGraph();
	waitOnly(60);

	// _XReXgJňt
	setScript(_FE02_PSC, FE02_FE02_0);
	waitScript();

	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();

	// Q̑䎌
	ha02_000();

	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();

	ha02_main();		// S̗x蕔

	ha02_001();		// \

	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();

	fadeBGM(60);

	//----------------------------------------
	// L[ȗ䎌iD̏ꍇADłȂꍇj
	setBgNum(BG_bgr000);	// #m_roomBg
	waitChangeGraph();
	if (getbtWinNo(0) == btcDA)
	{
		// D
		switch (getRandom() % 3)
		{
			case 0:
				setScript(_FE02_PSC, FE02_FE02_11);
				waitScript();
				break;
			case 1:
				setScript(_FE02_PSC, FE02_FE02_12);
				waitScript();
				break;
			case 2:
				setScript(_FE02_PSC, FE02_FE02_13);
				waitScript();
				break;
		}
	} else
	if (getbtWinNo(1) == btcDA || getbtWinNo(2) == btcDA)
	{
		setScript(_FE01_PSC, FE01_FE01_36);
		waitScript();
	} else {
		setScript(_FE01_PSC, FE01_FE01_35);
		waitScript();
	}

	//	#call{ fe00_56 }	// DłȂ
	// ͌\[XRgAEg

	RichAndFamous();	//܋ƒmx

	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setBgNum(BG_black);
	setChangeLock(FALSE);
	waitChangeGraph();

	if (getbtWinNo(0) == btcKR)
		setLabel(LF_ha2_kr_victory, ON);		// NX`[i_XReXgDtO
}

//--------------------------------------------------------------------
//
//--------------------------------------------------------------------
static void ha02_main(void)
{
	int select;

	ha2_func_set_entry_list();		// xp^[ƏoꏇԂ߂
	ha2_rank_set();					// ܏ʂ߂

	putDanceBG(TRUE);
	waitChangeGraph();

	//------------------------------------------
	// 
	ha2_dance_init();

	btMyIndex = 3;
	while (btMyIndex >= 0)
	{
		int index;
		index = bt_tstate[btMyIndex];
		if (getbtWinNo(0) == index)
		{
			ha2_ng_min = 0;
			ha2_ng_max = 1;
		} else
		if (getbtWinNo(1) == index || getbtWinNo(2) == index)
		{
			ha2_ng_min = 2;
			ha2_ng_max = 3;
		} else {
			ha2_ng_min = 4;
			ha2_ng_max = 5;
		}

		ha2_dance_start_move();
		ha02_002();
		ha2_dance_start();

		select = (int)(getRandom() % 8);

		switch (select)
		{
			case 0:
				ha2_dance_01();
				break;
			case 1:
				ha2_dance_02();
				break;
			case 2:
				ha2_dance_03();
				break;
			case 3:
				ha2_dance_04();
				break;
			case 4:
				ha2_dance_05();
				break;
			case 5:
				ha2_dance_06();
				break;
			case 6:
				ha2_dance_07();
				break;
			case 7:
				ha2_dance_08();
				break;
		}
		ha2_dance_end();
		btMyIndex -= 1;
	}
	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();
	//#spr.clear{ SPN_BT_SBG, efAlpha1s, 0 }
}

//--------------------------
// oꏇԂ߂
//--------------------------
static void ha2_func_set_entry_list(void)
{
	int i, val0, val1, val2;

	// oꏇԂ߂
	for (i=0; i<4; i++)
		bt_tstate[i] = -1;

	val2 = 4;
	while (val2 > 0)
	{
		val0 = (int)(getRandom() % val2);		// val0 = XԖ
		val2--;
		val1 = 0;
		while (val1 < 4)
		{
			if (bt_tstate[val1] < 0)
			{
				if (val0 == 0)
				{
					bt_tstate[val1] = (s8)ha2_char_tbl[val2];
					break;
				}
				val0--;
			}
			val1++;
		}
	}
}

//--------------------------
// ܏ʂ߂
//--------------------------
static void ha2_rank_set(void)
{
	// ̃p[^eܐl擾
	int index, val0;

	// 
	haParam[0] = (int)((getParam(pTAIRYOKU) * 3) + (getParam(pMIRYOKU) * 3) + (getParam(pKANNJYU) * 3) + (getSchDays(jButou) * 20));
	// |p
	haParam[1] = (int)((getParam(pTAIRYOKU) * 1) + (getParam(pMIRYOKU) * 4) + (getParam(pKANNJYU) * 4) + (getSchDays(jButou) * 40));
	// Zp
	haParam[2] = (int)((getParam(pTAIRYOKU) * 5) + (getParam(pMIRYOKU) * 2) + (getParam(pKANNJYU) * 2) + (getSchDays(jButou) * 10));

	index = (int)((getGameY()-1) * 3);
	val0 = (int)((getRandom() % 16) * 3);
	if (haParam[0] >= ha02RankParamTbl[index])
	{
		setbtWinNo(0, btcDA);
		setbtWinNo(1, ha02RankSetTbl[val0]);
		setbtWinNo(2, ha02RankSetTbl[val0+1]);
	} else
	if (haParam[1] >= ha02RankParamTbl[index+1])
	{
		setbtWinNo(1, btcDA);
		setbtWinNo(0, ha02RankSetTbl[val0]);
		setbtWinNo(2, ha02RankSetTbl[val0+1]);
	} else
	if (haParam[2] >= ha02RankParamTbl[index+2])
	{
		setbtWinNo(2, btcDA);
		setbtWinNo(0, ha02RankSetTbl[val0]);
		setbtWinNo(1, ha02RankSetTbl[val0+1]);
	} else {
		setbtWinNo(0, ha02RankSetTbl[val0]);
		setbtWinNo(1, ha02RankSetTbl[val0+1]);
		setbtWinNo(2, ha02RankSetTbl[val0+2]);
	}
}

//--------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------
static void ha2_dance_init(void)
{

	initDanceObj();

	btMyIndex = 3;
	while (btMyIndex >= 0)
	{
		switch (bt_tstate[btMyIndex])
		{
			case btcDA:
				setDanceChar(btMyIndex, 2);
				break;
			case btcKR:
				setDanceChar(btMyIndex, 3);
				break;
			case btcRA:
				setDanceChar(btMyIndex, 1);
				break;
			case btcMI:
				setDanceChar(btMyIndex, 0);
				break;
		}
		if (btMyIndex == 3)
			setDanceObj(btMyIndex, HA2_ANM_STOP, ha2_cx[btMyIndex], ha2_cy[btMyIndex]);
		else
			setDanceObj(btMyIndex, HA2_ANM_WAIT, ha2_cx[btMyIndex], ha2_cy[btMyIndex]);
		btMyIndex--;
	}
}


//--------------------------------------------------------------------------
// ̒ֈړ
// ̃L͎Oɋl߂
//--------------------------------------------------------------------------
static void ha2_dance_start_move(void)
{
	switch (btMyIndex)
	{
		case 2:
			poseDanceObj(1, HA2_ANM_WALK);
			poseDanceObj(0, HA2_ANM_WALK);
			poseDanceObj(2, HA2_ANM_WALK);
			moveDanceObj(1, ha2_cx[2], ha2_cy[2], 60);
			moveDanceObj(0, ha2_cx[1], ha2_cy[1], 60);
			moveDanceObj(2, ha2_cx[3], ha2_cy[3], 60);
			waitDanceMove();
			poseDanceObj(1, HA2_ANM_WAIT);
			poseDanceObj(0, HA2_ANM_WAIT);
			poseDanceObj(2, HA2_ANM_STOP);
			break;
		case 1:
			poseDanceObj(0, HA2_ANM_WALK);
			poseDanceObj(1, HA2_ANM_WALK);
			moveDanceObj(0, ha2_cx[2], ha2_cy[2], 60);
			moveDanceObj(1, ha2_cx[3], ha2_cy[3], 60);
			waitDanceMove();
			poseDanceObj(0, HA2_ANM_WAIT);
			poseDanceObj(1, HA2_ANM_STOP);
			break;
		case 0:
			poseDanceObj(0, HA2_ANM_WALK);
			moveDanceObj(0, ha2_cx[3], ha2_cy[3], 60);
			waitDanceMove();
			poseDanceObj(0, HA2_ANM_STOP);
			break;
	}
}

//--------------------------------------------------------------------------
// LN^̗xJn
// ŏ̗
//--------------------------------------------------------------------------
static void ha2_dance_start(void)
{
	ha2_x = ha2_cx[3];
	ha2_y = ha2_cy[3];
	poseDanceObj(btMyIndex, HA2_ANM_STOP);
	ha02_003();
	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChangeLock(FALSE);
	waitChangeGraph();

	poseDanceObj(btMyIndex, HA2_ANM_BOW);	// ŏ̗
	waitOnly(60);
	poseDanceObj(btMyIndex, HA2_ANM_STOP);
	waitOnly(60);
}

//--------------------------
// xI̋ʏ
//--------------------------
static void ha2_dance_end(void)
{
	poseDanceObj(btMyIndex, HA2_ANM_STOP);
	waitOnly(30);
	poseDanceObj(btMyIndex, HA2_ANM_BOW);
	if (getOptionSFX() != 0)
		playAdxM(_SE09_AHX);
	ha02_004();
	clearDanceObj(btMyIndex);
}

//------------------------------------------------------------------------------
// LN^̈ړ֘A
//------------------------------------------------------------------------------

//------------------------------------------------------------
static void ha2_get_ng_par(void)
{
	if (ha2_seq_num <= ha2_ng_min)
		ha2_ng_par = 100;
	else
	if (ha2_ng_min <= 0 && ha2_ng_max > 0)
		ha2_ng_par = 15;
	else
	if (ha2_ng_max > 0)
		ha2_ng_par = 50;
	else
		ha2_ng_par = 0;
	ha2_seq_num -= 1;
}

//------------------------------------------------------------
static void ha2_dance_ng_L(void)
{
	ha2_get_ng_par();

	if (getRandom() % 100 < ha2_ng_par)
	{
		ha2_ng_min -= 1;
		ha2_ng_max -= 1;
		poseDanceObj(btMyIndex, HA2_ANM_NG);
		waitOnlyNoSkip(20);
		poseDanceObj(btMyIndex, HA2_ANM_TURN_L);
	}
}

//------------------------------------------
static void ha2_dance_ng_R(void)
{
	ha2_get_ng_par();

	if (getRandom() % 100 < ha2_ng_par)
	{
		ha2_ng_min -= 1;
		ha2_ng_max -= 1;
		poseDanceObj(btMyIndex, HA2_ANM_NG);
		waitOnlyNoSkip(20);
		poseDanceObj(btMyIndex, HA2_ANM_TURN_R);
	}
}

//------------------------------------------
static void ha2_dance_ng_N(void)
{
	ha2_get_ng_par();

	if (getRandom() % 100 < ha2_ng_par)
	{
		ha2_ng_min -= 1;
		ha2_ng_max -= 1;
		poseDanceObj(btMyIndex, HA2_ANM_NG);
		waitOnlyNoSkip(20);
		poseDanceObj(btMyIndex, HA2_ANM_STOP);
	}
}

//------------------------------------------
// p^[P
//------------------------------------------
static void ha2_dance_01(void)
{
	ha2_seq_num = 10;

	// 1:(1)
	poseDanceObj(btMyIndex, HA2_ANM_TURN_L);
	ha2_x = ha2_cx[3] + ((88 * 256) / 640);
	ha2_y = ha2_cy[3] - ((33 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1328*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 2:(2)
	ha2_x = ha2_cx[3] + ((43 * 256) / 640);
	ha2_y = ha2_cy[3] - ((43 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (609*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 3:(3)
	ha2_x = ha2_cx[3] - ((30 * 256) / 640);
	ha2_y = ha2_cy[3] - ((24 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1017*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 4:(4)
	ha2_x = ha2_cx[3] - ((118 * 256) / 640);
	ha2_y = ha2_cy[3] + ((4 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1278*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 5:(5)
	ha2_x = ha2_cx[3] + ((7 * 256) / 640);
	ha2_y = ha2_cy[3] + ((48 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1858*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 6:(6)
	ha2_x = ha2_cx[3] + ((109 * 256) / 640);
	ha2_y = ha2_cy[3] + ((21 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1426*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 7:(7)
	ha2_x = ha2_cx[3] + ((212 * 256) / 640);
	ha2_y = ha2_cy[3] - ((6 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1437*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 8:(8)
	ha2_x = ha2_cx[3] + ((147 * 256) / 640);
	ha2_y = ha2_cy[3] - ((24 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (917*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 9:(9)
	ha2_x = ha2_cx[3] + ((30 * 256) / 640);
	ha2_y = ha2_cy[3] - ((14 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1708*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 10:(0)
	ha2_x = ha2_cx[3];
	ha2_y = ha2_cy[3];
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (478*60)/1000);
	waitDanceMove();

	ha2_dance_ng_N();
	poseDanceObj(btMyIndex, HA2_ANM_STOP);
}

//------------------------------------------
// p^[Q
//------------------------------------------
static void ha2_dance_02(void)
{
	ha2_seq_num = 10;

	// 1:(1)
	poseDanceObj(btMyIndex, HA2_ANM_TURN_R);
	ha2_x = ha2_cx[3] - ((8 * 256) / 640);
	ha2_y = ha2_cy[3] - ((30 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (525*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 2:(2)
	ha2_x = ha2_cx[3] + ((33 * 256) / 640);
	ha2_y = ha2_cy[3] - ((49 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (653*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 3:(3)
	ha2_x = ha2_cx[3] + ((68 * 256) / 640);
	ha2_y = ha2_cy[3] - ((24 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (630*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 4:(4)
	ha2_x = ha2_cx[3] + ((111 * 256) / 640);
	ha2_y = ha2_cy[3] - ((11 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (618*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 5:(5)
	ha2_x = ha2_cx[3] + ((202 * 256) / 640);
	ha2_y = ha2_cy[3] - ((6 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1066*60)/1000);
	waitDanceMove();

	ha2_dance_ng_N();
	waitOnly(30);

	poseDanceObj(btMyIndex, HA2_ANM_TURN_R);
	// 6:(6)
	ha2_x = ha2_cx[3] + ((102 * 256) / 640);
	ha2_y = ha2_cy[3] + ((21 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1404*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 7:(7)
	ha2_x = ha2_cx[3] + ((27 * 256) / 640);
	ha2_y = ha2_cy[3] + ((16 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (888*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 8:(8)
	ha2_x = ha2_cx[3] - ((10 * 256) / 640);
	ha2_y = ha2_cy[3] + ((40 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (647*60)/1000);
	waitDanceMove();

	ha2_dance_ng_N();
	waitOnly(30);

	poseDanceObj(btMyIndex, HA2_ANM_TURN_R);
	// 9:(9)
	ha2_x = ha2_cx[3] - ((74 * 256) / 640);
	ha2_y = ha2_cy[3] + ((19 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (936*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 10:(0)
	ha2_x = ha2_cx[3];
	ha2_y = ha2_cy[3];
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1028*60)/1000);
	waitDanceMove();

	ha2_dance_ng_N();
	poseDanceObj(btMyIndex, HA2_ANM_STOP);
}

//------------------------------------------
// p^[R
//------------------------------------------
static void ha2_dance_03(void)
{
	ha2_seq_num = 10;

	// 1:(1)
	poseDanceObj(btMyIndex, HA2_ANM_TURN_R);
	ha2_x = ha2_cx[3] + ((7 * 256) / 640);
	ha2_y = ha2_cy[3] + ((45 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (721*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 2:(2)
	ha2_x = ha2_cx[3] - ((62 * 256) / 640);
	ha2_y = ha2_cy[3] + ((23 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1003*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 3:(3)
	ha2_x = ha2_cx[3] - ((119 * 256) / 640);
	ha2_y = ha2_cy[3] + ((4 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (837*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 4:(4)
	ha2_x = ha2_cx[3] + ((94 * 256) / 640);
	ha2_y = ha2_cy[3] - ((2 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (2433*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 5:(5)
	ha2_x = ha2_cx[3] + ((204 * 256) / 640);
	ha2_y = ha2_cy[3] - ((11 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1321*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 6:(6)
	ha2_x = ha2_cx[3] + ((125 * 256) / 640);
	ha2_y = ha2_cy[3] - ((29 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1074*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 7:(7)
	ha2_x = ha2_cx[3] + ((70 * 256) / 640);
	ha2_y = ha2_cy[3] - ((41 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (742*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 8:(8)
	ha2_x = ha2_cx[3] + ((18 * 256) / 640);
	ha2_y = ha2_cy[3] - ((52 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (698*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 9:(9)
	ha2_x = ha2_cx[3] + ((9 * 256) / 640);
	ha2_y = ha2_cy[3] - ((28 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (452*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 10:(0)
	ha2_x = ha2_cx[3];
	ha2_y = ha2_cy[3];
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (509*60)/1000);
	waitDanceMove();

	ha2_dance_ng_N();
	poseDanceObj(btMyIndex, HA2_ANM_STOP);
}

//------------------------------------------
// p^[S
//------------------------------------------
static void ha2_dance_04(void)
{
	ha2_seq_num = 10;

	// 1:(1)
	poseDanceObj(btMyIndex, HA2_ANM_TURN_R);
	ha2_x = ha2_cx[3] - ((48 * 256) / 640);
	ha2_y = ha2_cy[3] + ((3 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (566*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 2:(2)
	ha2_x = ha2_cx[3] - ((87 * 256) / 640);
	ha2_y = ha2_cy[3] - ((5 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (521*60)/1000);
	waitDanceMove();

	ha2_dance_ng_N();
	waitOnly(30);

	poseDanceObj(btMyIndex, HA2_ANM_TURN_R);
	// 3:(3)
	ha2_x = ha2_cx[3] - ((42 * 256) / 640);
	ha2_y = ha2_cy[3] + ((25 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (794*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 4:(4)
	ha2_x = ha2_cx[3] + ((22 * 256) / 640);
	ha2_y = ha2_cy[3] + ((31 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (777*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 5:(5)
	ha2_x = ha2_cx[3] + ((93 * 256) / 640);
	ha2_y = ha2_cy[3] + ((21 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (899*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 6:(6)
	ha2_x = ha2_cx[3] + ((158 * 256) / 640);
	ha2_y = ha2_cy[3] - ((21 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1136*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 7:(7)
	ha2_x = ha2_cx[3] + ((65 * 256) / 640);
	ha2_y = ha2_cy[3] - ((44 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1283*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 8:(8)
	ha2_x = ha2_cx[3] - ((19 * 256) / 640);
	ha2_y = ha2_cy[3] - ((43 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (944*60)/1000);
	waitDanceMove();

	ha2_dance_ng_N();
	waitOnly(30);
	poseDanceObj(btMyIndex, HA2_ANM_TURN_R);
	// 9:(9)
	ha2_x = ha2_cx[3] + ((2 * 256) / 640);
	ha2_y = ha2_cy[3] - ((25 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (498*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 10:(0)
	ha2_x = ha2_cx[3];
	ha2_y = ha2_cy[3];
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (374*60)/1000);
	waitDanceMove();

	ha2_dance_ng_N();
	poseDanceObj(btMyIndex, HA2_ANM_STOP);
}

//------------------------------------------
// p^[T
//------------------------------------------
static void ha2_dance_05(void)
{
	ha2_seq_num = 10;

	// 1:(1)
	poseDanceObj(btMyIndex, HA2_ANM_TURN_R);
	ha2_x = ha2_cx[3] + ((115 * 256) / 640);
	ha2_y = ha2_cy[3] - ((41 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1715*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 2:(2)
	ha2_x = ha2_cx[3] + ((180 * 256) / 640);
	ha2_y = ha2_cy[3] - ((24 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (906*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 3:(3)
	ha2_x = ha2_cx[3] + ((145 * 256) / 640);
	ha2_y = ha2_cy[3] + ((6 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (830*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 4:(4)
	ha2_x = ha2_cx[3] + ((88 * 256) / 640);
	ha2_y = ha2_cy[3] + ((22 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (806*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 5:(5)
	ha2_x = ha2_cx[3] + ((25 * 256) / 640);
	ha2_y = ha2_cy[3] + ((32 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (810*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 6:(6)
	ha2_x = ha2_cx[3] - ((54 * 256) / 640);
	ha2_y = ha2_cy[3] + ((25 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (955*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 7:(7)
	ha2_x = ha2_cx[3] - ((57 * 256) / 640);
	ha2_y = ha2_cy[3] - ((18 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (638*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 8:(8)
	ha2_x = ha2_cx[3] - ((29 * 256) / 640);
	ha2_y = ha2_cy[3] - ((57 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (703*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 9:(9)
	ha2_x = ha2_cx[3] + ((25 * 256) / 640);
	ha2_y = ha2_cy[3] - ((55 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (622*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 10:(0)
	ha2_x = ha2_cx[3];
	ha2_y = ha2_cy[3];
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (871*60)/1000);
	waitDanceMove();

	ha2_dance_ng_N();
	poseDanceObj(btMyIndex, HA2_ANM_STOP);
}

//------------------------------------------
// p^[U
//------------------------------------------
static void ha2_dance_06(void)
{
	ha2_seq_num = 10;

	// 1:(1)
	poseDanceObj(btMyIndex, HA2_ANM_TURN_L);
	ha2_x = ha2_cx[3] + ((19 * 256) / 640);
	ha2_y = ha2_cy[3] - ((25 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (458*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 2:(2)
	ha2_x = ha2_cx[3] + ((68 * 256) / 640);
	ha2_y = ha2_cy[3] - ((30 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (599*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 3:(3)
	ha2_x = ha2_cx[3] + ((110 * 256) / 640);
	ha2_y = ha2_cy[3] - ((17 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (606*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 4:(4)
	ha2_x = ha2_cx[3] + ((156 * 256) / 640);
	ha2_y = ha2_cy[3] + ((0 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (692*60)/1000);
	waitDanceMove();

	ha2_dance_ng_N();
	waitOnly(30);
	poseDanceObj(btMyIndex, HA2_ANM_TURN_L);

	// 5:(5)
	ha2_x = ha2_cx[3] + ((128 * 256) / 640);
	ha2_y = ha2_cy[3] - ((39 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (703*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 6:(6)
	ha2_x = ha2_cx[3] + ((35 * 256) / 640);
	ha2_y = ha2_cy[3] - ((51 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1165*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 7:(7)
	ha2_x = ha2_cx[3] - ((34 * 256) / 640);
	ha2_y = ha2_cy[3] - ((33 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (962*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 8:(8)
	ha2_x = ha2_cx[3] - ((54 * 256) / 640);
	ha2_y = ha2_cy[3] + ((25 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1073*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 9:(9)
	ha2_x = ha2_cx[3] + ((10 * 256) / 640);
	ha2_y = ha2_cy[3] + ((39 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (864*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 10:(0)
	ha2_x = ha2_cx[3];
	ha2_y = ha2_cy[3];
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (677*60)/1000);
	waitDanceMove();

	ha2_dance_ng_N();
	poseDanceObj(btMyIndex, HA2_ANM_STOP);
}

//------------------------------------------
// p^[V
//------------------------------------------
static void ha2_dance_07(void)
{
	ha2_seq_num = 11;

	// 1:(1)
	poseDanceObj(btMyIndex, HA2_ANM_TURN_L);
	ha2_x = ha2_cx[3] + ((19 * 256) / 640);
	ha2_y = ha2_cy[3] - ((25 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (458*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 2:(2)
	ha2_x = ha2_cx[3] + ((59 * 256) / 640);
	ha2_y = ha2_cy[3] - ((40 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (603*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 3:(3)
	ha2_x = ha2_cx[3] + ((114 * 256) / 640);
	ha2_y = ha2_cy[3] - ((42 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (633*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 4:(4)
	ha2_x = ha2_cx[3] + ((159 * 256) / 640);
	ha2_y = ha2_cy[3] - ((27 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (660*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 5:(5)
	ha2_x = ha2_cx[3] + ((182 * 256) / 640);
	ha2_y = ha2_cy[3] + ((0 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (511*60)/1000);
	waitDanceMove();

	ha2_dance_ng_N();
	waitOnly(30);
	poseDanceObj(btMyIndex, HA2_ANM_TURN_L);

	// 6:(6)
	ha2_x = ha2_cx[3] + ((91 * 256) / 640);
	ha2_y = ha2_cy[3] + ((0 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1011*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 7:(7)
	ha2_x = ha2_cx[3] - ((0 * 256) / 640);
	ha2_y = ha2_cy[3] - ((0 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1011*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 8:(8)
	ha2_x = ha2_cx[3] - ((55 * 256) / 640);
	ha2_y = ha2_cy[3] + ((20 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1843*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 9:(9)
	ha2_x = ha2_cx[3] + ((5 * 256) / 640);
	ha2_y = ha2_cy[3] + ((43 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (910*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 10:(9)
	ha2_x = ha2_cx[3] + ((59 * 256) / 640);
	ha2_y = ha2_cy[3] + ((25 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (793*60)/1000);
	waitDanceMove();

	ha2_dance_ng_L();
	// 11:(0)
	ha2_x = ha2_cx[3];
	ha2_y = ha2_cy[3];
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (918*60)/1000);
	waitDanceMove();

	ha2_dance_ng_N();
	poseDanceObj(btMyIndex, HA2_ANM_STOP);
}

//------------------------------------------
// p^[W
//------------------------------------------
static void ha2_dance_08(void)
{
	ha2_seq_num = 11;

	// 1:(1)
	poseDanceObj(btMyIndex, HA2_ANM_TURN_R);
	ha2_x = ha2_cx[3] - ((59 * 256) / 640);
	ha2_y = ha2_cy[3] + ((20 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (869*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 2:(2)
	ha2_x = ha2_cx[3] + ((23 * 256) / 640);
	ha2_y = ha2_cy[3] + ((39 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (1118*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 3:(0)
	ha2_x = ha2_cx[3] + ((0 * 256) / 640);
	ha2_y = ha2_cy[3] + ((0 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (830*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 4:(3)
	ha2_x = ha2_cx[3] + ((69 * 256) / 640);
	ha2_y = ha2_cy[3] + ((7 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (821*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 5:(4)
	ha2_x = ha2_cx[3] + ((132 * 256) / 640);
	ha2_y = ha2_cy[3] + ((12 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (755*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 6:(5)
	ha2_x = ha2_cx[3] + ((129 * 256) / 640);
	ha2_y = ha2_cy[3] - ((15 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (416*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 7:(6)
	ha2_x = ha2_cx[3] + ((126 * 256) / 640);
	ha2_y = ha2_cy[3] - ((40 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (388*60)/1000);
	waitDanceMove();

	ha2_dance_ng_N();
	waitOnly(30);
	poseDanceObj(btMyIndex, HA2_ANM_TURN_R);

	// 8:(7)
	ha2_x = ha2_cx[3] + ((100 * 256) / 640);
	ha2_y = ha2_cy[3] - ((30 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (394*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 9:(8)
	ha2_x = ha2_cx[3] + ((71 * 256) / 640);
	ha2_y = ha2_cy[3] - ((22 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (408*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 10:(9)
	ha2_x = ha2_cx[3] + ((39 * 256) / 640);
	ha2_y = ha2_cy[3] - ((12 * 192) / 480);
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (463*60)/1000);
	waitDanceMove();

	ha2_dance_ng_R();
	// 11:(0)
	ha2_x = ha2_cx[3];
	ha2_y = ha2_cy[3];
	moveDanceObj(btMyIndex, ha2_x, ha2_y, (562*60)/1000);
	waitDanceMove();

	ha2_dance_ng_N();
	poseDanceObj(btMyIndex, HA2_ANM_STOP);
}


//----------------------------------------------------------
// Q̑䎌
//----------------------------------------------------------
static void ha02_000(void)
{
	if (getLabel(LF_ha02_000) == OFF)
	{
		if (getageWidth() == ageC)
			setScript(_FE02_PSC, FE02_FE02_1);
		else
		if (getageWidth() == ageL)
			setScript(_FE02_PSC, FE02_FE02_2);
		else
			setScript(_FE02_PSC, FE02_FE02_3);
		waitScript();
		setLabel(LF_ha02_000, ON);
	} else {
		if (getageWidth() == ageC)
			setScript(_FE02_PSC, FE02_FE02_4);
		else
		if (getageWidth() == ageL)
			setScript(_FE02_PSC, FE02_FE02_5);
		else
			setScript(_FE02_PSC, FE02_FE02_6);
		waitScript();
	}
}

//--------------------------
// I
//--------------------------
static void ha02_001(void)
{
	waitOnly(30);
	endDanceObj();

	bt_func_set_win_name();

	setChangeLock(TRUE);
	putDanceBG(FALSE);
	setBgNum(BG_har_bg02);		// wi
	setChangeLock(FALSE);
	waitChangeGraph();
	putResult23();
	waitChangeGraph();
	// Zp
	putResult3name();
	waitOnly(60);
	// |p
	putResult2name();
	waitOnly(60);
	// D
	putResult1();
	waitChangeGraph();
	setScript(_FE02_PSC, FE02_FE02_10);
	waitScript();
	putResult1name();
	setScript(_FE02_PSC, FE02_FE02_10A);
	waitScript();

	// ̃gtB[^
	if (getbtWinNo(0) == btcDA)
	{
		if (getageWidth() == ageC)
			setBgNum(BG_ev44a);
		else
		if (getageWidth() == ageL)
			setBgNum(BG_ev44b);
		else
			setBgNum(BG_ev44c);
		waitChangeGraph();
		setScript(_FE02_PSC, FE02_HA02_001);
		waitScript();
	}
// l̂t
	switch (getbtWinNo(0))
	{
		case btcDA:		// 
			if (getageWidth() == ageC)
				setScript(_FE02_PSC, FE02_FE02_26);
			else
			if (getageWidth() == ageL)
				setScript(_FE02_PSC, FE02_FE02_27);
			else
				setScript(_FE02_PSC, FE02_FE02_28);
			waitScript();
			break;

		case btcKR:
			if (getageWidth() == ageC)
				setScript(_FE02_PSC, FE02_FE02_29);
			else
			if (getageWidth() == ageL)
				setScript(_FE02_PSC, FE02_FE02_30);
			else
				setScript(_FE02_PSC, FE02_FE02_31);
			waitScript();
			break;

		case btcMI:
			if (getageWidth() == ageC)
				setScript(_FE00_PSC, FE00_FE00_89);
			else
			if (getageWidth() == ageL)
				setScript(_FE00_PSC, FE00_FE00_92);
			else
				setScript(_FE00_PSC, FE00_FE00_95);
			waitScript();
			break;

		case btcRA:
			if (getageWidth() == ageC)
				setScript(_FE00_PSC, FE00_FE00_98);
			else
			if (getageWidth() == ageL)
				setScript(_FE00_PSC, FE00_FE00_101);
			else
				setScript(_FE00_PSC, FE00_FE00_104);
			waitScript();
			break;

		default:
			;
	}
	fe00_conY();		// sǂ̏ꍇi͒łĂ܂j

	//-------------------------------
	// ȍ~AƃNX`[ỉbiKj
	//-------------------------------
	setChangeLock(TRUE);
	clearMessage();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setBgNum(BG_bg01);
	setChangeLock(FALSE);
	waitChangeGraph();

	if (getbtWinNo(0) == btcDA)
	{
		// D
		if (getageWidth() == ageC)
			setScript(_FE02_PSC, FE02_FE02_23);
		else
		if (getageWidth() == ageL)
			setScript(_FE02_PSC, FE02_FE02_24);
		else
			setScript(_FE02_PSC, FE02_FE02_25);
		waitScript();
	} else
	if (getbtWinNo(0) == btcKR)
	{
		// NX`[iD
		if (getageWidth() == ageC)
			setScript(_FE02_PSC, FE02_FE02_17);
		else
		if (getageWidth() == ageL)
			setScript(_FE02_PSC, FE02_FE02_18);
		else
			setScript(_FE02_PSC, FE02_FE02_19);
		waitScript();
	} else {
		// ANX`[iɗDŖꍇ
		if (getageWidth() == ageC)
			setScript(_FE02_PSC, FE02_FE02_32);
		else
		if (getageWidth() == ageL)
			setScript(_FE02_PSC, FE02_FE02_33);
		else
			setScript(_FE02_PSC, FE02_FE02_34);
		waitScript();
	}
}

//----------------------------------
// xȌЉ
//----------------------------------
static void ha02_002(void)
{
	switch (bt_tstate[btMyIndex])
	{
		case btcDA:		// 
			setEnemyName(1);
			break;
		case btcKR:
			setEnemyName(3);
			break;
		case btcRA:
			setEnemyName(7);
			break;
		case btcMI:
			setEnemyName(9);
			break;
	}
	switch (btMyIndex)
	{
		case 3:
			setScript(_FE02_PSC, FE02_HA02_002A);
			break;
		case 2:
			setScript(_FE02_PSC, FE02_HA02_002B);
			break;
		case 1:
			setScript(_FE02_PSC, FE02_HA02_002C);
			break;
		case 0:
			setScript(_FE02_PSC, FE02_HA02_002D);
			break;
	}
	waitScript();
}

//----------------------------------
// x蒼Ȏ䎌ieLj
//----------------------------------
static void ha02_003(void)
{
	switch (bt_tstate[btMyIndex])
	{
		case btcDA:
			if (getageWidth() == ageC)
				setScript(_FE02_PSC, FE02_HA02_003A);
			else
			if (getageWidth() == ageL)
				setScript(_FE02_PSC, FE02_HA02_003B);
			else
				setScript(_FE02_PSC, FE02_HA02_003C);
			break;

		case btcKR:
			if (getageWidth() == ageC)
				setScript(_FE02_PSC, FE02_HA02_003D);
			else
				setScript(_FE02_PSC, FE02_HA02_003E);
			break;

		case btcRA:
			setScript(_FE02_PSC, FE02_HA02_003F);
			break;

		case btcMI:
			setScript(_FE02_PSC, FE02_HA02_003G);
			break;
	}
	waitScript();
}

//----------------------------------
// //x肪IƂ
//----------------------------------
static void ha02_004(void)
{
	switch (btEnemy)
	{
		case 0:
			if (btMyIndex == 0)
				setScript(_FE02_PSC, FE02_HA02_004A);
			else
			if (btMyIndex == 1)
				setScript(_FE02_PSC, FE02_HA02_004B);
			else
			if (btMyIndex == 2)
				setScript(_FE02_PSC, FE02_HA02_004C);
			else
			if (btMyIndex == 3)
				setScript(_FE02_PSC, FE02_HA02_004D);
			waitScript();
			break;

		case 1:
			if (btMyIndex == 0)
				setScript(_FE02_PSC, FE02_HA02_004E);
			else
			if (btMyIndex == 1)
				setScript(_FE02_PSC, FE02_HA02_004F);
			else
			if (btMyIndex == 2)
				setScript(_FE02_PSC, FE02_HA02_004G);
			else
			if (btMyIndex == 3)
				setScript(_FE02_PSC, FE02_HA02_004H);
			waitScript();
			break;

		case 2:
			if (btMyIndex == 0)
				setScript(_FE02_PSC, FE02_HA02_004I);
			else
			if (btMyIndex == 1)
				setScript(_FE02_PSC, FE02_HA02_004J);
			else
			if (btMyIndex == 2)
				setScript(_FE02_PSC, FE02_HA02_004K);
			else
			if (btMyIndex == 3)
				setScript(_FE02_PSC, FE02_HA02_004L);
			waitScript();
			break;
	}
}

