//---------------------------------------------------------------------------
//
//	܂XNvg
//
//---------------------------------------------------------------------------
#include <nitro.h>
#include "bds_lib.h"
#include "pack_data.h"
#include "game.h"
#include "prime4.h"
#include "omake.h"
#include "graph.h"
#include "event_grp.h"
#include "script.h"
#include "item.h"
#include "sound_data.h"
#include "def/omk00_def.h"
#include "def/omk01_def.h"
#include "def/omk02_def.h"
#include "def/omk03_def.h"
#include "def/omk04_def.h"
#include "def/omk05_def.h"
#include "def/omk06_def.h"
#include "def/omk07_def.h"
#include "def/omk08_def.h"
#include "def/omk09_def.h"
#include "def/omk10_def.h"
#include "def/omk11_def.h"
#include "def/omk12_def.h"
#include "def/omk13_def.h"
#include "def/omk14_def.h"
#include "def/omk15_def.h"
#include "def/omk16_def.h"
#include "def/omk17_def.h"
#include "def/omk18_def.h"
#include "def/omk19_def.h"
#include "def/omk01v2_def.h"
#include "def/omk02v2_def.h"
#include "def/omk_touch_def.h"

// -------------------------------------
// 萔`
// -------------------------------------
#define OMAKE_MODE_INIT				0
#define OMAKE_MODE_WAIT				1
#define OMAKE_MODE_MAIN				2
#define OMAKE_MODE_OSAWARI_START	3
#define OMAKE_MODE_OSAWARI_WAIT		4
#define OMAKE_MODE_OSAWARI_MAIN		5
#define OMAKE_MODE_OSAWARI_SCRIPT	6
#define OMAKE_MODE_OSAWARI_END		7

#define OSAWARI_POS_ATAMA			0
#define OSAWARI_POS_KAO				1
#define OSAWARI_POS_KATA			2
#define OSAWARI_POS_MUNE			3
#define OSAWARI_POS_UDE				4
#define OSAWARI_POS_ONAKA			5
#define OSAWARI_POS_KOSI			6


// -------------------------------------
// NXE\̒`
// -------------------------------------
// -------------------------------------
// [Jϐ`
// -------------------------------------
static u8
	g_step,
	g_count,
	g_decide,
	NextOmkNo,
	g_script_num,
	nTouch[7][3];
static s16
	g_touch_script_req,
	g_wait;

static s16
	g_touch_script[7][3][3] = 
	{
		{
			{ OMK_TOUCH_TOUCH_ATAMA_ASA_0, OMK_TOUCH_TOUCH_ATAMA_ASA_1, OMK_TOUCH_TOUCH_ATAMA_ASA_2 },
			{ OMK_TOUCH_TOUCH_ATAMA_HIRU_0, OMK_TOUCH_TOUCH_ATAMA_HIRU_1, OMK_TOUCH_TOUCH_ATAMA_HIRU_2 },
			{ OMK_TOUCH_TOUCH_ATAMA_YORU_0, OMK_TOUCH_TOUCH_ATAMA_YORU_1, OMK_TOUCH_TOUCH_ATAMA_YORU_2 }
		}, {
			{ OMK_TOUCH_TOUCH_KAO_ASA_0, OMK_TOUCH_TOUCH_KAO_ASA_1, OMK_TOUCH_TOUCH_KAO_ASA_2 },
			{ OMK_TOUCH_TOUCH_KAO_HIRU_0, OMK_TOUCH_TOUCH_KAO_HIRU_1, OMK_TOUCH_TOUCH_KAO_HIRU_2 },
			{ OMK_TOUCH_TOUCH_KAO_YORU_0, OMK_TOUCH_TOUCH_KAO_YORU_1, OMK_TOUCH_TOUCH_KAO_YORU_2 }
		}, {
			{ OMK_TOUCH_TOUCH_KATA_ASA_0, OMK_TOUCH_TOUCH_KATA_ASA_1, OMK_TOUCH_TOUCH_KATA_ASA_2 },
			{ OMK_TOUCH_TOUCH_KATA_HIRU_0, OMK_TOUCH_TOUCH_KATA_HIRU_1, OMK_TOUCH_TOUCH_KATA_HIRU_2 },
			{ OMK_TOUCH_TOUCH_KATA_YORU_0, OMK_TOUCH_TOUCH_KATA_YORU_1, OMK_TOUCH_TOUCH_KATA_YORU_2 }
		}, {
			{ OMK_TOUCH_TOUCH_MUNE_ASA_0, OMK_TOUCH_TOUCH_MUNE_ASA_1, OMK_TOUCH_TOUCH_MUNE_ASA_2 },
			{ OMK_TOUCH_TOUCH_MUNE_HIRU_0, OMK_TOUCH_TOUCH_MUNE_HIRU_1, OMK_TOUCH_TOUCH_MUNE_HIRU_2 },
			{ OMK_TOUCH_TOUCH_MUNE_YORU_0, OMK_TOUCH_TOUCH_MUNE_YORU_1, OMK_TOUCH_TOUCH_MUNE_YORU_2 }
		}, {
			{ OMK_TOUCH_TOUCH_UDE_ASA_0, OMK_TOUCH_TOUCH_UDE_ASA_1, OMK_TOUCH_TOUCH_UDE_ASA_2 },
			{ OMK_TOUCH_TOUCH_UDE_HIRU_0, OMK_TOUCH_TOUCH_UDE_HIRU_1, OMK_TOUCH_TOUCH_UDE_HIRU_2 },
			{ OMK_TOUCH_TOUCH_UDE_YORU_0, OMK_TOUCH_TOUCH_UDE_YORU_1, OMK_TOUCH_TOUCH_UDE_YORU_2 }
		}, {
			{ OMK_TOUCH_TOUCH_ONAKA_ASA_0, OMK_TOUCH_TOUCH_ONAKA_ASA_1, OMK_TOUCH_TOUCH_ONAKA_ASA_2 },
			{ OMK_TOUCH_TOUCH_ONAKA_HIRU_0, OMK_TOUCH_TOUCH_ONAKA_HIRU_1, OMK_TOUCH_TOUCH_ONAKA_HIRU_2 },
			{ OMK_TOUCH_TOUCH_ONAKA_YORU_0, OMK_TOUCH_TOUCH_ONAKA_YORU_1, OMK_TOUCH_TOUCH_ONAKA_YORU_2 }
		}, {
			{ OMK_TOUCH_TOUCH_KOSI_ASA_0, OMK_TOUCH_TOUCH_KOSI_ASA_1, OMK_TOUCH_TOUCH_KOSI_ASA_2 },
			{ OMK_TOUCH_TOUCH_KOSI_HIRU_0, OMK_TOUCH_TOUCH_KOSI_HIRU_1, OMK_TOUCH_TOUCH_KOSI_HIRU_2 },
			{ OMK_TOUCH_TOUCH_KOSI_YORU_0, OMK_TOUCH_TOUCH_KOSI_YORU_1, OMK_TOUCH_TOUCH_KOSI_YORU_2 }
		}
	};


// -------------------------------------
// [J֐`
// -------------------------------------
static void initOmakeScreen(void);
static void waitOmakeMode(void);
static void mainOmakeMode(void);
static void omake1main(void);
static void omk00(void);
static void omk01(void);
static void omk02(void);
static void omk03(void);
static void omk04(void);
static void omk05(void);
static void omk06(void);
static void omk07(void);
static void omk08(void);
static void omk09(void);
static void omk10(void);
static void omk11(void);
static void omk12(void);
static void omk13(void);
static void omk14(void);
static void omk15(void);
static void omk16(void);
static void omk17(void);
static void omk18(void);
static void omk19(void);
static void osawari(void);
static void omake2main(void);
static void omake3main(void);
static void startOsawari(void);
static void waitOsawari(void);
static void mainOsawari(void);
static void scriptOsawari(void);
static void endOsawari(void);

//---------------------------------------------------------------------------
//
// ֐
//
//---------------------------------------------------------------------------
// -------------------------------------
//  
// -------------------------------------
void initOmakeScript(void)
{
	g_step = OMAKE_MODE_INIT;
}

// -------------------------------------
//  C
// -------------------------------------
void execOmakeScript(void)
{
	switch (g_step)
	{
		case OMAKE_MODE_INIT:
			initOmakeScreen();
			break;
		case OMAKE_MODE_WAIT:
			waitOmakeMode();
			break;
		case OMAKE_MODE_MAIN:
			mainOmakeMode();
			break;
		case OMAKE_MODE_OSAWARI_START:
			startOsawari();
			break;
		case OMAKE_MODE_OSAWARI_WAIT:
			waitOsawari();
			break;
		case OMAKE_MODE_OSAWARI_MAIN:
			mainOsawari();
			break;
		case OMAKE_MODE_OSAWARI_SCRIPT:
			scriptOsawari();
			break;
		case OMAKE_MODE_OSAWARI_END:
			endOsawari();
			break;
		default:
			;
	}
}

// -------------------------------------
//  C
// -------------------------------------
void setOmakeScript(int in_num)
{
	g_script_num = (u8)in_num;
}

// -------------------------------------
//  ʏ
// -------------------------------------
static void initOmakeScreen(void)
{
	initEventGraph(2);
	setScriptGraph();

	g_step = OMAKE_MODE_WAIT;
}

// -------------------------------------
//  \EFCg
// -------------------------------------
static void waitOmakeMode(void)
{
	if (!isFlipBmpBuf())
	{
		if (g_script_num == 0)
			setScriptThread(omake1main);
		else
		if (g_script_num == 1)
			setScriptThread(omake2main);
		else
			setScriptThread(omake3main);
		g_step = OMAKE_MODE_MAIN;
	}
	execBmpBuf();
}

// -------------------------------------
//  ʕ\
// -------------------------------------
static void mainOmakeMode(void)
{
	if (isEndScriptThread())
	{
		stopBGM();
		exitEventGraph();
		changeGameMode(GAME_MODE_OMAKE);
	} else {
		execScript();
		execEventGraph();
	}
}

// -------------------------------------
//  L[ûȂ
// -------------------------------------
static void omake1main(void)
{
	int i;

	// v̕ϐݒ
	initGameValue();
	initParam();

	NextOmkNo = 0;
	setDays(97, 5, 2, 0);

	setPolicy(0);
	setGold(2000);
	setAge(10);
	setDress(1);
	setcon(conN);
	setageWidth(ageC);
	setRoomPic(0);

	// Q[ŎgpXNvg̕ϐNA
	setTimeZone(0);
	setGameY(0);
	setGameM(0);

	for (i=0; i<3; i++)
	{
		nTouch[OSAWARI_POS_ATAMA][i] = 0;
		nTouch[OSAWARI_POS_KAO][i] = 0;
		nTouch[OSAWARI_POS_KATA][i] = 0;
		nTouch[OSAWARI_POS_MUNE][i] = 0;
		nTouch[OSAWARI_POS_UDE][i] = 0;
		nTouch[OSAWARI_POS_ONAKA][i] = 0;
		nTouch[OSAWARI_POS_KOSI][i] = 0;
	}

	// ViIX^[g
	//MenuCallFlag = OFF;
	do
	{
		switch (NextOmkNo)
		{
			case 0:
				omk00();
				break;
			case 1:
				setOmakeTitleGraph(0);
				omk01();
				break;
			case 2:
				omk02();
				break;
			case 3:
				omk03();
				break;
			case 4:
				omk04();
				break;
			case 5:
				omk05();
				break;
			case 6:
				omk06();
				break;
			case 7:
				omk07();
				break;
			case 8:
				omk08();
				break;
			case 9:
				omk09();
				break;
			case 10:
				omk10();
				break;
			case 11:
				omk11();
				break;
			case 12:
				omk12();
				break;
			case 13:
				omk13();
				break;
			case 14:
				omk14();
				break;
			case 15:
				omk15();
				break;
			case 16:
				omk16();
				break;
			case 17:
				omk17();
				break;
			case 18:
				omk18();
				break;
			case 19:
				omk19();
				break;
		}
	} while (NextOmkNo != 0);

	setBgNum(BG_black);
	waitChangeGraph();
	waitOnly(120);
	setBgNum(BG_ed_fin2);
	waitChangeGraph();
	waitOnly(600);
	setBgNum(BG_black);
	waitChangeGraph();
}

//----------------------------------------------------------
//Cxg00uv[Ov
//----------------------------------------------------------
static void omk00(void)
{
	setBGM(SEQ_PRM4_35);
	playBGM();

	setTimeZone(2);
	setBgNum(BG_bgr000);
	waitChangeGraph();
	waitOnly(20);
	setTextMode(1);

	setScript(_OMK00_PSC, OMK00_OMK00);
	waitScript();

	NextOmkNo = 1;
}

//----------------------------------------------------------
//Cxg01uppA͂悤v
//----------------------------------------------------------
static void omk01(void)
{
	setTimeZone(0);
	setDress(16);
	setScript(_OMK01_PSC, OMK01_OMK01);
	waitScript();

	if (getScriptEndCode() == 0)
		NextOmkNo = 2;
	else
		NextOmkNo = 3;
}

//----------------------------------------------------------
//Cxg02ûւv
//----------------------------------------------------------
static void omk02(void)
{
	setTimeZone(0);
	setDress(16);
	setScript(_OMK02_PSC, OMK02_OMK02);
	waitScript();
	setDress(1);
	setScript(_OMK02_PSC, OMK02_OMK02_00);
	waitScript();

	NextOmkNo = 6;
}

//----------------------------------------------------------
//Cxg03u͂v
//----------------------------------------------------------
static void omk03(void)
{
	setTimeZone(0);
	setDress(1);

	setScript(_OMK03_PSC, OMK03_OMK03);
	waitScript();

	if (getScriptEndCode() == 0)
		NextOmkNo = 4;
	else
		NextOmkNo = 5;
}

//----------------------------------------------------------
//Cxg04uӂӂv
//----------------------------------------------------------
static void omk04(void)
{
	setDress(1);
	setTimeZone(0);

	setScript(_OMK04_PSC, OMK04_OMK04);
	waitScript();

	setTimeZone(1);
	NextOmkNo = 7;
	//MenuCallFlag = ON;
}

//----------------------------------------------------------
//Cxg05u݂͂ł邩ȁv
//----------------------------------------------------------
static void omk05(void)
{
	setDress(1);
	setTimeZone(0);

	setScript(_OMK05_PSC, OMK05_OMK05);
	waitScript();

	setTimeZone(0);
	NextOmkNo = 9;
	//MenuCallFlag = ON;
}

//----------------------------------------------------------
//Cxg06u󂵂܂傤v
//----------------------------------------------------------
static void omk06(void)
{
	setDress(1);
	setTimeZone(0);

	setScript(_OMK06_PSC, OMK06_OMK06);
	waitScript();

	osawari();

	setScript(_OMK06_PSC, OMK06_OMK06_00);
	waitScript();

	NextOmkNo = 19;
	setTimeZone(0);
	//MenuCallFlag = ON;
}

//----------------------------------------------------------
//Cxg07uƎ`v
//----------------------------------------------------------
static void omk07(void)
{
	setDress(1);
	setTimeZone(0);

	setScript(_OMK07_PSC, OMK07_OMK07);
	waitScript();

	NextOmkNo = 8;
}

//----------------------------------------------------------
//Cxg08uׂ񂫂傤ł܂邮v
//----------------------------------------------------------
static void omk08(void)
{
	setDress(1);
	setTimeZone(0);

	setScript(_OMK08_PSC, OMK08_OMK08);
	waitScript();

	setTimeZone(1);

	setScript(_OMK08_PSC, OMK08_OMK08_00);
	waitScript();

	osawari();

	setScript(_OMK08_PSC, OMK08_OMK08_10);
	waitScript();

	if (getScriptEndCode() == 0)
	{
		NextOmkNo = 14;
		//MenuCallFlag = ON;
	} else {
		NextOmkNo = 11;
		setTimeZone(2);
		//MenuCallFlag = ON;
	}
}

//----------------------------------------------------------
//Cxg09uƂv
//----------------------------------------------------------
static void omk09(void)
{
	setDress(1);
	setTimeZone(0);

	setScript(_OMK09_PSC, OMK09_OMK09);
	waitScript();

	if (getLabel(LF_omk06) == ON)
	{
		//Q@Cxg06u󂵂܂傤vĂꍇ
		//Ó]
		//Cxg10uЂ˂悤v
		NextOmkNo = 10;
	} else {
		//P@Cxg05u݂͂ł邩ȁvĂꍇ
		//Ó]
		//Cxg08uׂ񂫂傤ł܂邮v
		NextOmkNo = 8;
	}
}

//----------------------------------------------------------
//Cxg10uЂ˂悤v
//----------------------------------------------------------
static void omk10(void)
{
	setDress(1);
	setTimeZone(1);

	setScript(_OMK10_PSC, OMK10_OMK10);
	waitScript();

	osawari();

	setScript(_OMK10_PSC, OMK10_OMK10_00);
	waitScript();

	NextOmkNo = 12;
	setTimeZone(2);
	//MenuCallFlag = ON;
}

//----------------------------------------------------------
//Cxg11uv
//----------------------------------------------------------
static void omk11(void)
{
	setDress(16);
	setTimeZone(2);

	setScript(_OMK11_PSC, OMK11_OMK11);
	waitScript();

	osawari();

	setScript(_OMK11_PSC, OMK11_OMK11_00);
	waitScript();

	NextOmkNo = 15;
}

//----------------------------------------------------------
//Cxg12u΂邼v
//----------------------------------------------------------
static void omk12(void)
{
	setDress(1);
	setTimeZone(1);

	setScript(_OMK12_PSC, OMK12_OMK12);
	waitScript();

	NextOmkNo = 13;
}

//----------------------------------------------------------
//Cxg13u`v
//----------------------------------------------------------
static void omk13(void)
{
	setTimeZone(2);
	setDress(1);

	setScript(_OMK13_PSC, OMK13_OMK13);
	waitScript();

	osawari();

	setScript(_OMK13_PSC, OMK13_OMK13_00);
	waitScript();

	if (getScriptEndCode() == 0)
	{
		NextOmkNo = 14;
	} else {
		setDress(16);
		setScript(_OMK13_PSC, OMK13_OMK13_1_00);
		waitScript();
		NextOmkNo = 17;
		//MenuCallFlag = ON;
	}
}

//----------------------------------------------------------
//Cxg14uv
//----------------------------------------------------------
static void omk14(void)
{
	setTimeZone(2);
	setDress(1);

	setScript(_OMK14_PSC, OMK14_OMK14);
	waitScript();

	NextOmkNo = 16;
}

//----------------------------------------------------------
//Cxg15u킢͂ȂHv
//----------------------------------------------------------
static void omk15(void)
{
	setDress(16);
	setTimeZone(2);

	setScript(_OMK15_PSC, OMK15_OMK15);
	waitScript();

	NextOmkNo = 17;
	//MenuCallFlag = ON;
}

//----------------------------------------------------------
//Cxg16upp̃pW}Hv
//----------------------------------------------------------
static void omk16(void)
{
	setDress(16);
	setTimeZone(2);

	setScript(_OMK16_PSC, OMK16_OMK16);
	waitScript();

	NextOmkNo = 17;
	//MenuCallFlag = ON;
}

//----------------------------------------------------------
//Cxg17u₷݂Ȃv
//----------------------------------------------------------
static void omk17(void)
{
	setDress(16);
	setTimeZone(2);

	setScript(_OMK17_PSC, OMK17_OMK17);
	waitScript();

	NextOmkNo = 18;
}

//----------------------------------------------------------
//Cxg18u˂ނȂ́v
//----------------------------------------------------------
static void omk18(void)
{
	setTimeZone(2);
	setDress(16);

	setScript(_OMK18_PSC, OMK18_OMK18);
	waitScript();

	//if (getLabel(LF_OMAKE_04_FLAG) == ON && getLabel(LF_OMAKE_05_FLAG) == ON && getLabel(LF_OMAKE_06_FLAG) == ON)
	if (getAlbum(BG_omk04) && getAlbum(BG_omk05) && getAlbum(BG_omk06))
	{
		setScript(_OMK18_PSC, OMK18_OMK18_00);
		waitScript();
		//tO
		//P@Cxg12u΂邼vĂ
		//Q@Cxg14uvĂ
		//R@L̏𖞂ĂȂ
		if (getLabel(LF_omk12) == ON)
		{
			setScript(_OMK18_PSC, OMK18_OMK18_0);
			waitScript();
		} else
		if (getLabel(LF_omk14) == ON)
		{
			setScript(_OMK18_PSC, OMK18_OMK18_1);
			waitScript();
		} else {
			setScript(_OMK18_PSC, OMK18_OMK18_2);
			waitScript();
		}
	}
	setScript(_OMK18_PSC, OMK18_OMK18_END);
	waitScript();

	NextOmkNo = 0;
}

//----------------------------------------------------------
//Cxg19u܂܂Ɓv
//----------------------------------------------------------
static void omk19(void)
{
	setTimeZone(0);
	setDress(1);

	setScript(_OMK19_PSC, OMK19_OMK19);
	waitScript();

	NextOmkNo = 9;
}



// -------------------------------------
//  ܂ViIQ@C
// -------------------------------------
static void omake2main(void)
{
	setOmakeTitleGraph(1);

	initGameValue();
	initParam();
	setDress(1);

	setTimeZone(0);
	setageWidth(ageL);

	setScript(_OMK01V2_PSC, OMK01V2_OMK02_0);
	waitScript();

	setBgNum(BG_black);
	waitChangeGraph();
	waitOnly(120);
	setBgNum(BG_ed_fin2);
	waitChangeGraph();
	waitOnly(600);
	setBgNum(BG_black);
	waitChangeGraph();
}


// -------------------------------------
//  ܂ViIR@V
// -------------------------------------
static void omake3main(void)
{
	int name_f;

	setOmakeTitleGraph(2);

	initGameValue();
	initParam();
	setDress(1);

	setTimeZone(0);
	setageWidth(ageH);

	setScript(_OMK02V2_PSC, OMK02V2_OMK03_0);
	waitScript();
	name_f = getScriptEndCode();
	//omk201û͂܂v
	if (name_f == 0)
		setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL01_0);
	else
	if (name_f == 1)
		setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL01_1);
	else
		setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL01_2);
	waitScript();
	if (name_f == 0)
		setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL02_0);
	else
	if (name_f == 1)
		setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL02_1);
	else
		setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL02_2);
	waitScript();
	if (name_f == 0)
		setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL03_0);
	else
	if (name_f == 1)
		setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL03_1);
	else
		setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL03_2);
	waitScript();
	//omk202u͂v
	if (getLabel(o3_select03_0) == ON)
	{
		//omk206u󂵂܂v
		if (name_f == 0)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL10_0);
		else
		if (name_f == 1)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL10_1);
		else
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL10_2);
		waitScript();
		//omk207uЕtv
		if (name_f == 0)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL11_0);
		else
		if (name_f == 1)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL11_1);
		else
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL11_2);
		waitScript();
		if (getLabel(o3_select06_0) == ON)
		{
			if (name_f == 0)
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL12_0);
			else
			if (name_f == 1)
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL12_1);
			else
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL12_2);
			waitScript();
		} else {
			// uaFAvvI
			if (name_f == 0)
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL13_0);
			else
			if (name_f == 1)
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL13_1);
			else
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL13_2);
			waitScript();
		}
	} else {
		//omk203u֍sv
		if (name_f == 0)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL04_0);
		else
		if (name_f == 1)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL04_1);
		else
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL04_2);
		waitScript();
		if (name_f == 0)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL05_0);
		else
		if (name_f == 1)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL05_1);
		else
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL05_2);
		waitScript();
		//omk204uÂ閺v
		if (name_f == 0)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL06_0);
		else
		if (name_f == 1)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL06_1);
		else
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL06_2);
		waitScript();
		if (name_f == 0)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL07_0);
		else
		if (name_f == 1)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL07_1);
		else
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL07_2);
		waitScript();
	}
	if (getLabel(o3_select03_0) == ON && getLabel(o3_select06_0) == ON)
	{
		//omk208uAȂv
		
		if (getLabel(o3_select07_0) == ON)
		{
			//omk209uтɂ܂v
			if (name_f == 0)
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL14_0);
			else
			if (name_f == 1)
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL14_1);
			else
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL14_2);
			waitScript();
		} else
		if (getLabel(o3_select07_1) == ON)
		{
			//omk210uCɂ܂v
			if (name_f == 0)
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL15_0);
			else
			if (name_f == 1)
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL15_1);
			else
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL15_2);
			waitScript();
			if (name_f == 0)
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL16_0);
			else
			if (name_f == 1)
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL16_1);
			else
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL16_2);
			waitScript();
		} else {
			//omk211uƂccɂ܂Iv
		}
		//omk212uÔЂƂƂv
		if (name_f == 0)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL17_0);
		else
		if (name_f == 1)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL17_1);
		else
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL17_2);
		waitScript();
	} else {
		//omk205uQ߂v
		if (name_f == 0)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL08_0);
		else
		if (name_f == 1)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL08_1);
		else
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL08_2);
		waitScript();
		if (name_f == 0)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL09_0);
		else
		if (name_f == 1)
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL09_1);
		else
			setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL09_2);
		waitScript();
		if (getLabel(o3_select04_0) == ON)
		{
			//omk212uÔЂƂƂv
			if (name_f == 0)
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL17_0);
			else
			if (name_f == 1)
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL17_1);
			else
				setScript(_OMK02V2_PSC, OMK02V2_O3_AUTOSL17_2);
			waitScript();
		}
	}
	setBgNum(BG_black);
	waitChangeGraph();
	waitOnly(120);
	setBgNum(BG_ed_fin2);
	waitChangeGraph();
	waitOnly(600);
	setBgNum(BG_black);
	waitChangeGraph();
}


// -------------------------------------
//  L[ûȂE
// -------------------------------------
static void osawari(void)
{
	g_touch_script_req = -1;

	setChangeLock(TRUE);
	clearMessage();
	clearFaceName();
	putFaceWindow(FALSE);
	putMessageWindow(FALSE);
	setChaNum(0, cDA1);
	setChangeLock(FALSE);
	waitChangeGraph();
	setScript(_OMK_TOUCH_PSC, OMK_TOUCH_TOUCH_START);
	waitScript();
	g_step = OMAKE_MODE_OSAWARI_START;

	while(g_step != OMAKE_MODE_MAIN)
	{
		if (g_touch_script_req != -1)
		{
			setScript(_OMK_TOUCH_PSC, g_touch_script_req);
			waitScript();
			g_touch_script_req = -1;
		}
		OS_Sleep(10);
	}
}

// -------------------------------------
static void startOsawari(void)
{
	changeLCDC(FALSE);

	g_step = OMAKE_MODE_OSAWARI_WAIT;
}

// -------------------------------------
static void waitOsawari(void)
{
	if (!isChangeLCDC())
	{
		initTouchPenData();
		setTouchPenData(_OMAKE_TOUCH_TPD);
		putModoru(TRUE);
		g_step = OMAKE_MODE_OSAWARI_MAIN;
	}
	execScript();
	execEventGraph();
}

// -------------------------------------
static void mainOsawari(void)
{
	s16 decide, select, selold;
	s8 pos, time;

	decide = getTouchPenDecide();
	select = getTouchPenSelect();
	selold = getTouchPenOldSelect();
	if (decide != -1)
	{
		pos = -1;
		switch (decide)
		{
			case 0:		// ߂
				playSE(SE_02);
				putModoru(FALSE);
				g_count = 0;
				g_step = OMAKE_MODE_OSAWARI_END;
				break;
			case 1:		// 
				pos = OSAWARI_POS_ATAMA;
				break;
			case 2:		// 
				pos = OSAWARI_POS_KAO;
				break;
			case 3:		// 
			case 4:		// 
				pos = OSAWARI_POS_KATA;
				break;
			case 5:		// 
				pos = OSAWARI_POS_MUNE;
				break;
			case 6:		// r
			case 7:		// r
				pos = OSAWARI_POS_UDE;
				break;
			case 8:		// 
				pos = OSAWARI_POS_ONAKA;
				break;
			case 9:		// 
				pos = OSAWARI_POS_KOSI;
				break;
			default:
				;
		}
		if (pos != -1)
		{
			// GI
			time = (s8)getTimeZone();
			g_touch_script_req = g_touch_script[pos][time][nTouch[pos][time]];
			nTouch[pos][time] = (u8)((nTouch[pos][time] + 1) % 3);
			g_step = OMAKE_MODE_OSAWARI_SCRIPT;
		}
	} else
	if (select != selold)
	{
		if (select == 0)
		{
			playSE(SE_01);
			changeModoru(1);
		} else
		if (selold == 0)
		{
			changeModoru(0);
		}
	}
	execScript();
	execEventGraph();
}

// -------------------------------------
static void scriptOsawari(void)
{
	if (g_touch_script_req == -1)
		g_step = OMAKE_MODE_OSAWARI_MAIN;
	execScript();
	execEventGraph();
}

// -------------------------------------
static void endOsawari(void)
{
	if (g_count == 0)
	{
		if (!isFlipBmpBuf())
		{
			changeLCDC(TRUE);
			g_count = 1;
		}
	} else
	if (!isChangeLCDC())
		g_step = OMAKE_MODE_MAIN;
	execScript();
	execEventGraph();
}

