//---------------------------------------------------------------------------
//
//	vSp
//
//---------------------------------------------------------------------------
#include <nitro.h>
#include "bds_lib.h"
#include "pack_data.h"
#include "game.h"
#include "prime4.h"
#include "item.h"

// -------------------------------------
// 萔`
// -------------------------------------
#define CRC_START			0x20080107
#define COMMON_INIT_CODE	0x9ea7			// ς΋ʃf[^𖳌ł
#define USER_INIT_CODE		0xc5a4			// ς΃Z[uf[^𖳌ł
#define LABEL_LEN			(LF_MAX+31)/32
#define BG_LEN				(BG_MAX_NUM+31)/32
#define BACKUP_SIZE			1024*64/8		// obNAbv64k

#define ENDING_LEN			(37+31)/32

#ifdef PRIME_DEBUG
//#define DARK_TOWN_CHECK
//#define ITEM_CHECK
//#define SICK_CHECK
//#define ORK_CHECK
//#define BUTOU_CHECK
//#define NFD_CHECK
//#define BIRTH_CHECK
//#define HOLI_CHECK
//#define FE_CHECK
//#define AKUMASHOP_CHECK
//#define POOR_CHECK
//#define RIVAL_CHECK
//#define CERO2_CHECK
//#define KIHIN_CHECK
#define GOLD_CHECK
//#define OUJI_CHECK
//#define ENDING_CHECK
//#define KUMA_CHECK
#endif


// -------------------------------------
// NXE\̒`
// -------------------------------------
typedef struct
{
	u16
		m_crc,
		m_init_code;
	u8
		m_Name1Bak[13],		// O 6SJIS
		m_Name2Bak[13],		// c 6SJIS
		m_OptionBGM,		// 0:OFF 1: 2:(Default) 3:
		m_OptionSFX,		// 0:OFF 1: 2:(Default) 3:
		m_OptionVoice,		// 0:OFF 1: 2:(Default) 3:
		m_OptionMessage,	// 0:High 1:Normal(Default) 2:Slow
		m_AlbumEnable,		// 0:FALSE 1:TRUE Album
		m_FatherBride,		// 0:FALSE 1:TRUE ̉łɂȂ
		m_Princess,			// 0:FALSE 1:TRUE vZXGh
		m_LastSaved;		// ŌɃZ[uԍ
	// Ao󋵂Kv
	u32
		m_AlbumFlag[BG_LEN],	// x
		m_EndingFlag[ENDING_LEN];	// GfBO
} COMMON_PARAM;

typedef struct
{
	u16
		m_crc,
		m_init_code;

	u8
		// VXen
		m_ParamType,			// 0: 1: 2: 3:
		m_SaveMonth,			// Z[u
		m_SaveDay,				// Z[u
		m_SaveHour,				// Z[u
		m_SaveMinute,			// Z[u
		// p[^n
		m_Name1[13],			// O 6SJIS
		m_Name2[13],			// c 6SJIS
		m_Blood,				// t^(0=A , 1=B , 2=O , 3=AB
		m_BirthY,				// aiNj
		m_BirthM,				// aij
		m_BirthD,				// aij
		m_FBirthY,				// ̒aiNj
		m_FBirthM,				// ̒aij
		m_FBirthD,				// ̒aij
		m_Age, 					// N
		m_ageWidth,				// N(0=C, 1=L, 2=H
		m_Policy,				// 琬j
		m_Dress,				// mԍ
		m_RoomPic,				// ̊Gԍi0`3)
		m_con,					// ̏	0=ʏ,1=s,2=aC
		m_DemonRank,			// N
		m_Item[100],			// ĂACeobt@
		m_ItemCount,			// ĂACe
		m_ParamDecim[28],		// ̃p[^i1/100j
		// NG
		m_Year,					// N(0=1341 255=1596)
		m_Month,				// 
		m_Day,					// 
		m_Week,					// j
		m_GameY,				// Q[Jn̔N
		m_GameM,				// Q[Jň
		m_Season,				// G߁i0:tA1:āA2:HA3:~)
		m_Wave,					// oG߁i0:A1:ҏA2:~j
		m_TimeZone,				// 
		// Q[is
		m_Flag,					// isp
								// Bit0:TalkExec TalksǂiŃNAj
								// Bit1`3:RankupMsg NAbṽbZ[W
		m_WarFlag,				// 1:푈
		m_SchRank[24],			// XPW[N
		m_SchLast[3],			// OɍsXPW[
		m_Sale,					// 
		m_btWinNo[3],			// ܎҂̔ԍ
		m_harvestNo,			// nՂ̋Zԍ
		// CxgQ[irpj
		m_evm_pa,				// Viqj
		m_evm_pb,				// hS[X
		m_evm_pc,				// @A
		m_evm_pd,				// x
		m_evm_ra,				// [[
		m_evm_rb,				// NX`[i
		m_evm_rc,				// }[
		m_evm_rd,				// J
		m_evm_adv01,			// K˂
		m_RvlEnc,				// ݈ԐeCo
		m_countAC,				// ̏K
		m_countDT;				// _[N^EK
	s8
		m_SchLastRes[24];		// OɍsXPW[̌
	u16
		// VXen
		m_SaveYear,				// Z[uN
		// p[^n
		m_ParamInt[28],			// ̃p[^ij
		m_BMI,					// BMI	25+:fu BMIx10̒l
		m_Demonize,				// Ǒ̖x
		// Q[is
		m_SchCount[24],			// XPW[s
		m_SchDays[24],			// XPW[s@
		m_SchSuc[24];			// XPW[s
	s32
		m_ParamOfs[28];		// ̃p[^ItZbgij


	u32
		// p[^n
		m_Gold,				// 				999999
		// Q[is
		m_SchSet,			// BOOL[24]XPW[I\ǂ
		m_NewSchGuide,		// BOOL[24]VXPW[̃KChoH
		m_LabelFlag[LABEL_LEN];	// x
} PLAYER_PARAM;

// -------------------------------------
// [Jϐ`
// -------------------------------------
static COMMON_PARAM
	g_common_param;
static PLAYER_PARAM
	g_player_param;
static u8
	g_save_count;


// -------------------------------------
// [J֐`
// -------------------------------------
static void saveCommonData(void);

//---------------------------------------------------------------------------
//
// ֐
//
//---------------------------------------------------------------------------
// -------------------------------------
// obNAbvf[^̒
// -------------------------------------
void initFirstBackup(void)
{
	COMMON_PARAM *param;
	u16 crc, i;
	BOOL result;

	OS_TPrintf("SystemBackup=%d byte\n", sizeof(COMMON_PARAM));
	OS_TPrintf("UserBackup=%d byte\n", sizeof(PLAYER_PARAM));
	g_save_count = (u8)((BACKUP_SIZE - sizeof(COMMON_PARAM)) / sizeof(PLAYER_PARAM));
	if (g_save_count > 8)
		g_save_count = 8;
	OS_TPrintf("Z[u=%d\n", g_save_count);

	for (i=0; i<g_save_count; i++)
		OS_TPrintf("UserBackupAddress(%d)=0x%x\n", i, sizeof(COMMON_PARAM)+sizeof(PLAYER_PARAM)*i);

	// foCX̑I
	setBackupDevice(BACKUP_TYPE_EEPROM_64K);
	// ʃf[^̓ǂݍ
	result = FALSE;
	param = (COMMON_PARAM *)mallocBDS(sizeof(COMMON_PARAM));
	// œǂݍ
	result = readBackup((void *)param, 0, sizeof(COMMON_PARAM));
#ifdef BACKUP_NON_STOP
	result = TRUE;
#endif
	if (!result)
	{
		changeGameMode(GAME_MODE_WARNING_LOAD);
	} else {
		crc = SVC_GetCRC16(CRC_START, (const void *)(((u32)&param->m_crc)+2), sizeof(COMMON_PARAM)-2);
		if (param->m_crc == crc && param->m_init_code == COMMON_INIT_CODE)
		{
			// ǂݍݐ
			memcpyBDS((s8 *)&g_common_param, (s8 *)param, sizeof(COMMON_PARAM));
			if (g_common_param.m_OptionBGM == 0)
			{
				setBGMFlag(FALSE);
			} else {
				setBGMFlag(TRUE);
			}
			if (g_common_param.m_OptionSFX == 0)
			{
				setSEFlag(FALSE);
				setWAVFlag(FALSE);
			} else {
				setSEFlag(TRUE);
				setWAVFlag(TRUE);
			}
			if (g_common_param.m_OptionVoice == 0)
			{
				setMovieVolume(0);
			} else {
				setMovieVolume(100);
			}
		} else {
			// ǂݍݎs
			initCommonData();
		}
	}
	freeBDS((void *)param);
}
// -------------------------------------
//  S
// -------------------------------------
void initCommonData(void)
{
	int i;

	for (i=0; i<13; i++)
	{
		g_common_param.m_Name1Bak[i] = 0;
		g_common_param.m_Name2Bak[i] = 0;
	}
	memcpyBDS((s8 *)&g_common_param.m_Name1Bak[0], (s8 *)"pgVA", 10);
	memcpyBDS((s8 *)&g_common_param.m_Name2Bak[0], (s8 *)"nCEF", 10);

	g_common_param.m_AlbumEnable = 0;
	g_common_param.m_FatherBride = 0;
	g_common_param.m_Princess = 0;

	g_common_param.m_OptionBGM = 2;
	g_common_param.m_OptionSFX = 2;
	g_common_param.m_OptionVoice = 2;
	g_common_param.m_OptionMessage = 1;

	g_common_param.m_LastSaved = 0;

	g_common_param.m_init_code = COMMON_INIT_CODE;

	for (i=0; i<BG_LEN; i++)
		g_common_param.m_AlbumFlag[i] = 0;
	for (i=0; i<ENDING_LEN; i++)
		g_common_param.m_EndingFlag[i] = 0;

	saveCommonData();
}
// -------------------------------------
//  Z[u
// -------------------------------------
static void saveCommonData(void)
{
	BOOL result;
	u8 p;

	g_common_param.m_crc = SVC_GetCRC16(CRC_START, (const void *)(((u32)&g_common_param.m_crc)+2), sizeof(COMMON_PARAM)-2);
	result = readBackup((void *)&p, 0, 1);
#ifdef BACKUP_NON_STOP
	result = TRUE;
#endif
	if (!result)
		changeGameMode(GAME_MODE_WARNING_SAVE);
	else
	{
		writeBackup((void *)&g_common_param, 0, sizeof(COMMON_PARAM));
		OS_TPrintf("SaveCommonData\n");
	}
}
// -------------------------------------
// őZ[u
// -------------------------------------
u8 getSaveCount(void)
{
	return g_save_count;
}
// -------------------------------------
// 0:OFF 1: 2:(Default) 3:
// -------------------------------------
void setOptionBGM(u8 in_num)
{
	g_common_param.m_OptionBGM = in_num;
	if (in_num == 0)
	{
		setBGMFlag(FALSE);
		setMovieVolume(0);
	} else {
		setBGMFlag(TRUE);
		setMovieVolume(100);
	}
	saveCommonData();
}
// -------------------------------------
u8 getOptionBGM(void)
{
	return g_common_param.m_OptionBGM;
}
// -------------------------------------
// 0:OFF 1: 2:(Default) 3:
// -------------------------------------
void setOptionSFX(u8 in_num)
{
	g_common_param.m_OptionSFX = in_num;
	if (in_num == 0)
	{
		setSEFlag(FALSE);
		setWAVFlag(FALSE);
	} else {
		setSEFlag(TRUE);
		setWAVFlag(TRUE);
	}
	saveCommonData();
}
// -------------------------------------
u8 getOptionSFX(void)
{
	return g_common_param.m_OptionSFX;
}
// -------------------------------------
// 0:OFF 1: 2:(Default) 3:
// -------------------------------------
void setOptionVoice(u8 in_num)
{
	g_common_param.m_OptionVoice = in_num;
	if (in_num == 0)
	{
		setMovieVolume(0);
	} else {
		setMovieVolume(100);
	}
	saveCommonData();
}
// -------------------------------------
u8 getOptionVoice(void)
{
	return g_common_param.m_OptionVoice;
}
// -------------------------------------
// 0:High 1:Normal(Default) 2:Slow
// -------------------------------------
void setOptionMessage(u8 in_num)
{
	g_common_param.m_OptionMessage = in_num;
	saveCommonData();
}
// -------------------------------------
u8 getOptionMessage(void)
{
	return g_common_param.m_OptionMessage;
}
// -------------------------------------
// 0:FALSE 1:TRUE Album
// -------------------------------------
void setAlbumEnable(u8 in_num)
{
	g_common_param.m_AlbumEnable = in_num;
	saveCommonData();
}
// -------------------------------------
u8 getAlbumEnable(void)
{
	return g_common_param.m_AlbumEnable;
}
// -------------------------------------
// 0:FALSE 1:TRUE ̉ł
// -------------------------------------
void setFatherBride(u8 in_num)
{
	g_common_param.m_FatherBride = in_num;
	saveCommonData();
}
// -------------------------------------
u8 getFatherBride(void)
{
	return g_common_param.m_FatherBride;
}
// -------------------------------------
// 0:FALSE 1:TRUE vZXGh
// -------------------------------------
void setPrincess(u8 in_num)
{
	g_common_param.m_Princess = in_num;
	saveCommonData();
}
// -------------------------------------
u8 getPrincess(void)
{
	return g_common_param.m_Princess;
}
// -------------------------------------
// ŌɃZ[uԍ
// -------------------------------------
void setLastSaved(u8 in_num)
{
	g_common_param.m_LastSaved = in_num;
	saveCommonData();
}
// -------------------------------------
u8 getLastSaved(void)
{
	return g_common_param.m_LastSaved;
}
// -------------------------------------
// Ao
// -------------------------------------
void setAlbum(s32 in_label)
{
	s32 label, flag;

	label = in_label / 32;
	flag = 1 << (in_label % 32);
	if (!(g_common_param.m_AlbumFlag[label] & flag))
	{
		g_common_param.m_AlbumFlag[label] |= flag;
		saveCommonData();
	}
}
// -------------------------------------
BOOL getAlbum(s32 in_label)
{
	s32 label, flag;

	label = in_label / 32;
	flag = 1 << (in_label % 32);
	if (g_common_param.m_AlbumFlag[label] & flag)
		return TRUE;
	return FALSE;
}
// -------------------------------------
// GfBO
// -------------------------------------
void setEnding(s32 in_label)
{
	s32 label, flag;

	label = in_label / 32;
	flag = 1 << (in_label % 32);
	if (!(g_common_param.m_EndingFlag[label] & flag))
	{
		g_common_param.m_EndingFlag[label] |= flag;
		saveCommonData();
	}
}
// -------------------------------------
BOOL getEnding(s32 in_label)
{
	s32 label, flag;

	label = in_label / 32;
	flag = 1 << (in_label % 32);
	if (g_common_param.m_EndingFlag[label] & flag)
		return TRUE;
	return FALSE;
}
// -------------------------------------
s32 getEndingCount(void)
{
	s32 i, edc;

	edc = 0;
	for (i=0; i<37; i++)
	{
		if (getEnding(i))
			edc++;
	}
	return edc;
}

// -------------------------------------
//  
// -------------------------------------
void initGameValue(void)
{
	int i;

	g_player_param.m_ParamType = 0;
	// Q[ŎgpXNvg̕ϐNA
	g_player_param.m_GameY = 0;
	g_player_param.m_GameM = 0;
	g_player_param.m_Season = 0;
	g_player_param.m_Wave = 0;
	g_player_param.m_TimeZone = 0;
	g_player_param.m_WarFlag = 0;
	g_player_param.m_RoomPic = 0;
	for (i=0; i<LABEL_LEN; i++)
		g_player_param.m_LabelFlag[i] = 0;
	g_player_param.m_Flag = 0;
	g_player_param.m_SchSet = 0;
	g_player_param.m_NewSchGuide = 0;
	for (i=0; i<24; i++)
	{
		g_player_param.m_SchCount[i] = 0;
		g_player_param.m_SchDays[i] = 0;
		g_player_param.m_SchSuc[i] = 0;
		g_player_param.m_SchRank[i] = 0;
	}
	for (i=0; i<3; i++)
		g_player_param.m_SchLast[i] = 0;
	for (i=0; i<100; i++)
		g_player_param.m_Item[i] = 0;
	for (i=0; i<28; i++)
	{
		g_player_param.m_ParamInt[i] = 0;
		g_player_param.m_ParamDecim[i] = 0;
		g_player_param.m_ParamOfs[i] = 0;
	}
	g_player_param.m_evm_pa = 0;
	g_player_param.m_evm_pb = 0;
	g_player_param.m_evm_pc = 0;
	g_player_param.m_evm_pd = 0;
	g_player_param.m_evm_ra = 0;
	g_player_param.m_evm_rb = 0;
	g_player_param.m_evm_rc = 0;
	g_player_param.m_evm_rd = 0;
	g_player_param.m_evm_adv01 = 0;
	g_player_param.m_countAC = 0;
	g_player_param.m_countDT = 0;
	g_player_param.m_RvlEnc = 0;
	g_player_param.m_Demonize = 0;
	g_player_param.m_DemonRank = 0;

	// v̕ϐݒ
	g_player_param.m_Year = 99;			// 1440 - 1341 = 99
	g_player_param.m_Month = 4;
	g_player_param.m_Day = 1;
	g_player_param.m_Week = 3;
	memcpyBDS((s8 *)&g_player_param.m_Name1[0], (s8 *)&g_common_param.m_Name1Bak[0], 12);
	memcpyBDS((s8 *)&g_player_param.m_Name2[0], (s8 *)&g_common_param.m_Name2Bak[0], 12);
	g_player_param.m_Blood = blood_A;
	g_player_param.m_BirthY = 89;		// 1430 - 1341 = 89
	g_player_param.m_BirthM = 4;
	g_player_param.m_BirthD = 1;
	g_player_param.m_FBirthY = 79;		// 1420 - 1341 = 79
	g_player_param.m_FBirthM = 1;
	g_player_param.m_FBirthD = 1;
	g_player_param.m_Policy = 0;
	g_player_param.m_Gold = 2000;
	g_player_param.m_Age = 10;
	g_player_param.m_Dress = 1;
	g_player_param.m_con = conN;
	g_player_param.m_ageWidth = ageC;
	g_player_param.m_Sale = 100;
	g_player_param.m_btWinNo[0] = 
	g_player_param.m_btWinNo[1] = 
	g_player_param.m_btWinNo[2] = 99;	// ȂĂ낤ǁEEE
	g_player_param.m_harvestNo = 0;		// ȂĂ낤ǁEEE

	addItem(58);						// i

	// initSch
	setSchSet(jZagaku,       ON);
	setSchSet(jBujyutu,      ON);
	setSchSet(jMajyutu,      ON);
	setSchSet(jReihou,       OFF);
	setSchSet(jGeijyutu,     ON);
	setSchSet(jButou,        OFF);
	setSchSet(jKajiTetudai,  ON);
	setSchSet(jKomori,       ON);
	setSchSet(jNoujyou,      ON);
	setSchSet(jKyoukai,      ON);
	setSchSet(jRyouriya,     OFF);
	setSchSet(jMeido,        OFF);
	setSchSet(jKikori,       OFF);
	setSchSet(jYadoya,       OFF);
	setSchSet(jIchiba,       OFF);
	setSchSet(jSakaba,       OFF);
	setSchSet(jKateiKyousi,  OFF);
	setSchSet(jMeidoSakaba,  OFF);
	setSchSet(jAyasiiSakaba, OFF);
	setSchSet(jKajino,       OFF);
	setSchSet(jYasumi,       ON);
	setSchSet(jBakansu,      ON);
	setSchSet(jOdekake,      ON);
	setSchSet(jRyouyou,      ON);
}

// -------------------------------------
// p[^̏
// at^mAĂ
// -------------------------------------
void initParam(void)
{
	g_player_param.m_ParamInt[pHeight] = 140;
	g_player_param.m_ParamInt[pWeight] =  38;
	g_player_param.m_ParamInt[pBust]   =  66;
	g_player_param.m_ParamInt[pWaist]  =  55;
	g_player_param.m_ParamInt[pHip]    =  68;
	// l̐ݒ
	g_player_param.m_ParamInt[pTAIRYOKU] = 50;		// X^~i
	g_player_param.m_ParamInt[pCHIRYOKU] = 25;		// m
	g_player_param.m_ParamInt[pMIRYOKU]  = 25;		// 
	g_player_param.m_ParamInt[pPRIDE]    = 25;		// vCh
	g_player_param.m_ParamInt[pMORAL]    = 20;		// 
	g_player_param.m_ParamInt[pKIHINN]   = 25;		// Ci
	g_player_param.m_ParamInt[pKANNJYU]  = 25;		// 
	g_player_param.m_ParamInt[pKIDATE]   = 20;		// C
	g_player_param.m_ParamInt[pCHIMEI]   =  0; 		// mx
	g_player_param.m_ParamInt[pBUJYUTU]  = 20;		// p\
	g_player_param.m_ParamInt[pMAJYUTU]  = 20;		// p\
	g_player_param.m_ParamInt[pINGOU]    =  0; 		// 
	g_player_param.m_ParamInt[pHIROU]    =  0; 		// Jx
#ifdef SICK_CHECK
	g_player_param.m_ParamInt[pHIROU] = 900;
#endif
	g_player_param.m_ParamInt[pMAZOKU]   =  0; 		// 
	g_player_param.m_ParamInt[pFA]       =  0; 		// ς
	g_player_param.m_ParamInt[pPR]       =  0; 		// vX
	g_player_param.m_ParamInt[pDP]       =  0; 		// EvX
	g_player_param.m_ParamInt[pDY]       =  0; 		// hS[X
	g_player_param.m_ParamInt[pR1]       =  0; 		// CoPi[[j
	g_player_param.m_ParamInt[pR2]       =  0; 		// CoQiNX`[ij
	g_player_param.m_ParamInt[pR3]       =  0; 		// CoRi}[j
	g_player_param.m_ParamInt[pCU]       =  0; 		// L[u

	if ((g_player_param.m_BirthM == 3 && g_player_param.m_BirthD >= 21) ||
		(g_player_param.m_BirthM == 4 && g_player_param.m_BirthD <= 19))
	{
		// Ђ
		g_player_param.m_ParamInt[pTAIRYOKU] += 30;		// X^~i
		g_player_param.m_ParamInt[pCHIRYOKU] -= 10;		// m
		g_player_param.m_ParamInt[pMIRYOKU]  -= 10;		// 
		g_player_param.m_ParamInt[pMORAL]    -=  9;		// 
		g_player_param.m_ParamInt[pKIHINN]   -=  4;		// Ci
		g_player_param.m_ParamInt[pKANNJYU]  -=  4;		// 
		g_player_param.m_ParamInt[pKIDATE]   -= 10;		// C
		g_player_param.m_ParamInt[pBUJYUTU]  += 20;		// p\
		g_player_param.m_ParamInt[pMAJYUTU]  += 15;		// p\
	} else
	if ((g_player_param.m_BirthM == 4/* && g_player_param.m_BirthD >= 20*/) ||
		(g_player_param.m_BirthM == 5 && g_player_param.m_BirthD <= 20))
	{
		// 
		g_player_param.m_ParamInt[pTAIRYOKU] -=  4;		// X^~i
		g_player_param.m_ParamInt[pCHIRYOKU] +=  5;		// m
		g_player_param.m_ParamInt[pMIRYOKU]  +=  3;		// 
		g_player_param.m_ParamInt[pPRIDE]    += 10;		// vCh
		g_player_param.m_ParamInt[pKIHINN]   +=  4;		// Ci
		g_player_param.m_ParamInt[pKANNJYU]  -=  5;		// 
		g_player_param.m_ParamInt[pKIDATE]   +=  3;		// C
		g_player_param.m_ParamInt[pMAJYUTU]  += 10;		// p\
	} else
	if ((g_player_param.m_BirthM == 5/* && g_player_param.m_BirthD >= 21*/) ||
		(g_player_param.m_BirthM == 6 && g_player_param.m_BirthD <= 21))
	{
		// ӂ
		g_player_param.m_ParamInt[pCHIRYOKU] += 10;		// m
		g_player_param.m_ParamInt[pMIRYOKU]  -=  2;		// 
		g_player_param.m_ParamInt[pPRIDE]    +=  1;		// vCh
		g_player_param.m_ParamInt[pMORAL]    -= 12;		// 
		g_player_param.m_ParamInt[pKIHINN]   -=  5;		// Ci
		g_player_param.m_ParamInt[pKANNJYU]  += 17;		// 
		g_player_param.m_ParamInt[pKIDATE]   -=  8;		// C
		g_player_param.m_ParamInt[pBUJYUTU]  +=  5;		// p\
		g_player_param.m_ParamInt[pMAJYUTU]  += 13;		// p\
	} else
	if ((g_player_param.m_BirthM == 6/* && g_player_param.m_BirthD >= 22*/) ||
		(g_player_param.m_BirthM == 7 && g_player_param.m_BirthD <= 22))
	{
		// ɍ
		g_player_param.m_ParamInt[pTAIRYOKU] -= 10;		// X^~i
		g_player_param.m_ParamInt[pCHIRYOKU] +=  6;		// m
		g_player_param.m_ParamInt[pMIRYOKU]  +=  8;		// 
		g_player_param.m_ParamInt[pPRIDE]    -=  2;		// vCh
		g_player_param.m_ParamInt[pMORAL]    -=  3;		// 
		g_player_param.m_ParamInt[pKIHINN]   +=  8;		// Ci
		g_player_param.m_ParamInt[pKANNJYU]  += 12;		// 
		g_player_param.m_ParamInt[pKIDATE]   -=  6;		// C
		g_player_param.m_ParamInt[pBUJYUTU]  -=  4;		// p\
		g_player_param.m_ParamInt[pMAJYUTU]  += 20;		// p\
	} else
	if ((g_player_param.m_BirthM == 7/* && g_player_param.m_BirthD >= 23*/) ||
		(g_player_param.m_BirthM == 8 && g_player_param.m_BirthD <= 23))
	{
		// 
		g_player_param.m_ParamInt[pTAIRYOKU] += 35;		// X^~i
		g_player_param.m_ParamInt[pCHIRYOKU] -= 16;		// m
		g_player_param.m_ParamInt[pMIRYOKU]  -= 14;		// 
		g_player_param.m_ParamInt[pPRIDE]    +=  3;		// vCh
		g_player_param.m_ParamInt[pKIHINN]   += 12;		// Ci
		g_player_param.m_ParamInt[pKANNJYU]  -= 15;		// 
		g_player_param.m_ParamInt[pKIDATE]   -=  8;		// C
		g_player_param.m_ParamInt[pBUJYUTU]  += 17;		// p\
		g_player_param.m_ParamInt[pMAJYUTU]  +=  5;		// p\
	} else
	if ((g_player_param.m_BirthM == 8/* && g_player_param.m_BirthD >= 24*/) ||
		(g_player_param.m_BirthM == 9 && g_player_param.m_BirthD <= 23))
	{
		// Ƃߍ
		g_player_param.m_ParamInt[pTAIRYOKU] -= 15;		// X^~i
		g_player_param.m_ParamInt[pCHIRYOKU] +=  3;		// m
		g_player_param.m_ParamInt[pMIRYOKU]  += 11;		// 
		g_player_param.m_ParamInt[pPRIDE]    -=  6;		// vCh
		g_player_param.m_ParamInt[pMORAL]    -=  2;		// 
		g_player_param.m_ParamInt[pKIHINN]   += 15;		// Ci
		g_player_param.m_ParamInt[pKANNJYU]  +=  5;		// 
		g_player_param.m_ParamInt[pKIDATE]   += 12;		// C
		g_player_param.m_ParamInt[pBUJYUTU]  -= 10;		// p\
		g_player_param.m_ParamInt[pMAJYUTU]  += 13;		// p\
	} else
	if ((g_player_param.m_BirthM == 9/* && g_player_param.m_BirthD >= 24*/) ||
		(g_player_param.m_BirthM == 10 && g_player_param.m_BirthD <= 23))
	{
		// Ăт
		g_player_param.m_ParamInt[pTAIRYOKU] -=  8;		// X^~i
		g_player_param.m_ParamInt[pCHIRYOKU] +=  8;		// m
		g_player_param.m_ParamInt[pPRIDE]    -=  1;		// vCh
		g_player_param.m_ParamInt[pMORAL]    += 12;		// 
		g_player_param.m_ParamInt[pKIHINN]   +=  3;		// Ci
		g_player_param.m_ParamInt[pKANNJYU]  +=  4;		// 
		g_player_param.m_ParamInt[pKIDATE]   -=  2;		// C
		g_player_param.m_ParamInt[pMAJYUTU]  += 10;		// p\
	} else
	if ((g_player_param.m_BirthM == 10/* && g_player_param.m_BirthD >= 24*/) ||
		(g_player_param.m_BirthM == 11 && g_player_param.m_BirthD <= 22))
	{
		// 
		g_player_param.m_ParamInt[pMIRYOKU]  += 15;		// 
		g_player_param.m_ParamInt[pPRIDE]    -=  5;		// vCh
		g_player_param.m_ParamInt[pMORAL]    -=  2;		// 
		g_player_param.m_ParamInt[pKIHINN]   -=  8;		// Ci
		g_player_param.m_ParamInt[pKANNJYU]  +=  8;		// 
		g_player_param.m_ParamInt[pKIDATE]   -= 10;		// C
		g_player_param.m_ParamInt[pBUJYUTU]  -=  2;		// p\
		g_player_param.m_ParamInt[pMAJYUTU]  += 25;		// p\
	} else
	if ((g_player_param.m_BirthM == 11/* && g_player_param.m_BirthD >= 23*/) ||
		(g_player_param.m_BirthM == 12 && g_player_param.m_BirthD <= 21))
	{
		// č
		g_player_param.m_ParamInt[pTAIRYOKU] +=  7;		// X^~i
		g_player_param.m_ParamInt[pCHIRYOKU] +=  6;		// m
		g_player_param.m_ParamInt[pMIRYOKU]  -= 10;		// 
		g_player_param.m_ParamInt[pPRIDE]    +=  1;		// vCh
		g_player_param.m_ParamInt[pMORAL]    -=  1;		// 
		g_player_param.m_ParamInt[pKIHINN]   -=  5;		// Ci
		g_player_param.m_ParamInt[pKANNJYU]  -=  5;		// 
		g_player_param.m_ParamInt[pKIDATE]   +=  3;		// C
		g_player_param.m_ParamInt[pBUJYUTU]  +=  6;		// p\
		g_player_param.m_ParamInt[pMAJYUTU]  += 14;		// p\
	} else
	if ((g_player_param.m_BirthM == 12/* && g_player_param.m_BirthD >= 22*/) ||
		(g_player_param.m_BirthM == 1 && g_player_param.m_BirthD <= 19))
	{
		// €
		g_player_param.m_ParamInt[pTAIRYOKU] +=  6;		// X^~i
		g_player_param.m_ParamInt[pCHIRYOKU] -=  4;		// m
		g_player_param.m_ParamInt[pMIRYOKU]  -=  9;		// 
		g_player_param.m_ParamInt[pPRIDE]    -=  3;		// vCh
		g_player_param.m_ParamInt[pMORAL]    +=  5;		// 
		g_player_param.m_ParamInt[pKIHINN]   -=  2;		// Ci
		g_player_param.m_ParamInt[pKANNJYU]  -=  8;		// 
		g_player_param.m_ParamInt[pKIDATE]   += 20;		// C
		g_player_param.m_ParamInt[pMAJYUTU]  += 11;		// p\
	} else
	if ((g_player_param.m_BirthM == 1/* && g_player_param.m_BirthD >= 20*/) ||
		(g_player_param.m_BirthM == 2 && g_player_param.m_BirthD <= 18))
	{
		// ݂ߍ
		g_player_param.m_ParamInt[pTAIRYOKU] -=  7;		// X^~i
		g_player_param.m_ParamInt[pCHIRYOKU] += 18;		// m
		g_player_param.m_ParamInt[pMIRYOKU]  -=  5;		// 
		g_player_param.m_ParamInt[pPRIDE]    +=  2;		// vCh
		g_player_param.m_ParamInt[pMORAL]    +=  3;		// 
		g_player_param.m_ParamInt[pKIHINN]   -=  8;		// Ci
		g_player_param.m_ParamInt[pKANNJYU]  +=  7;		// 
		g_player_param.m_ParamInt[pKIDATE]   -=  9;		// C
		g_player_param.m_ParamInt[pBUJYUTU]  -=  3;		// p\
		g_player_param.m_ParamInt[pMAJYUTU]  += 18;		// p\
	} else {
//	if ((g_player_param.m_BirthM == 2 && g_player_param.m_BirthD >= 19) ||
//		(g_player_param.m_BirthM == 3 && g_player_param.m_BirthD <= 20))
//	{
		// 
		g_player_param.m_ParamInt[pTAIRYOKU] -=  9;		// X^~i
		g_player_param.m_ParamInt[pCHIRYOKU] -=  5;		// m
		g_player_param.m_ParamInt[pMIRYOKU]  +=  4;		// 
		g_player_param.m_ParamInt[pMORAL]    +=  3;		// 
		g_player_param.m_ParamInt[pKIHINN]   +=  7;		// Ci
		g_player_param.m_ParamInt[pKANNJYU]  += 10;		// 
		g_player_param.m_ParamInt[pBUJYUTU]  -=  1;		// p\
		g_player_param.m_ParamInt[pMAJYUTU]  += 15;		// p\
	}
/*
	g_player_param.m_ParamInt[
	g_player_param.m_ParamInt[
	g_player_param.m_ParamInt[
	g_player_param.m_ParamInt[
	g_player_param.m_ParamInt[
	g_player_param.m_ParamInt[
	g_player_param.m_ParamInt[
	g_player_param.m_ParamInt[
	g_player_param.m_ParamInt[
	g_player_param.m_ParamInt[
	g_player_param.m_ParamInt[
	g_player_param.
*/

	// fobOp
#ifdef DARK_TOWN_CHECK
	g_player_param.m_ageWidth = ageL;
	setLabel(LF_ev073_0, ON);

	g_player_param.m_Year = 105;			// 1440 - 1341 = 99
	g_player_param.m_GameY = 6;
	g_player_param.m_GameM = 7;
	g_player_param.m_GameM = y1446_7;
	setLabel(LF_ac00_0, ON);
	setLabel(LF_ac05_0, ON);

	addItem(52);
	setLabel(LF_adv02_6, ON);

	setLabel(LF_ev022, ON);
	setLabel(LF_ev023, ON);
	setLabel(LF_ev023_0, ON);
	setLabel(LF_ev016, ON);
	g_player_param.m_ParamInt[pDY] = 500;
#endif

#ifdef ITEM_CHECK
//	addItem(1);
//	addItem(4);
//	addItem(75);
//	addItem(10);
//	addItem(13);
//	addItem(15);
//	addItem(17);
//	addItem(19);
	addItem(59);
	addItem(60);
	addItem(61);
	addItem(62);
	addItem(64);
	addItem(68);
	addItem(57);
	addItem(82);
	addItem(13);
	addItem(14);
	addItem(15);
	addItem(15);
	addItem(15);
	addItem(16);
	addItem(17);
	addItem(18);
	addItem(20);
	addItem(22);
	addItem(24);
	addItem(53);
	addItem(55);
	addItem(56);
	addItem(81);
	addItem(4);
	addItem(3);
	addItem(80);
	addItem(12);

	g_player_param.m_ParamInt[pBust]   =  92;
	g_player_param.m_ParamInt[pWaist]  =  55;
	g_player_param.m_ParamInt[pHip]    =  80;
	g_player_param.m_ParamInt[pHeight] = 166;
	g_player_param.m_ParamInt[pWeight] =  38;
	g_player_param.m_ageWidth = ageH;
#endif

#ifdef SICK_CHECK
	g_player_param.m_con = conS;
	g_player_param.m_Gold = 60000;
#endif

#ifdef ORK_CHECK
	g_player_param.m_ageWidth = ageL;
	setLabel(LF_ev073_0, ON);
	setLabel(LF_adv02_6, ON);
#endif

#ifdef BUTOU_CHECK
	setLabel(LF_getSchDance_3, ON);
	setLabel(LF_getSchDance_4, OFF);
#endif

#ifdef NFD_CHECK
	g_player_param.m_Year = 106;			// 1440 - 1341 = 99
	g_player_param.m_Month = 1;
	g_player_param.m_Day = 1;
	g_player_param.m_Week = 3;
	g_player_param.m_GameY = 7;
	addItem(57);
	addItem(61);
	addItem(62);
	addItem(63);
	addItem(83);
	addItem(10);
	g_player_param.m_ParamInt[pBust]   =  92;
	g_player_param.m_ParamInt[pWaist]  =  55;
	g_player_param.m_ParamInt[pHip]    =  80;
	g_player_param.m_ParamInt[pHeight] = 166;
	g_player_param.m_ParamInt[pWeight] =  38;
	g_player_param.m_ageWidth = ageH;
	g_player_param.m_ParamInt[pPR] = 500;
	setLabel(LF_ev019, ON);
#endif

#ifdef BIRTH_CHECK
	g_player_param.m_BirthM = 4;
	g_player_param.m_BirthD = 2;
#endif

#ifdef HOLI_CHECK
	g_player_param.m_Year = 102;			// 1440 - 1341 = 99
	g_player_param.m_Month = 12;
	g_player_param.m_Day = 1;
	g_player_param.m_Week = 3;
	g_player_param.m_GameY = 3;
#endif
#ifdef FE_CHECK
	g_player_param.m_Month = 9;
	g_player_param.m_Year = 100;			// 1440 - 1341 = 99
	g_player_param.m_GameY = 1;
	g_player_param.m_RoomPic = 1;
	g_player_param.m_ParamInt[pBust]   =  92;
	g_player_param.m_ParamInt[pWaist]  =  55;
	g_player_param.m_ParamInt[pHip]    =  80;
	g_player_param.m_ParamInt[pHeight] = 166;
	g_player_param.m_ParamInt[pWeight] =  38;
	g_player_param.m_ParamInt[pTAIRYOKU] = (u16)(getRandom() % 1000);		// X^~i
	g_player_param.m_ParamInt[pCHIRYOKU] = (u16)(getRandom() % 1000);		// m
	g_player_param.m_ParamInt[pBUJYUTU]  = (u16)(getRandom() % 1000);		// p\
	g_player_param.m_ParamInt[pMAJYUTU]  = (u16)(getRandom() % 1000);		// p\
	g_player_param.m_ParamInt[pPRIDE]    = (u16)(getRandom() % 1000);		// 
	g_player_param.m_ParamInt[pMORAL]    = (u16)(getRandom() % 1000);		// 
	g_player_param.m_ParamInt[pKANNJYU]  = (u16)(getRandom() % 1000);		// 
	addItem(61);
	addItem(1);
	addItem(2);
	addItem(3);
	addItem(4);
	addItem(5);
	addItem(6);
	addItem(7);
	addItem(75);
	addItem(76);
	addItem(80);
	addItem(8);
	addItem(9);
	addItem(10);
	addItem(11);
	addItem(12);
#endif
#ifdef AKUMASHOP_CHECK
	setLabel(LF_at03_4, ON);
	setLabel(LF_openAkumaShop, OFF);
#endif
#ifdef POOR_CHECK
	g_player_param.m_Gold = 10;
#endif
#ifdef RIVAL_CHECK
	g_player_param.m_Month = 9;
#endif
#ifdef CERO2_CHECK
	addItem(57);
	addItem(58);
	addItem(59);
	addItem(60);
	addItem(61);
	addItem(62);
	addItem(63);
	addItem(64);
	addItem(65);
	addItem(67);
	addItem(68);
	g_player_param.m_ParamInt[pBust]   =  92;
	g_player_param.m_ParamInt[pWaist]  =  55;
	g_player_param.m_ParamInt[pHip]    =  80;
	g_player_param.m_ParamInt[pHeight] = 166;
	g_player_param.m_ParamInt[pWeight] =  38;
	if (getPad() & PAD_BUTTON_L)
		g_player_param.m_ageWidth = ageH;
	else
		g_player_param.m_ageWidth = ageL;
#endif
#ifdef KIHIN_CHECK
	g_player_param.m_ParamInt[pKIHINN] = 800;		// Ci
	g_player_param.m_ParamInt[pCHIMEI] = 900; 		// mx
#endif
#ifdef GOLD_CHECK
	g_player_param.m_Gold = 100000;
#endif
#ifdef OUJI_CHECK
	g_player_param.m_Year = 105;			// 1440 - 1341 = 99
	g_player_param.m_GameY = 6;
	g_player_param.m_GameM = y1446_4;
	g_player_param.m_ageWidth = ageL;
//	setLabel(LF_ev073_0, ON);
//	setLabel(LF_ev050, ON);
//	setLabel(LF_ev051, ON);
//	setLabel(LF_ev053, ON);
//	setLabel(LF_ev055, ON);
	g_player_param.m_ParamInt[pPR] = 500;
#endif
#ifdef ENDING_CHECK
	g_player_param.m_Year = 107;			// 1440 - 1341 = 99
	g_player_param.m_Month = 3;
	g_player_param.m_Day = 31;

	g_player_param.m_ParamInt[pTAIRYOKU] = 0;		// X^~i
	g_player_param.m_ParamInt[pCHIRYOKU] = 0;		// m
	g_player_param.m_ParamInt[pMIRYOKU]  = 0;		// 
	g_player_param.m_ParamInt[pPRIDE]    = 0;		// vCh
	g_player_param.m_ParamInt[pMORAL]    = 0;		// 
	g_player_param.m_ParamInt[pKIHINN]   = 0;		// Ci
	g_player_param.m_ParamInt[pKANNJYU]  = 0;		// 
	g_player_param.m_ParamInt[pKIDATE]   = 0;		// C
	g_player_param.m_ParamInt[pCHIMEI]   = 0;		// mx
	g_player_param.m_ParamInt[pBUJYUTU]  = 0;		// p\
	g_player_param.m_ParamInt[pMAJYUTU]  = 0;		// p\
	g_player_param.m_ParamInt[pINGOU]    = 0;	 	// 
	g_player_param.m_ParamInt[pHIROU]    = 0; 		// Jx
	g_player_param.m_ParamInt[pFA]       = 299;
	g_player_param.m_ParamInt[pMAZOKU]   = 99;
#endif
#ifdef KUMA_CHECK
	g_player_param.m_GameM = y1443_6;
#endif
}


//---------------------------------------------------------------------------
//
// common.gh
//
//---------------------------------------------------------------------------
// -------------------------------------
// }NF#m_getBMI
// -------------------------------------
s32 getBMI(void)
{
	g_player_param.m_BMI = (u16)(((s32)g_player_param.m_ParamInt[pWeight] * 10) / ((s32)g_player_param.m_ParamInt[pHeight] * (s32)g_player_param.m_ParamInt[pHeight] / 10000));
	return g_player_param.m_BMI;
}
// -------------------------------------
// XPW[ső邨
// -------------------------------------
s32 getScheduleGold(s32 in_sch)
{
	s32
		gold,
		studyG[6][4] = 
		{
			{ -10, -15, -30, 10 },		// w
			{ -10, -15, -30, 10 },		// p
			{ -15, -20, -35, 10 },		// p
			{ -10, -15, -35, 10 },		// @
			{ -10, -15, -30, 10 },		// |p
			{ -15, -20, -35, 10 }		// 
		};

	if (in_sch < 6)
	{
		gold = studyG[in_sch][g_player_param.m_SchRank[in_sch]];
	} else
	if (in_sch == jKajiTetudai)
	{
		// Ǝ`
		gold = 0;
	} else
	if (in_sch == jKomori)
	{
		// q
		gold = 8 * (100 + 25 * g_player_param.m_SchRank[jKomori]) / 100;
	} else
	if (in_sch == jNoujyou)
	{
		// _
		gold = 15 * (100 + 25 * g_player_param.m_SchRank[jNoujyou]) / 100;
	} else
	if (in_sch == jKyoukai)
	{
		// 
		gold = 1 + g_player_param.m_SchRank[jKyoukai];
	} else
	if (in_sch == jRyouriya)
	{
		// 
		gold = 15 * (100 + 25 * g_player_param.m_SchRank[jRyouriya]) / 100;
	} else
	if (in_sch == jMeido)
	{
		// Ch
		gold = 18 * (100 + 25 * g_player_param.m_SchRank[jMeido]) / 100;
	} else
	if (in_sch == jKikori)
	{
		// ؂
		gold = 25 * (100 + 25 * g_player_param.m_SchRank[jKikori]) / 100;
	} else
	if (in_sch == jYadoya)
	{
		// h
		gold = 10 * (100 + 25 * g_player_param.m_SchRank[jYadoya]) / 100;
	} else
	if (in_sch == jIchiba)
	{
		// s
		gold = 20 * (100 + 25 * g_player_param.m_SchRank[jIchiba]) / 100;
	} else
	if (in_sch == jSakaba)
	{
		// 
		if (getLabel(LF_al09_8))
			gold = 25 * (125 + 25 * g_player_param.m_SchRank[jSakaba]) / 100;
		else
			gold = 25 * (100 + 25 * g_player_param.m_SchRank[jSakaba]) / 100;
		if (g_player_param.m_Wave == 1)
			gold = gold * 15 / 10;		// ҏ̎͋1.5{
	} else
	if (in_sch == jKateiKyousi)
	{
		// ƒ닳t
		if (getLabel(LF_al10_9))
			gold = 25 * (125 + 25 * g_player_param.m_SchRank[jKateiKyousi]) / 100;
		else
			gold = 25 * (100 + 25 * g_player_param.m_SchRank[jKateiKyousi]) / 100;
	} else
	if (in_sch == jMeidoSakaba)
	{
		// Ch
		gold = 33 * (100 + 25 * g_player_param.m_SchRank[jMeidoSakaba]) / 100;
		if (g_player_param.m_Wave == 1)
			gold = gold * 12 / 10;		// ҏ̎͋1.2{
	} else
	if (in_sch == jAyasiiSakaba)
	{
		// 
		if (getLabel(LF_al12_8))
			gold = 45 * (125 + 25 * g_player_param.m_SchRank[jAyasiiSakaba]) / 100;
		else
			gold = 45 * (100 + 25 * g_player_param.m_SchRank[jAyasiiSakaba]) / 100;
		if (g_player_param.m_Wave == 1)
			gold = gold * 12 / 10;		// ҏ̎͋1.2{
	} else
	if (in_sch == jKajino)
	{
		// JWm
		gold = 40 * (100 + 25 * g_player_param.m_SchRank[jKajino]) / 100;
	} else
	if (in_sch == jYasumi)
	{
		// x
		gold = 0;
	} else
	if (in_sch == jBakansu)
	{
		// oJX
		gold = -30;
	} else
	if (in_sch == jOdekake)
	{
		// ł
		gold = 0;
	} else
	if (in_sch == jRyouyou)
	{
		// ×{
		gold = 0;
	}
	return gold;
}
// -------------------------------------
// 
// -------------------------------------
s32 getLivingGold(void)
{
	s32 gold;

	if (g_player_param.m_Policy == polNor)
		gold = 30;
	else
	if (g_player_param.m_Policy == polAct)
		gold = 80;
	else
	if (g_player_param.m_Policy == polMod)
		gold = 10;
	else
	if (g_player_param.m_Policy == polDie)
		gold = 5;
	return gold;
}
//----------------------------------
// }X^[NX̕׋邩H𔻒
//----------------------------------
BOOL CheckSchRankMaster(void)
{
	if (g_player_param.m_SchRank[jZagaku] != 3 &&
		g_player_param.m_SchRank[jReihou] != 3 &&
		g_player_param.m_SchRank[jBujyutu] != 3 &&
		g_player_param.m_SchRank[jMajyutu] != 3 &&
		g_player_param.m_SchRank[jGeijyutu] != 3 &&
		g_player_param.m_SchRank[jButou] != 3)
	{
		return FALSE;
	}
	return TRUE;
}
//---------------------------------------------------------------------------
//
// p[^
//
//---------------------------------------------------------------------------
// -------------------------------------
// p[^̕\^Cv
// -------------------------------------
void setParamType(u8 in_num)
{
	// p 0: 1: 2: 3:
	g_player_param.m_ParamType = in_num;
}
// -------------------------------------
u8 getParamType(void)
{
	return g_player_param.m_ParamType;
}
// -------------------------------------
// OǗ
// -------------------------------------
void setName(s32 in_num, u8 *in_name)
{
	if (in_num == 0)
	{
		// O
		memcpyBDS((s8 *)&g_player_param.m_Name1[0], (s8 *)in_name, 12);
		memcpyBDS((s8 *)&g_common_param.m_Name1Bak[0], (s8 *)in_name, 12);
		saveCommonData();
	} else {
		// 
		memcpyBDS((s8 *)&g_player_param.m_Name2[0], (s8 *)in_name, 12);
		memcpyBDS((s8 *)&g_common_param.m_Name2Bak[0], (s8 *)in_name, 12);
		saveCommonData();
	}
}
// -------------------------------------
u8 * getName(s32 in_num)
{
	u8 *ptr;

	if (in_num == 0)
	{
		// O
		ptr = &g_player_param.m_Name1[0];
	} else {
		// 
		ptr = &g_player_param.m_Name2[0];
	}
	return ptr;
}
// -------------------------------------
// t^(0=A , 1=B , 2=O , 3=AB
// -------------------------------------
void setBlood(u8 in_blood)
{
	g_player_param.m_Blood = in_blood;
}
// -------------------------------------
u8 getBlood(void)
{
	return g_player_param.m_Blood;
}
// -------------------------------------
// a N
// -------------------------------------
void setBirth(u8 in_y, u8 in_m, u8 in_d)
{
	g_player_param.m_BirthY = in_y;
	g_player_param.m_BirthM = in_m;
	g_player_param.m_BirthD = in_d;
}
// -------------------------------------
void getBirth(u8 *in_y, u8 *in_m, u8 *in_d)
{
	*in_y = g_player_param.m_BirthY;
	*in_m = g_player_param.m_BirthM;
	*in_d = g_player_param.m_BirthD;
}
// -------------------------------------
// a N
// -------------------------------------
void setFBirth(u8 in_y, u8 in_m, u8 in_d)
{
	g_player_param.m_FBirthY = in_y;
	g_player_param.m_FBirthM = in_m;
	g_player_param.m_FBirthD = in_d;
}
// -------------------------------------
void getFBirth(u8 *in_y, u8 *in_m, u8 *in_d)
{
	*in_y = g_player_param.m_FBirthY;
	*in_m = g_player_param.m_FBirthM;
	*in_d = g_player_param.m_FBirthD;
}
// -------------------------------------
// N
// -------------------------------------
void setAge(u8 in_age)
{
	g_player_param.m_Age = in_age;
}
// -------------------------------------
u8 getAge(void)
{
	return g_player_param.m_Age;
}
// -------------------------------------
// N(0=C, 1=L, 2=H
// -------------------------------------
void setageWidth(u8 in_age_width)
{
	g_player_param.m_ageWidth = in_age_width;
}
// -------------------------------------
u8 getageWidth(void)
{
	return g_player_param.m_ageWidth;
}
// -------------------------------------
// 琬j
// -------------------------------------
void setPolicy(u8 in_policy)
{
	g_player_param.m_Policy = in_policy;
}
// -------------------------------------
u8 getPolicy(void)
{
	return g_player_param.m_Policy;
}
// -------------------------------------
// mԍ
// -------------------------------------
void setDress(u8 in_dress)
{
	g_player_param.m_Dress = in_dress;
}
// -------------------------------------
u8 getDress(void)
{
	return g_player_param.m_Dress;
}
// -------------------------------------
// ̊Gԍi0`3)
// -------------------------------------
void setRoomPic(u8 in_room_pic)
{
	g_player_param.m_RoomPic = in_room_pic;
}
// -------------------------------------
u8 getRoomPic(void)
{
	return g_player_param.m_RoomPic;
}
// -------------------------------------
// ̏	0=ʏ,1=s,2=aC
// -------------------------------------
void setcon(u8 in_con)
{
	g_player_param.m_con = in_con;
}
// -------------------------------------
u8 getcon(void)
{
	return g_player_param.m_con;
}
// -------------------------------------
// ĂACeobt@
// -------------------------------------
void setItem(s32 in_item, u8 in_num)
{
	g_player_param.m_Item[in_item] = in_num;
}
// -------------------------------------
u8 getItem(s32 in_item)
{
	return g_player_param.m_Item[in_item];
}
// -------------------------------------
void addItem(u8 in_num)
{
	g_player_param.m_Item[g_player_param.m_ItemCount] = in_num;
	g_player_param.m_ItemCount++;
	updateItem();
}
// -------------------------------------
void deleteItem(u8 in_num)
{
	s32 i;

	for (i=0; i<g_player_param.m_ItemCount; i++)
	{
		if (g_player_param.m_Item[i] == in_num)
		{
			g_player_param.m_ItemCount--;
			g_player_param.m_Item[i] = g_player_param.m_Item[g_player_param.m_ItemCount];
			g_player_param.m_Item[g_player_param.m_ItemCount] = 0;
			break;
		}
	}
	updateItem();
}
// -------------------------------------
void updateItem(void)
{
	s32 i;

	for (i=0; i<28; i++)
		setParamOfs(i, 0);
	for (i=0; i<g_player_param.m_ItemCount; i++)
	{
		switch (g_player_param.m_Item[i])
		{
			case 15:		//l`
				addParamOfs(pKANNJYU, 500);
				addParamOfs(pHIROU, -500);
				break;
			case 16:		//W
				addParamOfs(pKANNJYU, 500);
				break;
			case 17:		//
				addParamOfs(pCHIRYOKU, 800);
				break;
			case 18:		//eB[Jbv
				addParamOfs(pKIHINN, 1000);
			case 19:		//ϓ
				addParamOfs(pMIRYOKU, 500);
				break;
			case 20:		//nCq[
				addParamOfs(pKIHINN, 500);
				break;
			case 21:		//ٖD
				addParamOfs(pKIDATE, 500);
				break;
			case 22:		//@
				addParamOfs(pMORAL, 500);
				break;
			case 23:		//ꂽ
				addParamOfs(pPRIDE, 500);
				break;
			case 24:		//p[Xg
				addParamOfs(pTAIRYOKU, 500);
				break;
			case 32:		//ԑ
				addParamOfs(pMIRYOKU, 1000);
				break;
			case 33:		//IS[
				addParamOfs(pKANNJYU, 1500);
				break;
			case 36:		//X}C
				addParamOfs(pMORAL, 500);
				addParamOfs(pFA, 100);
				break;
			case 55:		//̎w
				addParamOfs(pKIHINN, 1000);
				addParamOfs(pMAZOKU, 2500);
				break;
			case 56:		//̎
				addParamOfs(pMIRYOKU, 3000);
				addParamOfs(pKIHINN, -1000);
				addParamOfs(pMAJYUTU, 1000);
				addParamOfs(pMAZOKU,  1000);
				break;
			case 79:		//̎
				addParamOfs(pKIHINN, 2000);
				addParamOfs(pMAZOKU, -99900);
				break;
			case 81:		//d̗
				addParamOfs(pKANNJYU, 1000);
				break;
			default:
				;
		}
	}
	switch (g_player_param.m_Dress)
	{
		case 4:			// hX
			addParamOfs(pKIHINN, 1500);
			break;
		case 5:			// VÑhX
			addParamOfs(pKIHINN, 4000);
			break;
		case 6:			// ؂ȃhX
			addParamOfs(pMIRYOKU, 3000);
			addParamOfs(pKIHINN, 3000);
			break;
		case 7:			// p
			addParamOfs(pMIRYOKU, -500);
			addParamOfs(pBUJYUTU, 1000);
			break;
		case 8:			// pt̐
			addParamOfs(pMIRYOKU, -500);
			addParamOfs(pMAJYUTU, 1000);
			break;
		case 11:		// U[X[c
			addParamOfs(pMIRYOKU, 5000);
			addParamOfs(pKIHINN,  -2000);
			break;
		case 12:		// C
			addParamOfs(pMORAL, 2000);
			break;
		case 17:		// X̃[u
			addParamOfs(pMIRYOKU, 16000);
			break;
		case 18:		// P̃hX
			addParamOfs(pMIRYOKU, 4500);
			addParamOfs(pMORAL, -10000);
			addParamOfs(pMAZOKU, 2000);
			break;
		case 19:		// ̃hX
			addParamOfs(pMIRYOKU, 2800);
			break;
	}
}
//---------------------------------------------------------
// ɍsp[^ϓ
//---------------------------------------------------------
void funcParamChangeEndOfMonth(void)
{
	// t^ɂ
	switch (getBlood())
	{
		case blood_A:		// `
			addParam(pMORAL, 200);		// 
			addParam(pHIROU, 100);		// J
			break;
		case blood_B:		// a
			addParam(pHIROU, -200);		// J
			addParam(pTAIRYOKU, 100);	// ̗
			break;
		case blood_O:		// n
			addParam(pPRIDE, 100);		// vCh
			addParam(pTAIRYOKU, 100);	// ̗
			break;
		case blood_AB:		// `a
			addParam(pKANNJYU, 100);	// 
			addParam(pPRIDE, 100);		// vCh
			addParam(pHIROU, 100);		// J
			break;
	}

	switch (getPolicy())
	{
		case 0:				// Ȃ
			if (getageWidth() == ageC)
			{
				// C
				addParam(pHeight, 39);
				addParam(pWeight, 26);
				addParam(pBust,   30);
				addParam(pWaist,  15);
				addParam(pHip,    33);
			} else
			if (getageWidth() == ageL)
			{
				// L
				addParam(pHeight, 17);
				addParam(pWeight, 17);
				addParam(pBust,   18);
				addParam(pWaist,   5);
				addParam(pHip,    18);
			} else {
				// H
				addParam(pHeight, 10);
				addParam(pWeight,  8);
				addParam(pBust,   10);
				addParam(pWaist,   2);
				addParam(pHip,    10);
			}
			break;
		case 1:				// ɈĂ
			if (getageWidth() == ageC)
			{
				// C
				addParam(pTAIRYOKU, 250);	// ̗
				addParam(pHeight, 50);
				addParam(pWeight, 70);
				addParam(pBust,   40);
				addParam(pWaist,  55);
				addParam(pHip,    40);
			} else
			if (getageWidth() == ageL)
			{
				// L
				addParam(pTAIRYOKU, 500);	// ̗
				addParam(pHeight, 35);
				addParam(pWeight, 50);
				addParam(pBust,   20);
				addParam(pWaist,  35);
				addParam(pHip,    20);
			} else {
				// H
				addParam(pTAIRYOKU, 1000);	// ̗
				addParam(pHeight, 15);
				addParam(pWeight, 30);
				addParam(pBust,   18);
				addParam(pWaist,  20);
				addParam(pHip,    18);
			}
			break;
		case 2:				// Ƃ₩
			if (getageWidth() == ageC)
			{
				// C
				addParam(pTAIRYOKU, -250);	// ̗
				addParam(pHeight, 30);
				addParam(pWeight, 19);
				addParam(pBust,   29);
				addParam(pWaist,  12);
				addParam(pHip,    30);
			} else
			if (getageWidth() == ageL)
			{
				// L
				addParam(pTAIRYOKU, -500);	// ̗
				addParam(pHeight, 12);
				addParam(pWeight,  8);
				addParam(pBust,   17);
				addParam(pWaist,   4);
				addParam(pHip,    15);
			} else {
				// H
				addParam(pTAIRYOKU, -500);	// ̗
				addParam(pHeight,  8);
				addParam(pWeight,  5);
				addParam(pBust,    8);
				addParam(pWaist,   1);
				addParam(pHip,     8);
			}
			break;
		case 3:				// _CGbg
			if (getageWidth() == ageC)
			{
				// C
				addParam(pTAIRYOKU, -500);	// ̗
				addParam(pHeight, 20);
				addParam(pWeight, -5);
				addParam(pBust,   25);
				addParam(pWaist,  -5);
				addParam(pHip,    27);
			} else
			if (getageWidth() == ageL)
			{
				// L
				addParam(pTAIRYOKU, -1000);	// ̗
				addParam(pHeight, 10);
				addParam(pWeight,-40);
				addParam(pBust,   14);
				addParam(pWaist, -40);
				addParam(pHip,    15);
			} else {
				// H
				addParam(pTAIRYOKU, -1500);	// ̗
				addParam(pHeight,  5);
				addParam(pWeight,-60);
				addParam(pBust,    5);
				addParam(pWaist, -60);
				addParam(pHip,     5);
			}
			break;
	}

	if (getWave() == 1)
	{
		//ҏ
		if (isItem(59) == -1)
			addParam(pHIROU, 500);
		else
			addParam(pWeight, -50);
	} else
	if (getWave() == 2)
	{
		//~
		if (isItem(60) == -1)
			addParam(pHIROU, 500);
		else
			addParam(pTAIRYOKU, 500);	// ̗
	}

	if (isItem(53) != -1)
	{
		//ÂтF
		addParam(pHIROU, -500);
		addParam(pMAZOKU, 100);
	}

	if (isItem(54) != -1)
	{
		//Ȃ钤
		addParam(pHIROU, -500);
		addParam(pINGOU, 100);
	}

	if (isItem(81) != -1)
	{
		//d̗
		addParam(pMAZOKU, -100);
	}

	//aCn}iaCő̗͂OEJO܂ȂԂƁA΂ɉ񕜂łȂj
	if (getParam(pTAIRYOKU) < 10)
		setParam(pTAIRYOKU, 1000);
}


// -------------------------------------
// ĂACe
// -------------------------------------
void setItemCount(u8 in_item_count)
{
	g_player_param.m_ItemCount = in_item_count;
}
// -------------------------------------
u8 getItemCount(void)
{
	return g_player_param.m_ItemCount;
}
// -------------------------------------
// N(0=1341 255=1596)   j
// -------------------------------------
void setDays(u8 in_y, u8 in_m, u8 in_d, u8 in_w)
{
	g_player_param.m_Year = in_y;
	g_player_param.m_Month = in_m;
	g_player_param.m_Day = in_d;
	g_player_param.m_Week = in_w;
}
// -------------------------------------
void getDays(u8 *in_y, u8 *in_m, u8 *in_d, u8 *in_w)
{
	*in_y = g_player_param.m_Year;
	*in_m = g_player_param.m_Month;
	*in_d = g_player_param.m_Day;
	*in_w = g_player_param.m_Week;
}
// -------------------------------------
u16 getYear(void)
{
	return (u16)(g_player_param.m_Year + 1341);
}
// -------------------------------------
u8 getMonth(void)
{
	return g_player_param.m_Month;
}
// -------------------------------------
u8 getDay(void)
{
	return g_player_param.m_Day;
}
// -------------------------------------
u8 getWeek(void)
{
	return g_player_param.m_Week;
}
// -------------------------------------
// Q[Jn̔N
// -------------------------------------
void setGameY(u8 in_game_y)
{
	g_player_param.m_GameY = in_game_y;
}
// -------------------------------------
u8 getGameY(void)
{
	return g_player_param.m_GameY;
}
// -------------------------------------
// Q[Jň
// -------------------------------------
void setGameM(u8 in_game_m)
{
	g_player_param.m_GameM = in_game_m;
}
// -------------------------------------
u8 getGameM(void)
{
	return g_player_param.m_GameM;
}
// -------------------------------------
// G߁i0:tA1:āA2:HA3:~)
// -------------------------------------
void setSeason(u8 in_season)
{
	g_player_param.m_Season = in_season;
}
// -------------------------------------
u8 getSeason(void)
{
	return g_player_param.m_Season;
}
// -------------------------------------
// oG߁i0:A1:ҏA2:~j
// -------------------------------------
void setWave(u8 in_wave)
{
	g_player_param.m_Wave = in_wave;
}
// -------------------------------------
u8 getWave(void)
{
	return g_player_param.m_Wave;
}
// -------------------------------------
// 
// -------------------------------------
void setTimeZone(u8 in_time_zone)
{
	g_player_param.m_TimeZone = in_time_zone;
}
// -------------------------------------
u8 getTimeZone(void)
{
	return g_player_param.m_TimeZone;
}
// -------------------------------------
// 1:푈
// -------------------------------------
void setWarFlag(u8 in_war_flag)
{
	g_player_param.m_WarFlag = in_war_flag;
}
// -------------------------------------
u8 getWarFlag(void)
{
	return g_player_param.m_WarFlag;
}
// -------------------------------------
// 
// -------------------------------------
void setSale(u8 in_sale)
{
	g_player_param.m_Sale = in_sale;
}
// -------------------------------------
u8 getSale(void)
{
	return g_player_param.m_Sale;
}
// -------------------------------------
// ܎҂̔ԍ
// -------------------------------------
void setbtWinNo(u8 in_num, u8 in_char)
{
	g_player_param.m_btWinNo[in_num] = in_char;
}
// -------------------------------------
u8 getbtWinNo(u8 in_num)
{
	return g_player_param.m_btWinNo[in_num];
}
// -------------------------------------
// nՂ̋Zԍ
// -------------------------------------
void setharvestNo(u8 in_num)
{
	g_player_param.m_harvestNo = in_num;
}
// -------------------------------------
u8 getharvestNo(void)
{
	return g_player_param.m_harvestNo;
}
// -------------------------------------
// TalksǂiŃNAj
// -------------------------------------
void setTalkExec(BOOL in_talk_exec)
{
	if (in_talk_exec)
		g_player_param.m_Flag |= 0x01;
	else
		g_player_param.m_Flag &= 0xfe;
}
// -------------------------------------
BOOL getTalkExec(void)
{
	BOOL result;

	if (g_player_param.m_Flag & 0x01)
		result = TRUE;
	else
		result = FALSE;
	return result;
}
// -------------------------------------
// NAbṽbZ[W
// -------------------------------------
void setRankupMsg(u8 in_num, BOOL in_flag)
{
	u8 n;

	n = (u8)(2 << in_num);
	if (in_flag)
		g_player_param.m_Flag |= n;
	else
		g_player_param.m_Flag &= ~n;
}
// -------------------------------------
BOOL getRankupMsg(u8 in_num)
{
	u8 n;
	BOOL result;

	n = (u8)(2 << in_num);
	if (g_player_param.m_Flag & n)
		result = TRUE;
	else
		result = FALSE;
	return result;
}
// -------------------------------------
// Viqj
// -------------------------------------
void setevm_pa(u8 in_evm_pa)
{
	g_player_param.m_evm_pa = in_evm_pa;
}
// -------------------------------------
u8 getevm_pa(void)
{
	return g_player_param.m_evm_pa;
}
// -------------------------------------
// hS[X
// -------------------------------------
void setevm_pb(u8 in_evm_pb)
{
	g_player_param.m_evm_pb = in_evm_pb;
}
// -------------------------------------
u8 getevm_pb(void)
{
	return g_player_param.m_evm_pb;
}
// -------------------------------------
// @A
// -------------------------------------
void setevm_pc(u8 in_evm_pc)
{
	g_player_param.m_evm_pc = in_evm_pc;
}
// -------------------------------------
u8 getevm_pc(void)
{
	return g_player_param.m_evm_pc;
}
// -------------------------------------
// x
// -------------------------------------
void setevm_pd(u8 in_evm_pd)
{
	g_player_param.m_evm_pd = in_evm_pd;
}
// -------------------------------------
u8 getevm_pd(void)
{
	return g_player_param.m_evm_pd;
}
// -------------------------------------
// [[
// -------------------------------------
void setevm_ra(u8 in_evm_ra)
{
	g_player_param.m_evm_ra = in_evm_ra;
}
// -------------------------------------
u8 getevm_ra(void)
{
	return g_player_param.m_evm_ra;
}
// -------------------------------------
// NX`[i
// -------------------------------------
void setevm_rb(u8 in_evm_rb)
{
	g_player_param.m_evm_rb = in_evm_rb;
}
// -------------------------------------
u8 getevm_rb(void)
{
	return g_player_param.m_evm_rb;
}
// -------------------------------------
// }[
// -------------------------------------
void setevm_rc(u8 in_evm_rc)
{
	g_player_param.m_evm_rc = in_evm_rc;
}
// -------------------------------------
u8 getevm_rc(void)
{
	return g_player_param.m_evm_rc;
}
// -------------------------------------
// J
// -------------------------------------
void setevm_rd(u8 in_evm_rd)
{
	g_player_param.m_evm_rd = in_evm_rd;
}
// -------------------------------------
u8 getevm_rd(void)
{
	return g_player_param.m_evm_rd;
}
// -------------------------------------
// K˂
// -------------------------------------
void setevm_adv01(u8 in_evm_adv01)
{
	g_player_param.m_evm_adv01 = in_evm_adv01;
}
// -------------------------------------
u8 getevm_adv01(void)
{
	return g_player_param.m_evm_adv01;
}
// -------------------------------------
// ݈ԐeCo
// -------------------------------------
void setRvlEnc(u8 in_rvl_enc)
{
	g_player_param.m_RvlEnc = in_rvl_enc;
}
// -------------------------------------
u8 getRvlEnc(void)
{
	return g_player_param.m_RvlEnc;
}
// -------------------------------------
// Ǒ̖x
// -------------------------------------
void setDemonize(u16 in_demonize)
{
	g_player_param.m_Demonize = in_demonize;
}
// -------------------------------------
u16 getDemonize(void)
{
	return g_player_param.m_Demonize;
}
// -------------------------------------
// N
// -------------------------------------
void setDemonRank(u8 in_demonrank)
{
	g_player_param.m_DemonRank = in_demonrank;
}
// -------------------------------------
u8 getDemonRank(void)
{
	return g_player_param.m_DemonRank;
}
// -------------------------------------
// ̏K
// -------------------------------------
void setcountAC(u8 in_count_ac)
{
	g_player_param.m_countAC = in_count_ac;
}
// -------------------------------------
void inccountAC(void)
{
	if (g_player_param.m_countAC != 255)
		g_player_param.m_countAC++;
}
// -------------------------------------
u8 getcountAC(void)
{
	return g_player_param.m_countAC;
}
// -------------------------------------
// _[N^EK
// -------------------------------------
void setcountDT(u8 in_count_dt)
{
	g_player_param.m_countDT = in_count_dt;
}
// -------------------------------------
void inccountDT(void)
{
	if (g_player_param.m_countDT != 255)
		g_player_param.m_countDT++;
}
// -------------------------------------
u8 getcountDT(void)
{
	return g_player_param.m_countDT;
}
// -------------------------------------
// XPW[N
// -------------------------------------
void setSchRank(s32 in_sch, u8 in_num)
{
	g_player_param.m_SchRank[in_sch] = in_num;
}
// -------------------------------------
u8 getSchRank(s32 in_sch)
{
	return g_player_param.m_SchRank[in_sch];
}
// -------------------------------------
// OɍsXPW[
// -------------------------------------
void setSchLast(s32 in_sch, u8 in_num)
{
	g_player_param.m_SchLast[in_sch] = in_num;
}
// -------------------------------------
void incSchLast(s32 in_sch)
{
	g_player_param.m_SchLast[in_sch]++;
}
// -------------------------------------
u8 getSchLast(s32 in_sch)
{
	return g_player_param.m_SchLast[in_sch];
}
// -------------------------------------
// OɍsXPW[̌
// -------------------------------------
void setSchLastRes(s32 in_sch, s8 in_num)
{
	g_player_param.m_SchLastRes[in_sch] = in_num;
}
// -------------------------------------
void incSchLastRes(s32 in_sch)
{
	g_player_param.m_SchLastRes[in_sch]++;
}
// -------------------------------------
void decSchLastRes(s32 in_sch)
{
	g_player_param.m_SchLastRes[in_sch]--;
}
// -------------------------------------
s8 getSchLastRes(s32 in_sch)
{
	return g_player_param.m_SchLastRes[in_sch];
}
// -------------------------------------
// 
// -------------------------------------
void setGold(u32 in_gold)
{
	g_player_param.m_Gold = in_gold;
	if (g_player_param.m_Gold > 999999)
		g_player_param.m_Gold = 999999;
}
// -------------------------------------
u32 getGold(void)
{
	return g_player_param.m_Gold;
}
// -------------------------------------
void addGold(s32 in_add_gold)
{
	s32 g;

	g = (s32)g_player_param.m_Gold;
	g += in_add_gold;
	if (g > 999999)
		g = 999999;
	else
	if (g < 0)
		g = 0;
	g_player_param.m_Gold = (u32)g;
}
// -------------------------------------
// p[^
// -------------------------------------
void setParam(s32 in_param, s32 in_num)
{
	if (in_num > 99999)
		in_num = 99999;
	else
	if (in_num < 0)
		in_num = 0;
	if (in_param == pTAIRYOKU && in_num < 1000)
		in_num = 1000;
	if (in_param == pHeight && in_num > 20000)
		in_num = 20000;
	if (in_param == pWeight && in_num > 10000)
		in_num = 10000;
	if (in_param == pWeight && in_num < 2000)
		in_num = 2000;
	if (in_param == pBust && in_num > 10000)
		in_num = 10000;
	if (in_param == pWaist && in_num > 10000)
		in_num = 10000;
	if (in_param == pWaist && in_num < pBust - 5000)
		in_num = pBust - 5000;
	if (in_param == pWaist && in_num < 2000)
		in_num = 2000;
	if (in_param == pHip && in_num > 10000)
		in_num = 10000;

	g_player_param.m_ParamInt[in_param] = (u16)(in_num / 100);
	g_player_param.m_ParamDecim[in_param] = (u8)(in_num % 100);
}
// -------------------------------------
u32 getBaseParam(s32 in_param)
{
	u32 param;

	param = (u32)g_player_param.m_ParamInt[in_param] * 100 + (u32)g_player_param.m_ParamDecim[in_param];
	return param;
}
// -------------------------------------
void addParam(s32 in_param, s32 in_num)
{
	s32 param;

	param = (s32)getBaseParam(in_param);
	param += in_num;
	setParam(in_param, param);
}
// -------------------------------------
// p[^ItZbg
// -------------------------------------
void setParamOfs(s32 in_param, s32 in_num)
{
	g_player_param.m_ParamOfs[in_param] = in_num;
}
// -------------------------------------
s32 getParamOfs(s32 in_param)
{
	return g_player_param.m_ParamOfs[in_param];
}
// -------------------------------------
void addParamOfs(s32 in_param, s32 in_num)
{
	g_player_param.m_ParamOfs[in_param] += in_num;
}
// -------------------------------------
// p[^\l
// -------------------------------------
u32 getParam(s32 in_param)
{
	s32 param;

	param = (s32)getBaseParam(in_param);
	param += getParamOfs(in_param);
	if (param > 99999)
		param = 99999;
	else
	if (param < 0)
		param = 0;
	if (in_param == pTAIRYOKU && param < 1000)
		param = 1000;
	else
	if (in_param == pHeight && param > 20000)
		param = 20000;
	else
	if (in_param == pWeight && param > 10000)
		param = 10000;
	else
	if (in_param == pBust && param > 10000)
		param = 10000;
	else
	if (in_param == pWaist && param > 10000)
		param = 10000;
	else
	if (in_param == pHip && param > 10000)
		param = 10000;
	return (u32)(param/100);
}
// -------------------------------------
// SchCount
// -------------------------------------
void setSchCount(s32 in_sch, u16 in_num)
{
	g_player_param.m_SchCount[in_sch] = in_num;
}
// -------------------------------------
void incSchCount(s32 in_sch)
{
	g_player_param.m_SchCount[in_sch]++;
}
// -------------------------------------
u16 getSchCount(s32 in_sch)
{
	return g_player_param.m_SchCount[in_sch];
}
// -------------------------------------
// SchDays
// -------------------------------------
void setSchDays(s32 in_sch, u16 in_num)
{
	g_player_param.m_SchDays[in_sch] = in_num;
}
// -------------------------------------
void incSchDays(s32 in_sch)
{
	g_player_param.m_SchDays[in_sch]++;
}
// -------------------------------------
u16 getSchDays(s32 in_sch)
{
	return g_player_param.m_SchDays[in_sch];
}
// -------------------------------------
// SchSuc
// -------------------------------------
void setSchSuc(s32 in_sch, u16 in_num)
{
	g_player_param.m_SchSuc[in_sch] = in_num;
}
// -------------------------------------
void incSchSuc(s32 in_sch)
{
	g_player_param.m_SchSuc[in_sch]++;
}
// -------------------------------------
u16 getSchSuc(s32 in_sch)
{
	return g_player_param.m_SchSuc[in_sch];
}
// -------------------------------------
// SchSet
// -------------------------------------
void setSchSet(s32 in_num, u8 in_flag)
{
	s32 flag;

	flag = 1 << in_num;
	if (in_flag == ON)
		g_player_param.m_SchSet |= flag;
	else
		g_player_param.m_SchSet &= ~flag;
}
// -------------------------------------
u8 getSchSet(s32 in_num)
{
	s32 flag;

	flag = 1 << in_num;
	if (g_player_param.m_SchSet & flag)
		return ON;
	return OFF;
}
// -------------------------------------
// NewSchGuide
// -------------------------------------
void setNewSchGuide(s32 in_num, BOOL in_flag)
{
	s32 flag;

	flag = 1 << in_num;
	if (in_flag == ON)
		g_player_param.m_NewSchGuide |= flag;
	else
		g_player_param.m_NewSchGuide &= ~flag;
}
// -------------------------------------
BOOL getNewSchGuide(s32 in_num)
{
	s32 flag;

	flag = 1 << in_num;
	if (g_player_param.m_NewSchGuide & flag)
		return TRUE;
	return FALSE;
}
// -------------------------------------
// x
// -------------------------------------
void setLabel(s32 in_label, BOOL in_flag)
{
	s32 label, flag;

	label = in_label / 32;
	flag = 1 << (in_label % 32);
	if (in_flag)
		g_player_param.m_LabelFlag[label] |= flag;
	else
		g_player_param.m_LabelFlag[label] &= ~flag;
}
// -------------------------------------
BOOL getLabel(s32 in_label)
{
	s32 label, flag;

	label = in_label / 32;
	flag = 1 << (in_label % 32);
	if (g_player_param.m_LabelFlag[label] & flag)
		return TRUE;
	return FALSE;
}


// -------------------------------------
// [U[f[^̊Ǘ
// -------------------------------------
BOOL saveUserData(int in_num)
{
	// Z[u
	if (in_num < g_save_count)
	{
		BOOL result;
		u8 p, hour, min, sec;
		u16 y, m, d;

		getToday(&y, &m, &d);
		getNowTime(&hour, &min, &sec);
		g_player_param.m_SaveYear = y;
		g_player_param.m_SaveMonth = (u8)m;
		g_player_param.m_SaveDay = (u8)d;
		g_player_param.m_SaveHour = hour;
		g_player_param.m_SaveMinute = min;
		g_player_param.m_init_code = USER_INIT_CODE;
		g_player_param.m_crc = SVC_GetCRC16(CRC_START, (const void *)(((u32)&g_player_param.m_crc)+2), sizeof(PLAYER_PARAM)-2);
		result = readBackup((void *)&p, 0, 1);
#ifdef BACKUP_NON_STOP
		result = TRUE;
#endif
		if (!result)
		{
			changeGameMode(GAME_MODE_WARNING_SAVE);
		} else {
			writeBackup((void *)&g_player_param, sizeof(COMMON_PARAM)+sizeof(PLAYER_PARAM)*in_num, sizeof(PLAYER_PARAM));
			OS_TPrintf("SavePlayerData\n");
			return TRUE;
		}
	}
	return FALSE;
}
// -------------------------------------
BOOL loadUserData(int in_num)
{
	// [h
	if (in_num < g_save_count)
	{
		PLAYER_PARAM player_param;
		BOOL result;
		u16 crc;

		result = readBackup((void *)&player_param, sizeof(COMMON_PARAM)+sizeof(PLAYER_PARAM)*in_num, sizeof(PLAYER_PARAM));
#ifdef BACKUP_NON_STOP
		result = TRUE;
#endif
		if (!result)
		{
			changeGameMode(GAME_MODE_WARNING_LOAD);
			return FALSE;
		} else {
			crc = SVC_GetCRC16(CRC_START, (const void *)(((u32)&player_param.m_crc)+2), sizeof(PLAYER_PARAM)-2);
			if (player_param.m_crc == crc && player_param.m_init_code == USER_INIT_CODE)
			{
				// ǂݍݐ
				memcpyBDS((s8 *)&g_player_param, (s8 *)&player_param, sizeof(PLAYER_PARAM));
				OS_TPrintf("LoadPlayerData\n");
				return TRUE;
			}
		}
	}
	return FALSE;
}
// -------------------------------------
void getSaveInfo(void **in_ptr)
{
	// Z[u̎擾
	PLAYER_PARAM player_param;
	SAVE_INFO *save_info;
	u8 i;
	BOOL result;
	u16 crc;

	*in_ptr = mallocBDS(sizeof(SAVE_INFO) * g_save_count);
	for (i=0; i<g_save_count; i++)
	{
		result = readBackup((void *)&player_param, sizeof(COMMON_PARAM)+sizeof(PLAYER_PARAM)*i, sizeof(PLAYER_PARAM));
#ifdef BACKUP_NON_STOP
		result = TRUE;
#endif
		if (!result)
		{
			changeGameMode(GAME_MODE_WARNING_LOAD);
			return;
		} else {
			save_info = (SAVE_INFO *)((u32)*in_ptr + sizeof(SAVE_INFO) * i);
			crc = SVC_GetCRC16(CRC_START, (const void *)(((u32)&player_param.m_crc)+2), sizeof(PLAYER_PARAM)-2);
			if (player_param.m_crc == crc && player_param.m_init_code == USER_INIT_CODE)
			{
				// ǂݍݐ
				save_info->m_nodata = 1;
				memcpyBDS((s8 *)&save_info->m_Name1[0], (s8 *)&player_param.m_Name1[0], 13);
				memcpyBDS((s8 *)&save_info->m_Name2[0], (s8 *)&player_param.m_Name2[0], 13);
				save_info->m_Age = player_param.m_Age;
				save_info->m_Year = (u8)(player_param.m_GameY + 1);
				save_info->m_Month = player_param.m_Month;
				save_info->m_SaveYear = player_param.m_SaveYear;
				save_info->m_SaveMonth = player_param.m_SaveMonth;
				save_info->m_SaveDay = player_param.m_SaveDay;
				save_info->m_SaveHour = player_param.m_SaveHour;
				save_info->m_SaveMinute = player_param.m_SaveMinute;
			} else {
				// ǂݍݎs
				save_info->m_nodata = 0;
			}
		}
	}
}
// -------------------------------------
BOOL isSavedUserData(void)
{
	// Z[uf[^邩ȁH
	SAVE_INFO *save_info;
	u8 i;
	BOOL result;

	result = FALSE;
	getSaveInfo((void **)&save_info);
	for (i=0; i<g_save_count; i++)
	{
		if (save_info[i].m_nodata == 1)
		{
			result = TRUE;
			break;
		}
	}
	freeBDS(save_info);
	return result;
}


// -------------------------------------
// t
// -------------------------------------
u8 getMaxday(int in_month)
{
	u8 maxday[12] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

	return maxday[in_month-1];
}


//---------------------------------------------------------------------------
//
// IWi
//
//---------------------------------------------------------------------------
// -------------------------------------
// hS̒J
// -------------------------------------
BOOL checkDragon(void)
{
	if ((getLabel(LF_ev022) == ON && getLabel(LF_ev023) == OFF && getGameM() <= y1446_3) ||
		(getLabel(LF_ev023) == ON && getLabel(LF_ev108) == OFF && getParam(pDY) >= 75) ||
		(getLabel(LF_ev320) == ON && getLabel(LF_ev321) == OFF))
	{
		return TRUE;
	}
	return FALSE;
}
// -------------------------------------
// ؂̉
// -------------------------------------
BOOL checkOrk(void)
{
	if (getLabel(LF_adv02_6) == ON)
		return TRUE;
	return FALSE;
}



